#include <iostream>
#include <vector>
#include <assert.h>
#define ll long long
#define pb push_back
using namespace std;
const int N = 2e5+5;

bool eval(string s) {
    ll res[2] = {0, 0};
    ll cur = 0;
    char c = '+';
    int cnt = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '+' || s[i] == '-' || s[i] == '=') {
            if (c == '+') {
                res[cnt] += cur;
            } else {
                res[cnt] -= cur;
            }
            if (s[i] == '=') c = '+', cnt++; else c = s[i];
            cur = 0;
            continue;
        }
        if (s[i] == '0' && cur == 0 && (i+1 < s.size() && s[i+1] <= '9' && s[i+1] >= '0')) {
            return false;
        }
        cur = cur*10 + (s[i] - '0');
        if (cur >= 1e10) return false;
    }
    if (c == '+') {
        res[cnt] += cur;
    } else {
        res[cnt] -= cur;
    }
    //cout << res[0] << " " << res[1] << endl;
    assert(cnt < 2);
    return res[0] == res[1];
}

void test_case() {
    string s;
    cin >> s;

    if(eval(s)) {
        cout << "Correct" << endl;
        return ;
    }

    for (int i = 0; i < s.size(); i++) {
        if (s[i] <= '9' && s[i] >= '0') {
            if ((i > 0 && (s[i-1] < '0' || s[i-1] > '9') || i == 0)
            && (i+1 < s.size() && (s[i+1] < '0' || s[i+1] > '9') || i+1 == s.size())) continue;
            string a = s;
            char c = s[i];
            a.erase(a.begin()+i);
            for (int j = 0; j <= a.size(); j++) {
                a.insert(a.begin()+j, c);
                if (eval(a)) {
                    cout << a << endl;
                    return;
                }
                a.erase(a.begin()+j);
            }
        }
    }
    cout << "Impossible" << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        test_case();
    }


}
