#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int mod = 1e9 + 7;

void add(int &a, int b) {
    a += b;
    if (a >= mod) a -= mod;
    if (a < 0) a += mod;
}

int mul(int a, int b) {
    return (a * (ll) b) % mod;
}

int g(char c) {
    return (c == '#');
}

void solve() {
    int n;
    cin >> n;
    vector <string> s(2);
    for (int i = 0; i < 2; i++) {
        cin >> s[i];
        s[i].push_back('#');
    }
    bool multiple = false;
    for (int i = 0; i < n; i++) {
        if (s[0][i] == '.' && s[1][i] == '.' && i + 1 < n && s[0][i + 1] == '.' && s[1][i + 1] == '.') {
            multiple = true;
            i++;
            continue;
        }
        if (s[0][i] == '.' && s[1][i] == '.') {
            continue;
        }
        if (s[0][i] == '.' && s[0][i + 1] == '#') {
            cout << "None\n";
            return;
        }
        if (s[1][i] == '.' && s[1][i + 1] == '#') {
            cout << "None\n";
            return;
        }
        if (s[0][i] == '.') {
            s[0][i + 1] = '#';
        }
        if (s[1][i] == '.'){
            s[1][i + 1] = '#';
        }
    }
    cout << (multiple ? "Multiple\n" : "Unique\n");
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
