#include "bits/stdc++.h"

using namespace std;

int solutions(int h, int w, int n, string line1, string line2) {
    if (h == 0) {
        for (int i = w; i < n; i++) {
            if (line1[i] == '#') continue;
            int result = 0;
            if (line2[i] == '.') {
                string temp_line1 = "" + line1;
                string temp_line2 = "" + line2;
                temp_line1[i] = '#';
                temp_line2[i] = '#';
                if (i+1 < n) {
                    result = solutions(0, i+1, n, temp_line1, temp_line2);
                } else {
                    result = solutions(1, 0, n, temp_line1, temp_line2);
                }
            }
            if (i + 1 < n && line1[i+1] == '.') {
                string temp_line1 = "" + line1;
                temp_line1[i] = '#';
                temp_line1[i+1] = '#';
                if (i+2 < n) {
                    result += solutions(0, i+2, n, temp_line1, line2);
                } else {
                    result += solutions(1, 0, n, temp_line1, line2);
                }
            }
            return result;
        }
        return solutions(1, 0, n, line1, line2);
    } else {
        for (int i = w; i < n; i++) {
            if (line2[i] == '#') continue;
            if (i+1 < n) {
                if (line2[i+1] != '.') {
                    return 0;
                }
                i++;
            } else {
                return 0;
            }
        }
        return 1;
    }
}

int main()
{
    int t;
    cin >> t;

    for(int test = 0; test < t; test++){
        int n;
        cin >> n;

        string line1, line2;
        cin >> line1;
        cin >> line2;

        int result = solutions(0, 0, n, line1, line2);
        if (result == 0) {
            cout << "None\n";
        } else if (result == 1) {
            cout << "Unique\n";
        } else {
            cout << "Multiple\n";
        }
    }
}
