#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXA = 2e9;

void solve_() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<array<int, 2>> tasks(n);
    for (int i = 0; i < n; ++i) {
        cin >> tasks[i][1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> tasks[i][0];
    }
    sort(tasks.begin(), tasks.end());
    vector<int> preft(n + 1);
    for (int i = 0; i < n; ++i) {
        preft[i + 1] = preft[i] + tasks[i][1];
    }
    for (int i = 0; i < n; ++i) {
        preft[i + 1] -= tasks[i][0];
    }
    vector<int> sufmax(n + 1);
    sufmax[n] = preft[n];
    for (int i = n - 1; i >= 0; --i) {
        sufmax[i] = max(sufmax[i + 1], preft[i]);
    }
    vector<int> pref(m + 1);
    for (int i = 0; i < m; ++i) {
        int l;
        cin >> l;
        pref[i + 1] = pref[i] + l;
    }
    while (q--) {
        int t;
        cin >> t;
        array<int, 2> elem = {t, MAXA};
        int i = upper_bound(tasks.begin(), tasks.end(), elem) - tasks.begin();
        int val = t - preft[i];
        if (i != 0) {
            val -= tasks[i - 1][0];
        }
        /// cerr << val << endl;
        if (i < n) {
            val = min(val, -sufmax[i + 1]);
        }
        cout << upper_bound(pref.begin(), pref.end(), val) - pref.begin() - 1 << " ";
    }
    cout << "\n";
}

#define MULTITEST

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    int tst = 1;
#ifdef MULTITEST
    cin >> tst;
#endif // MULTITEST
    while (tst--) {
        solve_();
    }
    return 0;
}