#include <bits/stdc++.h>

using namespace std;

template <typename T_container, typename T = typename enable_if
        <!is_same<T_container, string>::value, typename
        T_container::value_type>::type>
        ostream& operator<<(ostream &os, const T_container &v){
            os << '{';
            string sep;
            for (const T &x:v){
                os << sep << x;
                sep = ", ";
            }
            return os << '}';
        }

        void dbg_out(){cerr<<endl;}
        template <typename Head, typename... Tail> void dbg_out(Head H
                ,Tail... T){cerr<<' '<<H; dbg_out(T...);}

#define dbg(...) dbg_out(__VA_ARGS__)


//#define TEST_CASES
#define vt vector

void solve(){
    int n;
    cin >> n;
    vt<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vt<int> used(n + 1, false);
    vt<pair<int, int>> res;
    for(int i = 0; i < n; ++i) {
        int value = a.back();
        a.pop_back();
        for(int i = value - 1; i >= 1; --i) if(!used[i]) {
            res.emplace_back(value, i);
        }
        for(int i = 1; i < value; ++i) if(!used[i]) {
            res.emplace_back(i, value);
        }
        for(int i = value + 1; i <= n; ++i) if(!used[i]) {
            res.emplace_back(i, value);
        }
        used[value] = 1;
    }
    cout << int(res.size()) << '\n';
    for(auto [x,y]: res) {
        cout << x << ' ' << y << '\n';
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
#ifdef TEST_CASES
    cin >>tt;
#endif
    while(tt--)
        solve();
return 0;
}
