#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long
#define ll long long
#define sz(x) x.begin(), x.end()

using namespace std;


int dx[] = {0, 1, 1, 1, 0, -1, -1, -1};
int dy[] = {1, 1, 0, -1, -1, -1, 0, 1};
struct point{
    vector<int> x, y;
    point(){
        x.resize(2);
        y.resize(2);
    }
};

struct line
{
    point A, B;
};
line gx(point A, point B){
    if(A.x != B.x){
        if(A.x > B.x)
            swap(A, B);

    }
    else if(A.y > B.y)
        swap(A, B);
    return {A, B};
}
vector < line > getPic(vector < pair< string , int > > ops, int ang){
    ang = (ang + 8)%8;
    point A;
    vector < line > res;
    for(auto [t, d]: ops){
        if(t[0] == 'r'){
            d /= 45;
            ang = (ang - d + 8) % 8;
        }
        else if(t[0] == 'd'){
            auto B = A;
            B.x[ang&1] += d * dx[ang];
            B.y[ang&1] += d * dy[ang];
            res.push_back(gx(A,B));
        }
        else{
            A.x[ang&1] += d * dx[ang];
            A.y[ang&1] += d * dy[ang];
        }
    }
    return res;
}
vector < line > rt(vector < line > in, point P){
    for(int i = 0; i < in.size(); i++){
        in[i].A.x[0] -= P.x[0];
        in[i].A.x[1] -= P.x[1];
        in[i].A.y[0] -= P.y[0];
        in[i].A.y[1] -= P.y[1];

        in[i].B.x[0] -= P.x[0];
        in[i].B.x[1] -= P.x[1];
        in[i].B.y[0] -= P.y[0];
        in[i].B.y[1] -= P.y[1];
    }
    return in;
}
void print(point A){
    cout << A.x[0] << ' ' << A.x[1] << ' '<< A.y[0] << ' ' << A.y[1] << '\n';
}
void print(line A){
    cout << "P = \n";
    print(A.A);print(A.B);
}
bool eq(vector<line> A, vector <line> B){
    int n = A.size();
    for(int i = 0; i < n; i++){
      //  print(A[i]);
       // print(B[i]);
        if(A[i].A.x != B[i].A.x)
            return false;
        if(A[i].A.y != B[i].A.y)
            return false;

        if(A[i].B.x != B[i].B.x)
            return false;
        if(A[i].B.y != B[i].B.y)
            return false;
    }
    return true;
}
void solve() {
    int n;
    cin >> n;
    vector < pair < string , int > > ops(n);
    for(int i = 0; i < n; i++){
        cin >> ops[i].first >> ops[i].second;
    }    
    vector < line > in = getPic(ops, 0);
    sort(in.begin(), in.end(), [](line p, line q){
        if(p.A.x == q.A.x)
            return p.B.y < q.B.y;
        return p.A.x < q.A.x; 
    }
    );
    in = rt(in, in[0].A);

    for(int ang = -1, ans = 45; ang >= -8; ang--, ans += 45){
        auto vc = getPic(ops, ang);
        sort(vc.begin(), vc.end(), [](line p, line q){
            if(p.A.x == q.A.x)
                return p.B.y < q.B.y;
            return p.A.x < q.A.x; 
        }
        ); 
        for(int i = 0; i < vc.size(); i++){
            if(eq(rt(vc, vc[i].A) , in)){
                cout << ans;
                return;
            }
            if(eq(rt(vc, vc[i].B), in)){
                cout << ans;
                return;
            }
        }
    }
}

 main() {    
    ios_base::sync_with_stdio(0); cin.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
}