#include <bits/stdc++.h>

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using namespace std;

typedef long long ll;

bool bit(int x, int p)
{
    return x & (1 << p);
}

vector<int> A;

void set_val(int pos, int x)
{
    assert(pos >= 0 && pos < sz(A));
    assert(A[pos] == -1);
    assert(0 <= x && x < (1 << 16));
    A[pos] = x;
}

int IO_get(int i)
{
    return (1 << 16) - i - 1;
}

int word_get(int word_index, int bit_index)
{
    assert(word_index >= 0 && word_index < sz(A));
    assert(bit_index >= 0 && bit_index < 16);
    return word_index * 16 + 15 - bit_index;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int x;
    cin >> x;

    A.assign((1 << 12) - 1, -1);
    int head = (1 << 16) - 1;
    int pos = (1 << 12) - 2;

    set_val(pos, 1);
    int one_index = word_get(pos, 0);
    int zero_index = word_get(pos, 1);
    pos--;

    for (int i = 0; i < 16; i++)
    {
        pos -= 16;
        int p1 = pos, p2 = pos + 3, p3 = pos + 6, p4;

        while ((p3 % 4) != 0)
        {
            p3++;
        }

        p4 = p3 + 3;

        set_val(p1, IO_get(i));
        set_val(p1 + 1, word_get(p2 + 2, 0));
        set_val(p1 + 2, p2);

        set_val(p2, IO_get(i));
        set_val(p2 + 1, word_get(p2 + 2, 1));
        set_val(p2 + 2, p3);

        // if 0 jumps to p3
        // if 1 jumps to p4

        set_val(p3, zero_index);
        set_val(p3 + 1, IO_get(0));
        set_val(p3 + 2, (1 << 16) - 1);

        set_val(p4, 0);
        set_val(p4 + 1, 0);
        set_val(p4 + 2, head);
        head = p1;
    }

    for (int i = 0; i < 16; i++)
    {
        if (!bit(x, i))
        {
            pos -= 16;
            int p1 = pos, p2 = pos + 3, p3 = pos + 6, p4;

            while ((p3 % 4) != 0)
            {
                p3++;
            }

            p4 = p3 + 3;

            set_val(p2 + 2, p3);

            set_val(p1, IO_get(i));
            set_val(p1 + 1, word_get(p2 + 2, 0));
            set_val(p1 + 2, p2);

            set_val(p2, IO_get(i));
            set_val(p2 + 1, word_get(p2 + 2, 1));

            // if 0 jumps to p3
            // if 1 jumps to p4

            set_val(p3, one_index);
            set_val(p3 + 1, IO_get(i));
            set_val(p3 + 2, head);

            set_val(p4, zero_index);
            set_val(p4 + 1, IO_get(i));
            set_val(p4 + 2, head);

            head = p1;
        }
    }

    for (int i = head; i < sz(A); i++)
    {
        if (A[i] == -1)
        {
            A[i] = 0;
        }
        for (int j = 12; j >= 0; j -= 4)
        {
            int x = ((A[i] >> j) & 15);
            cout << (char)(x < 10 ? x + '0' : 'a' + (x - 10));
        }
        cout << " \n"[i == sz(A) - 1];
    }

    return 0;
}