#include <bits/stdc++.h>

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using namespace std;

typedef long long ll;

string s;

bool check(string &s)
{
    if (s[0] == '-' || s[0] == '+' || s[0] == '=')
        return false;
    if (s[sz(s) - 1] == '-' || s[sz(s) - 1] == '+' || s[sz(s) - 1] == '=')
        return false;

    for (int i = 0; i < sz(s) - 1; ++i)
    {
        if ((s[i] == '+' || s[i] == '-' || s[i] == '=') && (s[i + 1] == '+' || s[i + 1] == '-' || s[i + 1] == '='))
            return false;
    }

    ll A = 0, B = 0;
    ll cur = 0, sgn = 1;
    int len = 0, last = -1;

    int posOfEq = -1;
    for (int i = 0; i < sz(s); ++i)
    {
        if (s[i] == '=')
        {
            posOfEq = i;
            break;
        }
    }

    for (int i = 0; i < posOfEq; ++i)
    {
        if (s[i] == '+')
        {
            A += cur * sgn;
            cur = 0;
            last = -1;
            sgn = 1;
            len = 0;
        }
        else if (s[i] == '-')
        {
            A += cur * sgn;
            cur = 0;
            last = -1;
            sgn = -1;
            len = 0;
        }
        else
        {
            ++len;
            cur = cur * 10ll + (s[i] - '0');

            if (len == 2 && last == 0)
            {
                // cout << "here1\n";
                return false;
            }
            last = (s[i] - '0');
        }
        if (len > 10)
        {
            // cout << "here2\n";
            return false;
        }
    }

    A += cur * sgn;

    cur = 0;
    sgn = 1;
    len = 0;
    last = -1;
    for (int i = posOfEq + 1; i < sz(s); ++i)
    {
        if (s[i] == '+')
        {
            B += cur * sgn;
            cur = 0;
            last = -1;
            sgn = 1;
            len = 0;
        }
        else if (s[i] == '-')
        {
            B += cur * sgn;
            cur = 0;
            last = -1;
            sgn = -1;
            len = 0;
        }
        else
        {
            ++len;
            cur = cur * 10ll + (s[i] - '0');

            if (len == 2 && last == 0)
            {
                // cout << "here3\n";
                return false;
            }
            last = (s[i] - '0');
        }
        if (len > 10)
        {
            // cout << "here4\n";
            return false;
        }
    }

    B += cur * sgn;

    // cout << s << " -> " << A << " " << B << "\n";
    return (A == B);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> s;

    int cntEq = 0;
    for (int i = 0; i < sz(s); ++i)
    {
        if (s[i] == '=')
            ++cntEq;
    }

    if (cntEq != 1)
    {
        cout << "Impossible";
        return 0;
    }

    if (check(s))
    {
        cout << "Correct";
        return 0;
    }

    for (int i = 0; i < sz(s); ++i)
    {
        string s2 = s;
        if ('0' <= s[i] && s[i] <= '9')
        {
            for (int j = i; j < sz(s) - 1; ++j)
            {
                swap(s2[j], s2[j + 1]);
                if (check(s2))
                {
                    cout << s2;
                    return 0;
                }
            }
        }
    }

    cout << "Impossible";
    return 0;
}