#include <bits/stdc++.h>
using namespace std;


string add(string &s, string &t) {

    string cur;
    int n = s.size();
    int m = t.size();
    int carry = 0;
    for (int i = n - 1, j = m - 1; j >= 0 && i >= 0; j--, i--) {
        int current = s[i] + t[j] - 2 * '0';

        cur += (carry + current) % 10 + '0';
        carry = (carry + current) / 10;

    }
    if (n < m) {
       for (int i = m - n - 1; i >= 0; i--) {
           int current = t[i] - '0';
           cur += (carry + current) % 10 + '0';
           carry = (carry + current) / 10;
       }
    } else if (n > m) {

        for (int i = n - m - 1; i >= 0; i--) {
            int current = s[i] - '0';

            cur += (carry + current) % 10 + '0';
            carry = (carry + current) / 10;
        }
    }


    if (carry)
        cur += '1';

    reverse(cur.begin(), cur.end());
    return cur;
}
string sub(string &s, string &t) {
    if (s.size() < t.size() || (s.size() == t.size() && s < t)) {
        return "-" + sub(t, s);
    }



    int n = s.size();
    int m = t.size();
    int carry = 0;
    string cur;
    for (int i = n - 1, j = m - 1; i >= 0 && j >= 0; i--, j--) {
        char u = s[i];
        char d = t[j] + carry;
        if (u < d) {
            carry = 1;
            cur += 10 + u - d + '0';
        } else {
            cur += u - d + '0';
        }
    }
    for (int i = n - m - 1; i >= 0; i--) {
        char u = s[i] - '0';
        char d = carry;
        if (u < d) {
            carry = 1;
            cur += 10 + u - d + '0';
        } else {
            cur += u - d + '0';
        }
    }

    reverse(cur.begin(), cur.end());
    string ncur ;
    int has = 0;
    for (int i = 0; i < cur.size(); i++) {
        if (has || cur[i] != '0') {
            has = 1;
            ncur += cur[i];
        }
    }

    return ncur;
}

string op(string &s, string &t, char op) {
    if (op == '-') {
        if (s[0] == '-' && t[0] == '-') {
            s.erase(s.begin());
            t.erase(t.begin());
            return sub(t, s);
        } else if (s[0] == '-') {
            s.erase(s.begin());
            return "-" + add(s, t);
        } else if (t[0] == '-') {
            t.erase(t.begin());
            return add(s, t);
        }

        return sub(s, t);
    }
    if (s[0] == '-' && t[0] == '-') {
        s.erase(s.begin());
        t.erase(t.begin());
        return "-" + add(t, s);
    } else if (s[0] == '-') {
        s.erase(s.begin());
        return sub(t, s);
    } else if (t[0] == '-') {
        t.erase(t.begin());
        return sub(s, t);
    }
    return add(s, t);
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
//
//    string S = "111111121";
//    string T = "1";
//    cout << op(S, T, '-') << "\n";
//    return 0;
    string s;
    cin >> s;

    string backup = s;
    auto check = [&](string t) {
        vector<string> l_num, r_num;
        vector<char> l_op{'+'}, r_op{'+'};

        string cur;
        int i = 0;
        for (i = 0; t[i] != '='; i++) {
            if (t[i] == '-' || t[i] == '+') {
                l_num.push_back(cur);
                if (cur.empty() || (cur[0] == '0' && cur.size() > 1)) {
                    return false;
                }
                cur = "";
                l_op.push_back(t[i]);
            } else {
                cur += t[i];
            }
        }
        if (cur.empty() || (cur[0] == '0' && cur.size() > 1)) {
            return false;
        }

        l_num.push_back(cur);
        cur = "";
        i++;

        for (; i < t.size(); i++) {
            if (t[i] == '-' || t[i] == '+') {
                r_num.push_back(cur);
                if (cur.empty() || (cur[0] == '0' && cur.size() > 1)) {
                    return false;
                }
                cur = "";
                r_op.push_back(t[i]);
            } else {
                cur += t[i];
            }
        }
        if (cur.empty() || (cur[0] == '0' && cur.size() > 1)) {
            return false;
        }

        r_num.push_back(cur);
        string r = "0", l = "0";
        for (i = 0; i < l_op.size(); i++) {
            if (l_num[i].size() > 10) {
                return false;
            }
            l = op(l, l_num[i], l_op[i]);
        }



        for (i = 0; i < r_op.size(); i++) {
            if (r_num[i].size() > 10) {
                return false;
            }
           r = op(r, r_num[i], r_op[i]);
        }


        return r == l;
    };

    if (check(s)) {
        cout << "Correct\n";
        return 0;
    }


    int n = s.size();
    for (int i = 0; i < n; i++) {
        s = backup;
        if (s[i] == '-' || s[i] == '+' || s[i] == '=') {
            continue;
        }
        char cur = s[i];


        s.erase(s.begin() + i);
        for (int j = 0; j < n; j++) {
            s.insert(s.begin() + j, cur);
//            cout << s << "\n";
            if (check(s)) {
                cout << s;
                return 0;
            }
            s.erase(s.begin() + j);
        }
    }


    cout << "Impossible\n";

    return 0;
}
