#include <bits/stdc++.h>
#define ll long long
using namespace std;

const int N = 5e5 + 5;

ll a[N], d[N], l[N];
ll p[N];
ll pref_work[N];

vector<pair<ll, ll>> work;
int n, m, q;

int get(ll t) {
    int L = 0;
    int R = n - 1;
    int ans = -1;
    while (L <= R) {
        int mid = L + R >> 1;
        if (work[mid].second <= t) {
            ans = mid;
            L = mid + 1;
        } else {
            R = mid - 1;
        }
    }
    return ans;
}

int get_ans(ll t) {
    int L = 1;
    int R = m;
    int ans = 0;
    while (L <= R) {
        int mid = L + R >> 1;
        if (p[mid] <= t) {
            ans = mid;
            L = mid + 1;
        } else {
            R = mid - 1;
        }
    }
    return ans;
}

ll get_new_t(int j, ll t) {
    t = min(work[j].first, t);
    return t;
}

void solve() {
    work.clear();
    cin >> n >> m >> q;
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int j = 1; j <= n; j++) cin >> d[j];

    vector<pair<ll, ll>>  ls;
    for (int i = 1; i <= n; i++) {
        ls.push_back({d[i], a[i]});
    }
    sort(ls.begin(), ls.end());
    ll prev = -1;
    for (int i = n - 1; i >= 0; i--) {
        ll dead = ls[i].first;
        ll duration = ls[i].second;
        ll r = dead;
        if (prev != -1) {
            r = min(dead, prev);
        }
        ll L = r - duration;
        prev = L;
        work.push_back({L, r});

    }
    sort(work.begin(), work.end());
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            pref_work[i] = work[i].second - work[i].first;
            continue;
        }
        pref_work[i] = work[i].second - work[i].first + pref_work[i - 1];
    }

    for (int i = 1; i <= m; i++) cin >> l[i];

    for (int i = 1; i <= m; i++) p[i] = p[i - 1] + l[i];

    for (int i = 1; i <= q; i++) {
        ll t;
        cin >> t;
        int j = get(t);
        if (j == n - 1) {
            t -= pref_work[j];
            cout << get_ans(t) << " ";
        } else if (j == -1) {
            t = get_new_t(j + 1, t);
            cout << get_ans(t) << " ";
        } else {
            t = get_new_t(j + 1, t);
            t -= pref_work[j];
            cout << get_ans(t) << " ";
        }
    }
    cout << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
