#include <bits/stdc++.h>
using namespace std;

#define nl '\n'
#define ll long long
#define int long long

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> task_dur(n), task_ded(n), ser_dur(m),task_sum(n),ser_sum(m);

    for (int i=0; i<n; i++){
        cin >> task_dur[i];
    }

    for (int i=0; i<n; i++)
        cin >> task_ded[i];

    vector<pair<int, int>> temp1 (n);
    for (int i=0; i<n; i++)
        temp1[i] = {task_ded[i], i};
    sort(temp1.begin(), temp1.end());

    int ii=0; int ts = 0;
    for(auto i:temp1){
        task_sum[ii]=ts + task_dur[i.second];
        ts = task_sum[ii];
        ii++;
    }

    ts = 0;
    for (int i=0; i<m; i++){
        cin >> ser_dur[i];
        ser_sum[i]=ts+ser_dur[i];
        ts = ser_sum[i];
    }

    for (int _=0; _<q; _++) {
        int num; cin >> num;
        int l=0, r=m;

        while(l<r){
            int mid = (l+r)/2;
            bool flag=false;

            int ind = upper_bound(task_sum.begin(), task_sum.end(), num)-task_sum.begin();
            cout<<"ind "<<ind<<nl;
            if(ind==n){
                cout<<m<<nl;

                break;
            }
            if(temp1[ind].first-task_dur[temp1[ind].second]-ser_sum[mid]-num>0) {
                flag=true;
            }

            if(flag) l=mid+1;
            else r=mid;
        }
        cout<<l<<nl;

    }
}

int32_t main() {
     freopen("input.txt", "r", stdin);

    int t = 1;
     cin >> t;
    while (t--) {
        solve();
        cout << nl;
    }

    return 0;
}
