#include <bits/stdc++.h>

#define ll long long
#define int ll
#define fi first
#define se second
#define ss size()
#define pb push_back
#define pii pair < int, int >
#define vi vector < int >
#define vpii vector < pii > 
#define FOR(i, l, r) for (int i = l; i <= r; i++)

using namespace std;

const ll INF = 1e16 + 9;
const int N = 4e5 + 40, inf = 1e9 + 7, T = 4 * N;
int n, m, l, r, e, w, f, id, timer, mn = inf, mx = -inf;
vpii ans;
vi gr[N];
ll mate[N], a[N];
pii p[N];
bool was[N], us[N];
ll lev[N];

bool kuhn(ll x){
    if (was[x]) return false;
    was[x] = true;
    for(ll i : gr[x]){
        if (mate[i] == 0 || kuhn(mate[i])){
            mate[i] = x;
            return 1;
        }
    }
    return 0;
}

void findlev(ll x, ll p=-1){
    for(ll i : gr[x]){
        if (i != p){
            lev[i] = lev[x] ^ 1;
            findlev(i, x);
        }
    }
}

void matcasd(){
    findlev(1);
    fill(mate, mate + 2*n+10, 0);
    while(1){
        fill(was, was + 2*n+10, 0);
        bool f = false;
        FOR(i, 1, 2*n){
            if (!lev[i] && kuhn(i)){ f = true;
                break;
            }
        }
        if (!f) break;
    }
    FOR(i, 1, 2*n){
        if (!lev[i]){
            mate[i] = 0;
        }
    }
    FOR(i, 1, 2*n){
        if (lev[i] && mate[i]){
            mate[mate[i]] = i;
        }
    }
    FOR(i, 1, 2*n){
        if (lev[i]){
            mate[i] = 0;
        }
    }
    FOR(i, 1, 2*n){
        if (!lev[i] && mate[i]){
            mate[mate[i]] = i;
        }
    }
}

int find_other(int x)
{
    auto cur = p[a[x]];
    if (cur.fi == x) return cur.se;
    return cur.fi;
}

void add(int x, int y)
{
    ans.pb({x, y});
    if (p[a[x]].fi == x) 
    {
        p[a[x]].fi = y;
    }
    else{
        p[a[x]].se = y;
    }

    if (p[a[y]].fi == y)
    {
        p[a[y]].fi = x;
    }
    else{
        p[a[y]].se = x;
    }
    swap(a[x], a[y]);
}

void dfs(int v)
{
    // cout << v << " " << mate[v] << " " << find_other(v) << endl;
    if (!mate[v]) return;
    int to = mate[v];
    int to2 = find_other(v);
    if (to == to2) return;
    add(to, to2);
    us[v] = us[to] = 1;
    dfs(to2);
}

void solve()
{
    cin >> n;
    FOR (i, 1, n) p[i] = {0, 0};
    FOR(i, 1, 2*n) 
    {
        cin >> a[i];
        if (!p[a[i]].fi) p[a[i]].fi = i;
        else p[a[i]].se = i;
        gr[i].clear();
    }
    FOR(i, 1, 2*n-1){
        ll a, b;
        cin >> a >> b;
        gr[a].pb(b);
        gr[b].pb(a);
    }
    matcasd();
    ans.clear();

    fill(us, us + n + n + 10, 0);
    FOR (i, 1, n + n)
    {
        if (us[i]) continue;
        dfs(i);
    }

    cout << ans.ss << endl;
    for (auto i : ans) cout << i.fi << " " << i.se << endl;
}

signed main()
{
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #endif

    int _ = 1;
    cin >> _;
    while (_--)
    {
        solve();
        cout << endl;
    }
}