#include<bits/stdc++.h>

#define DEBUGSTR_WNAME(os, name, a) \
    do { (os) << (name) << " = " << (a) << std::endl; } while(false)

#define DEBUGSTR(os, a) DEBUGSTR_WNAME((os), #a, (a))
#define DEBUG(a) DEBUGSTR_WNAME(std::cout, #a, (a))

#define ll long long
#define ld long double

#define pii pair<int, int>
#define vi vector<int>
#define vl vector<ll>

#define all(x) x.begin(), x.end()
#define sz(x)  (int)x.size()
#define pb push_back
#define fi first
#define se second

using namespace std;

const int N = (int)2e5 + 2000;
const int M = (int)1e7 + 200;
const ll mod = (ll)1e9+7;
const ll inf = (ll)1e18 + 7;
const char nl = '\n';

int n, a[N], p[N], cur[N];

void solve() {
    cin>> n;
    vector<pii> ans;
    for(int i = 1; i <= n; i++){
        cin>> a[i];
        p[a[i]] = i;
        cur[i] = i;
    }

    for(int i = 2; i <= n; i++){
        for(int j = i - 1; j >= 1; j--){
            ans.pb({i, cur[j]});
            swap(cur[j + 1], cur[j]);
        }
        int j = 2;
        while(j <= i && p[cur[j]] < p[i]){
            ans.pb({cur[j], i});
            swap(cur[j], cur[j-1]);
            j++;
        }
    }

    cout<< sz(ans)<< endl;
    for(auto i : ans){
        cout<< i.fi<< ' '<< i.se<< endl;
    }
}

int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int test = 1;
    // cin >> test;
    while(test--) {
        solve();
    }
}
