// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <map>
#include <math.h>
#define int long long

using namespace std;

map<int, int> indexes;
map<pair<int, int>, int> swaps;
vector<pair<int, int>> swap_vec;
vector<pair<int, int>> new_swap;
map<int, int> indexes_rev;

void print_vec(vector<int>& vec) {
	for (int i = 0; i < vec.size(); i++)
		cout << vec[i] << " ";
	cout << endl;
}


void bubble_sort(vector<int>& vec) {
	for (int i = 0; i < vec.size(); i++) {

		int minJ = i;
		int minEl = vec[i];
		for (int j = i; j < vec.size(); j++) {
			if (vec[j] < minEl) {
				minJ = j;
				minEl = vec[j];
			}
		}

		int k = minJ;
		while (k != i) {
			swap(vec[k], vec[k - 1]);
			swaps[{ vec[k - 1], vec[k] }]++;
			swap_vec.push_back({ k - 1, k });
			//print_vec(vec);
			k--;
		}
	}
}

pair<int, int> get_pair(int a, int b) {
	if (a > b)
		swap(a, b);

	return make_pair(a, b);
}

void rec(pair<int, int> a, vector<int>& vec, int n) {
	if (a.first - 1 >= 0) {
		pair<int, int> b = get_pair(vec[a.first - 1], vec[a.first]);

		if (swaps[b] == 0) {
			new_swap.push_back({ b.second, b.first });
			swap(vec[a.first - 1], vec[a.first]);
			swaps[b]++;

			rec({ a.first - 1, a.first }, vec, n);

			new_swap.push_back({ b.first, b.second });
			swap(vec[a.first - 1], vec[a.first]);
			swaps[b]++;
		}
	}

	if (a.second + 1 != n) {
		pair<int, int> b = get_pair(vec[a.second], vec[a.second + 1]);

		if (swaps[b] == 0) {
			new_swap.push_back({ b.second, b.first });
			swap(vec[a.second], vec[a.second + 1]);
			swaps[b]++;

			rec({ b.second, b.second + 1 }, vec, n);

			new_swap.push_back({ b.first, b.second });
			swap(vec[a.second], vec[a.second + 1]);
			swaps[b]++;
		}
	}
}

void post_process(int n) {
	vector<int> vec(n);

	for (int i = 1; i <= n; i++) {
		vec[i - 1] = indexes[i];
	}

	for (int i = 0; i < swap_vec.size(); i++) {
		pair<int, int> p = swap_vec[i];

		swap(vec[p.first], vec[p.second]);
		new_swap.push_back({vec[p.first], vec[p.second]});

		pair<int, int> a = get_pair(p.first, p.second);
		rec(a, vec, n);
	}
}

//void bubble_sort(vector<int>& vec) {
//	int n = vec.size();
//
//	for (int i = 0; i < n; i++) {
//		for (int j = i; j < n; j++) {
//			if (vec[i] > vec[j]) {
//				swap(vec[i], vec[j]);
//				swaps[make_pair(vec[i], vec[j])]++;
//				swap_vec.push_back(make_pair(vec[i], vec[j]));
//				swap_cnt++;
//			}
//
//		}
//	}
//}

int get_swaps(int a, int b) {
	return swaps[get_pair(a, b)];
}

#undef int
int main()
#define int long long
{
	int n;
	cin >> n;

	vector<int> vec(n);

	for (int i = 0; i < n; i++) {
		int tmp;
		cin >> tmp;
		indexes[tmp] = i;
		indexes_rev[i] = tmp;
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
			if (i == j)
				continue;

			swaps[get_pair(i, j)] = 0;
		}
			

	for (int i = 1; i <= n; i++) {
		vec[i - 1] = indexes[i];
	}

	bubble_sort(vec);

	for (int i = 0; i < n - 1; i++) {
		int j = i, k = i + 1;

		int cnt = 0;

		while (true) {
			if (get_swaps(vec[j], vec[k]) != 0)
				break;

			swap_vec.push_back({ j, k });
			swap(vec[k], vec[j]);
			swaps[get_pair(vec[j], vec[k])]++;
			//print_vec(vec);

			cnt++;
			j++;
			k++;

			if (k == n)
				break;
		}

		while(cnt--) {
			j--;
			k--;

			swap_vec.push_back({ j, k });
			swap(vec[k], vec[j]);
			swaps[get_pair(vec[j], vec[k])]++;
			//print_vec(vec);
		}
	}


	post_process(n);

	cout << new_swap.size() << endl;

	for(int i = 0; i < vec.size(); i++)
		if(i != vec[i])
			throw "Rishat loh\n";
	
	for (auto k : swaps) {
		if (k.second > 2)
			throw "Ramis loh\n";

		//cout << indexes_rev[k.first.first] << ", " << indexes_rev[k.first.second] << ": " << k.second << endl;
	}


	for (int i = 0; i < new_swap.size(); i++)
	{
		cout << indexes_rev[new_swap[i].first] << " " << indexes_rev[new_swap[i].second] << endl;
	}
}
