#include <bits/stdc++.h>
using namespace std;

const int Nmax { ( int )2e5 };

int t;
int n;
int parquet[ Nmax + 2 ];

int dp[ Nmax + 2 ][ 4 ];

void generate( int i, int j, int m0, int m1, vector<int> &masks )
{
    if( j == 3 )
    {
        masks.push_back( m1 );
        return;
    }

    if( !( m0 & j ) && !( parquet[ i + 1 ] & j ) )
        generate( i, j + 1, m0, m1 + j, masks );
    if( j == 1 && !( m0 & 1 ) && !( m0 & 2 ) )
        generate( i, j + 2, m0, m1, masks );
    if( m0 & j )
        generate( i, j + 1, m0, m1, masks );
}

int solve( int i, int mask )
{
    if( i > n )
        return ( mask == 0 ) ? 1 : 0;
    mask |= parquet[ i ];
    if( dp[ i ][ mask ] != -1 )
        return dp[ i ][ mask ];
    vector<int> masks;
    generate( i, 1, mask, 0, masks );
    int ans { 0 };
    for( auto next : masks )
        ans += solve( i + 1, next );
    dp[ i ][ mask ] = ans;
    return ans;
}

int main( int argc, char *argv[] )
{
    #ifdef LOCAL
    freopen( "F.txt", "r", stdin );
    #endif
    
    parquet[ 0 ] = 3;
    cin.sync_with_stdio( false );
    cin >> t;
    while( t-- )
    {
        cin >> n;

        for( int i { 1 }; i <= n; ++i )
            for( int j { 0 }; j <= 3; ++j )
                dp[ i ][ j ] = -1;

        parquet[ n + 1 ] = 3;
        for( int i { 1 }; i <= n; ++i )
        {
            parquet[ i ] = 0;
            char x;
            cin >> x;
            parquet[ i ] += ( x == '#' );
        }
        for( int i { 1 }; i <= n; ++i )
        {
            char x;
            cin >> x;
            parquet[ i ] += ( x == '#' ) << 1;
        }

        int ans = solve( 1, 0 );
        switch( ans )
        {
            case 0:
                cout << "None\n";
                break;
            case 1:
                cout << "Unique\n";
                break;
            default:
                cout << "Multiple\n";
        }
    }

    return 0;
}