#include <bits/stdc++.h>
using namespace std;

const int Nmax { ( int )2e5 };

int t;
int n;
int parquet[ Nmax + 1 ];

void mask_gen( int i, int j, int curr, int next, vector<int> &masks )
{
    if( j == 2 )
    {
        masks.push_back( next );
        return;
    }

    if( !( curr & ( 1 << j ) ) && !( parquet[ i + 1 ] & ( 1 << j ) ) && ( !( parquet[ i + 1 ] & ( 1 << ( j + 1 ) ) ) || ( curr & ( 1 << ( j + 1 ) ) ) ) )
        mask_gen( i, j + 1, curr, next + ( 1 << j ), masks );
    if( j == 0 && !( curr & ( 1 << j ) ) && !( curr & ( 1 << ( j + 1 ) ) )  )
        mask_gen( i, j + 2, curr, next, masks );
    if( curr & ( j + 1 ) )
        mask_gen( i, j + 1, curr, next, masks );
}

int solve( int i = 0, int mask = 0 )
{
    if( i == n )
        return ( int )( mask == 0 );
    mask |= parquet[ i ];
    vector<int> masks;
    mask_gen( i, 0, mask, 0, masks );
    int ans { 0 };
    for( auto next : masks )
        ans += solve( i + 1, next );
    return ans;
}

int main( int argc, char *argv[] )
{
    #ifdef LOCAL
    freopen( "F.txt", "r", stdin );
    #endif

    cin.sync_with_stdio( false );
    cin >> t;
    while( t-- )
    {
        cin >> n;
        for( int i { 0 }; i < n; ++i )
        {
            char x;
            cin >> x;
            parquet[ i ] = ( x == '#' );
        }
        for( int i { 0 }; i < n; ++i )
        {
            char x;
            cin >> x;
            parquet[ i ] += ( x == '#' ) << 1;
        }

        switch( solve( ) )
        {
            case 0:
                cout << "None\n";
                break;
            case 1:
                cout << "Unique\n";
                break;
            default:
                cout << "Multiple\n";
        }
    }
    return 0;
}