from collections import defaultdict
from sys import stdout, stdin
from copy import deepcopy
from collections import defaultdict

def main():
    n = read_num()
    bobiks = read_nums()
    bobiks_sets = defaultdict(set)
    results, bobiks_sets = bubble_bobiks(bobiks, bobiks_sets)
    results.reverse()

    for i in range(len(bobiks)-1):
        a = bobiks[i]
        b = bobiks[i + 1]
        if b not in bobiks_sets[a] and a not in bobiks_sets[b]:
            results.append([b,a])
            results.append([a,b])

    print(len(results))
    for x, y in results:
        print(f'{x} {y}')




def bubble_bobiks(bobiks_og, bobiks_sets):
    bobiks = deepcopy(bobiks_og)
    results = []
    for _ in range(len(bobiks)):
        for x in range(len(bobiks)-1):
            for i in range(x, len(bobiks) - 1):
                a = bobiks[i]
                b = bobiks[i+1]
                if a > b:
                    results.append([a,b])
                    bobiks_sets[a].add(b)
                    bobiks_sets[b].add(a)
                    bobiks[i], bobiks[i+1] = bobiks[i+1], bobiks[i]
                else:
                    break

    return results, bobiks_sets



def read_nums():
    return list(map(int, stdin.readline().split()))


def read_num():
    return int(stdin.readline().rstrip())


if __name__ == '__main__':
    main()
