#include <bits/stdc++.h>
using namespace std;

//void solve() {
//    int n; cin >> n;
//    vector<char> v1, v2;
//    v1.push_back('#');
//    v2.push_back('#');
//
//    bool isExist = true;
//    bool isMultiple = false;
//
//    for(int i = 0;i < n;i++) {
//        char ch; cin >> ch;
//        v1.push_back(ch);
//    }
//    for(int i = 0;i < n;i++) {
//        char ch; cin >> ch;
//        v2.push_back(ch);
//    }
//
//    for(int i = 1;i <= n;i++) {
//        if(v1[i] == '.' && v1[i - 1] == '.' && v2[i] == '.' && v2[i - 1] == '.') {
//            isMultiple = true;
//            break;
//        }
//    }
//
//
//    for(int i = 1;i <= n;i++) {
//        if(v1[i] == '.') {
//            if(v1[i - 1] == '.') {
//                v1[i - 1] = '#';
//                v1[i] = '#';
//                continue;
//            }
//        }
//
//        if(v2[i] == '.') {
//            if(v2[i - 1] == '.') {
//                v2[i - 1] = '#';
//                v2[i] = '#';
//                continue;
//            }
//        }
//
//        if(v2[i] == '.' && v1[i] == '.') {
//            v1[i] = '#';
//            v2[i] = '#';
//        }
//    }
//
//    // output check
//    for(int i = 1;i <= n;i++) {
//        if(v1[i] == '.') isExist = false;
//    }
//    cout << endl;
//    for(int i = 1;i <= n;i++) {
//        if(v2[i] == '.') isExist = false;
//    }
//
//    if(!isExist) {
//        cout << "None" << "\n";
//        return;
//    }
//    if(isMultiple) {
//        cout << "Multiple" << "\n";
//        return;
//    }
//    cout << "Unique" << "\n";
//
//
//
////    // output check
////    for(int i = 1;i <= n;i++) {
////        cout << v1[i];
////    }
////    cout << endl;
////    for(int i = 1;i <= n;i++) {
////        cout << v2[i];
////    }
//}

void solve() {
    int n; cin >> n;
    vector<char> v1, v2;

    for(int i = 0;i < n;i++) {
        char ch; cin >> ch;
        v1.push_back(ch);
    }
    for(int i = 0;i < n;i++) {
        char ch; cin >> ch;
        v2.push_back(ch);
    }

    vector<pair<int, int>> pref(n + 1);
    pref[0] = make_pair(0, 0);

    for (int i = 0; i < n; i++) {
        pref[i + 1] = make_pair( pref[i].first, pref[i].second);
        if (v1[i] == '.') {
            if (i % 2 == 0) {
                pref[i + 1].first++;
            }
            else {
                pref[i + 1].second++;
            }
        }
        if (v2[i] == '.') {
            if (i % 2 == 1) {
                pref[i + 1].first++;
            }
            else {
                pref[i + 1].second++;
            }
        }

        if (v1[i] == '#' && v2[i] == '#' &&
            pref[i + 1].first != pref[i + 1].second) {
            cout << "None\n";
            return;
        }
    }

    if (pref[n].first != pref[n].second) {
        cout << "None\n";
        return;
    }

    bool is_mult = false;
    for (int i = 0; i < n - 1; i++) {
        if (v1[i] != '.' || v2[i] != '.' ||
            v1[i + 1] != '.' || v2[i + 1] != '.') {
            continue;
        }

        int left = pref[i].first - pref[i].second;
        int right = (pref[n - 1].first - pref[i + 2].first) -
                (pref[n - 1].second - pref[i + 2].second);

        if (left == 0 && right == 0) {
            is_mult = true;
            break;
        }
    }

    if (is_mult) {
        cout << "Multiple\n";
    }
    else {
        cout << "Unique\n";
    }

//    // output check
//    for(int i = 1;i <= n;i++) {
//        cout << v1[i];
//    }
//    cout << endl;
//    for(int i = 1;i <= n;i++) {
//        cout << v2[i];
//    }
}

int main() {
    int t = 1;

    cin >> t;

    while(t--) {
        solve();
    }

    return 0;
}
