//Novosibirsk SU 1 CtrlAltDeFIT
// 001

#include <bits/stdc++.h>

using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define sz(x) (int)(x).size()
#define all(x) begin(x), end(x)
typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

string mhex(int x) {
    string res;
    assert(x < 16);
    if (x <= 9) {
        res.push_back('0' + x);
        return res;
    }
    if (x == 10) return "a";
    if (x == 11) return "b";
    if (x == 12) return "c";
    if (x == 13) return "d";
    if (x == 14) return "e";
    if (x == 15) return "f";
    assert(false);
}

string hex3(int number) {
    string res = "";
    while(number) {
        int x = number % 16; number /= 16;
        res += mhex(x);
    }

    while(res.size() < 3) {
        res.push_back('0');
    }

    reverse(res.begin(), res.end());
    return res;
}


string query(int cnt, int bitn) {
    string res = "";
    res += "fff" + mhex(bitn) + " ";
    res += hex3(cnt + 2) + "2 ";
    res += hex3(bitn) + "8 ";

    res += "0000 ";
    return res;
}

string bad(int cnt) {
    string res = "";
    // copy oldest bit from our addres and set to to io. then quit.

    res += hex3(cnt) + "f ";
    res += "fff0 ";
    res += "ffff ";
    res += "0000 ";

    return res;
}

string good(int cnt, int tocnt) {
    string res = "";
    // just go to next block tocnt, no useful copying

    // Just self copying
    res += "eeee ";
    res += "eeee ";
    res += "0" + hex3(cnt) + " ";
    res += "0000 ";

    return res;
}

void solve() {
    int x;
    cin >> x;

    string answer = "";

    int cnt = 0;
    for(int i = 0; i < 16; i++) {
        int bit = ((x >> i) & 1);
        // Add query
        //
        answer += query(cnt, i);
        answer += "0000 ";
        answer += "0000 ";
        answer += "0000 ";
        answer += "0000 ";
        if (bit) {
            // Add query then good then bad
            // good leads to next query.
            answer += bad(cnt + 8);
            answer += good(cnt + 12, cnt + 16);
        } else {
            answer += good(cnt + 8, cnt + 16);
            answer += bad(cnt + 12);
        }
        answer += "\n";
        cnt += 16;
    }


    // LastGood have to be special
    // Just add block that sets 1 to IO and ends.
    answer += "0000 ";
    answer += "fff0 ";
    answer += "ffff ";
    answer += "0000 ";

    cout << answer;
}

int main() {
//    freopen("input.txt", "r", stdin);
    cin.tie(0)->sync_with_stdio(false);
    cout << setprecision(15) << fixed;
    int t = 1;
    // cin >> t;
    rep(i, 0, t) {
        solve();
    }
    return 0;
}
