#include <bits/stdc++.h>

using namespace std;

template<typename T>
bool mini(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool maxi(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &a: v) {
        in >> a;
    }
    return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
    out << v.first << ' ' << v.second;
    return out;
}

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.first >> v.second;
    return in;
}

using ll = long long;
/*
 *
 */

size_t new_ind = 0;

struct IndInt {
    ll x, id;

    IndInt(int x, int id) : x(x), id(id) {

    }

    explicit IndInt() = default;


    friend istream &operator>>(istream &in, IndInt &i) {
        in >> i.x;
        i.id = new_ind++;
        return in;
    }

    friend bool operator<(const IndInt &a, const IndInt &b) {
        if (a.x != b.x)
            return a.x < b.x;
        return a.id < b.id;
    }
};

struct Task {
    ll a, d, id;

    Task(ll a, ll d, ll id) : a(a), d(d), id(id) {

    }

    Task() = default;
};

void solve() {
    int n;
    cin >> n;
    string s1, s2;
    cin >> s1 >> s2;
    int empty[n];
    for (int i = 0; i < n; i++) {
        empty[i] = ((s1[i] == '.') * 2) ^ ((s2[i] == '.') * 1);
    }
//    for (int i = 0; i < n; i++) cout << empty[i] << ' '; cout << '\n';
    int dp[n][4];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 4; j++) dp[i][j] = 0;
    }
    dp[0][0] = 1;
    dp[0][3] = 1 * (empty[0] == 3);
    for (int i = 1; i < n; i++) {
        dp[i][0] = dp[i - 1][empty[i - 1]];
        if (empty[i - 1] & empty[i] & 1) {
            dp[i][1] = dp[i - 1][empty[i - 1] ^ 1];
        }
        if (empty[i - 1] & empty[i] & 2) {
            dp[i][2] = dp[i - 1][empty[i - 1] ^ 2];
        }
        if (empty[i] == 3) {
            if (empty[i - 1] == 3 && dp[i - 1][0]) {
                dp[i][3] = 2;
            } else {
                dp[i][3] = dp[i - 1][empty[i - 1]];
            }
        }
    }
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < 4; j++) cout << dp[i][j] << ' ';
//        cout <<
//             '\n';
//    }
    int c = dp[n - 1][empty[n - 1]];
    if (c == 0) {
        cout << "None";
    } else if (c == 1) {
        cout << "Unique";
    } else {
        cout << "Multiple";
    }
//    cout << '\n';
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
#ifdef BOBRY
    freopen("./../bobry.txt", "r", stdin);
    freopen("./../bober.txt", "w", stdout);
#endif
    cin >> test;

    while (test--) {
        solve();
        cout << '\n';
    }
}