#include <bits/stdc++.h>

using namespace  std;

#define int long long

bool check_eq(string s, bool correct=false) {
    int max_str = 999'999'999'9;
    int cur = 0;
    int st = 1;
    bool eq = false;
    bool minus = (s[0] == '-');
    vector <int> left, right;
    int leftsum = 0;
    int rightsum = 0;
    for (int i = 0; i < s.size(); i++) {
        if (isdigit(s[i])) {
            if (cur == 0 && s[i] == '0' && i + 1 < s.size() && isdigit(s[i + 1])) {
                return false;
            }
            st = 1;
            cur = cur * 10 + (s[i] - '0');
        } else {
            if (minus) {
                cur = -cur;
            }

            if (abs(cur) > max_str || st == -1) {
                return false;
            }

            if (!eq) {
                left.emplace_back(cur);
                leftsum += cur;
            } else {
                right.emplace_back(cur);
                rightsum += cur;
            }

            cur = 0;
            minus = false;
            st = -1;

            if (s[i] == '=') {
                eq = true;
            } else if (s[i] == '-') {
                minus = true;
            }
        }
    }

    if (minus) {
        cur = -cur;
    }

    if (!eq) {
        left.emplace_back(cur);
        leftsum += cur;
    } else {
        right.emplace_back(cur);
        rightsum += cur;
    }

    if (leftsum == rightsum) {
        if (!correct) {
           cout << s << '\n';
        }
        return true;
    } else {
        return false;
    }
}

void solve() {
    string s;
    cin >> s;

    if (check_eq(s, true)) {
        cout << "Correct\n";
        return;
    }

    for (int er = 0; er < s.size(); er++) {
        if (!isdigit(s[er])) {
            continue;
        }
        for (int ins = 0; ins < s.size(); ins++) {
            if (ins == er) {
                continue;
            }
            string t = s;
            t.erase(t.begin() + er);
            t.insert(t.begin() + ins, s[er]);
            if (check_eq(t)) {
                return;
            }
        }
    }


    cout << "Impossible";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
    return 0;
}