#include <bits/stdc++.h>
using namespace std;

#define vec std::vector

int main() {
    int n;
    cin >> n;

    vec<int> masb(n);
    for (auto& e : masb) {
        cin >> e;
        e--;
    }

    vec<int> indb(n);
    for (int i = 0; i < masb.size(); i++) {
        indb[i] = i;
    }

    vec<pair<int, int>> swaps;
    {
        vec<int> mas;
        for (int i = 0; i < n; i++) {
            mas.push_back(i);
        }
        auto ind = indb;

        auto swap = [&](int a, int b){
            swaps.push_back({mas[a], mas[b]});
            std::swap(ind[mas[a]], ind[mas[b]]);
            std::swap(mas[a], mas[b]);
        };

        for (int i = 0; i < mas.size(); i++) {
            int pos = ind[masb[i]];

            while (pos != mas.size() - 1) {
                swap(pos + 1, pos);
                pos++;
            }
            while (pos != i) {
                swap(pos, pos - 1);
                pos--;
            }
        }
    }


    {
        vec<pair<int, int>> sub_swaps;
        vec<int> mas;
        for (int i = 0; i < n; i++) {
            mas.push_back(i);
        }
        auto ind = indb;

        auto swap = [&](int a, int b){
            sub_swaps.push_back({mas[a], mas[b]});
            std::swap(ind[mas[a]], ind[mas[b]]);
            std::swap(mas[a], mas[b]);
        };

        for (int i = mas.size() - 1; i >= 0; i--) {
            int pos = ind[masb[i]];

            while (pos != 0) {
                swap(pos - 1, pos);
                pos--;
            }
            while (pos != i) {
                swap(pos, pos + 1);
                pos++;
            }
        }

        if (sub_swaps.size() > swaps.size()) {
            swaps = move(sub_swaps);
        }
    }

    cout << swaps.size() << endl;
    for (auto& e : swaps) {
        cout << e.first + 1 << ' ' << e.second + 1 << endl;
    }
    return 0;
}