#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int,int>;
using pll = pair<ll,ll>;
using graph = vector<vector<int>>;

#define all(a) a.begin(), a.end()
#define f first
#define s second
#define pb push_back

const int mod = 1'000'000'007;
const ld eps = 1e-9;
const ll inf = 3'000'000'000'000'000'007ll;

struct IOInit {
    IOInit() {
        cin.tie(0)->sync_with_stdio(0);
        cout << fixed << setprecision(12);
    }
    ~IOInit() {
        #ifdef DEBUG
            cerr << fixed << setprecision(5) << "Runtime: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
        #endif
    }
} _io;

template<class T> istream& operator>>(istream& str, vector<T> &x) {
    for (auto &i : x) str >> i;
    return str;
}
template<class ...T> void read(T&... x) {(cin >> ... >> x);}
template<class ...T> void print(const T&... x) {(cout << ... << x);}
template<class ...T> void println(const T&... x) {print(x..., '\n');}

template<class T> int sz(const T& x) {return x.size();}
template<class T, class U> bool chmin(T& x, const U& y) {return y < x?x=y,1:0;}
template<class T, class U> bool chmax(T& x, const U& y) {return x < y?x=y,1:0;}

#ifdef DEBUG
    template<class T>
    string pdbg(const T& x) {
        if constexpr (same_as<T, string>) {
            return "\"" + x  +"\"";
        }
        if constexpr (requires{x.first;}) {
            return "{" + pdbg(x.f) + ", " + pdbg(x.s) + "}";
        }
        if constexpr (requires{cout << x;}) {
            stringstream ss;
            ss << x;
            return ss.str();
        }
        if constexpr(ranges::range<T>) {
            string ans = "{";
            string del = ", ";
            auto it = begin(x);
            if (it != end(x)) ans += pdbg(*it++);
            while (it !=end(x)) ans += del + pdbg(*it++);
            return ans + "}";
        }
        return "Can't parse type";
    }
    template<class T, class ...U>
    string pdbg(const T& x, const U&... y) {
        return pdbg(x) + ", " + pdbg(y...);
    }
    #define dbg(...) print("[",#__VA_ARGS__,"] = ", pdbg(__VA_ARGS__)), cout << endl
#else
    #define dbg(...) 0
#endif

#include <format>

int main() {
    int x;
    read(x);
    vector<uint16_t> ans(49);

    // 48 * 16 (+ 1)
    ans[48] |= 1 << 1;

    for (int bit = 0; bit < 16; ++bit) {
        int bit_from = 48 * 16 + (x >> bit & 1);
        int bit_to = (1 << 16) - 16 + bit;
        ans[bit * 3] = bit_from;
        ans[bit * 3 + 1] = bit_to;
        ans[bit * 3 + 2] = bit == 15 ? (1 << 12) : bit * 3 + 3;
    }
    for (int i = 0; i < sz(ans); ++i) {
        print(format("{:04x}", ans[i]), ' ');
    }
    return 0;
}