#include <bits/stdc++.h>

#define re return
#define fi first
#define se second
#define f0r(i,n) for (int i = 0; i < (n); ++i)
#define f0rr(i,n) for (int i = (n) - 1; i >= 0; --i)
#define V vector
#define P pair
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define sz(a) ((int)a.size())

using namespace std;

using bl = bool;
using ll = long long;
using ld = double;
using lld = long double;
using vi = vector<int>;
using vll = vector<ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using str = string;
using uint = unsigned int;
using ull = unsigned long long;
using vvi = V<vi>;

template<class T> istream& operator>>(istream& in, V<T>& a) { for (T& x : a) in >> x; re in; }
template<class T> ostream& operator<<(ostream& out, const V<T>& a) { for (const T& x : a) out << x << ' '; re out; }

void solve() {
    int n;
    cin >> n;
    V<P<bl,bl>> a(n);
    int set_idx = -1, unsed_idx = -1;
    f0r(i,n) {
        str s, b;
        cin >> s >> b;
        a[i] = {s == "set", b == "true"};
        if (a[i].se) (a[i].fi ? set_idx : unsed_idx) = i;
    }
    int m;
    cin >> m;
    vvi g(n);
    vi c(n);
    while (m--) {
        int u, v;
        cin >> u >> v;
        g[--u].pb(--v);
        ++c[v];
    }
    vi ans;
    ans.reserve(n);
    V<queue<int>> q(2);
    f0r(i,n) if (!c[i] && !a[i].se) q[a[i].fi].push(i);
    const auto remove_vertex = [&](int u) {
        ans.pb(u+1);
        for (int v : g[u])
            if (!--c[v] && !a[v].se)
                q[a[v].fi].push(v);
    };
    const auto clear_queue = [&](int i) {
        while (sz(q[i])) {
            int u = q[i].front();
            q[i].pop();
            remove_vertex(u);
        }
    };
    clear_queue(0);
    if (set_idx != -1) {
        if (c[set_idx]) {
            cout << -1;
            return;
        }
        remove_vertex(set_idx);
    } else if (sz(ans) == n) {
        cout << ans;
        return;
    } else {
        cout << -1;
        return;
    }
    clear_queue(1);
    if (unsed_idx != -1) {
        if (c[unsed_idx]) {
            cout << -1;
            return;
        }
        remove_vertex(unsed_idx);
    } else if (sz(ans) == n) {
        cout << ans;
        return;
    } else {
        cout << -1;
        return;
    }
    clear_queue(0);
    if (sz(ans) == n) {
        cout << ans;
        return;
    } else {
        cout << -1;
        return;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
//        cout << '\n';
    }
}
