#include <bits/stdc++.h>

#define re return
#define fi first
#define se second
#define f0r(i,n) for (int i = 0; i < (n); ++i)
#define f0rr(i,n) for (int i = (n) - 1; i >= 0; --i)
#define V vector
#define P pair
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define sz(a) ((int)a.size())

using namespace std;

using ll = long long;
using ld = double;
using lld = long double;
using vi = vector<int>;
using vll = vector<ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using str = string;
using uint = unsigned int;
using ull = unsigned long long;
using vvi = V<vi>;

template<class T> istream& operator>>(istream& in, V<T>& a) { for (T& x : a) in >> x; re in; }
template<class T> ostream& operator<<(ostream& out, const V<T>& a) { for (const T& x : a) out << x << ' '; re out; }

void add(str& a, str b) {
    bool carry = 0;
    while (sz(a) < sz(b)) a += '0';
    while (sz(b) < sz(a)) b += '0';
    f0r(i,sz(a)) {
        int s = (a[i] - '0') + (b[i] - '0') + carry;
        carry = 0;
        if (s > 9) {
            carry = 1;
            s -= 10;
        }
        a[i] = s + '0';
    }
    if (carry) a.pb('1');
}

void sub(str& a, str b) {
    while (sz(a) < sz(b)) a += '0';
    while (sz(b) < sz(a)) b += '0';
    bool l = 0;
    f0rr(i,sz(a))
        if (a[i] != b[i]) {
            l = a[i] < b[i];
            break;
        }
    if (l) {
        str t = a;
        a = b;
        b = t;
    }
    bool carry = 0;
    f0r(i,sz(a)) {
        int d = (a[i] - '0') - (b[i] - '0') - carry;
        carry = 0;
        if (d < 0) {
            d += 10;
            carry = 1;
        }
        a[i] = d + '0';
    }
    while (sz(a) > 1 && a.back() == '0') a.pop_back();
    if (l) a.pb('-');
}

void calc(str& a, str b, char op) {
    reverse(all(b));
    if (op == '+') {
        if (a.back() == '-') {
            str t = a;
            t.pop_back();
            a = b;
            sub(a,t);
        } else add(a,b);
    } else {
        if (a.back() == '-') {
            a.pop_back();
            add(a,b);
            a += '-';
        } else sub(a,b);
    }
}

bool check(const str& s) {
    str left = "0";
    str right = "0";
    str num = "";
    char last_op = '+';
    bool r = 0;
    for (char c : s) {
        if (c == '=') {
            if (!sz(num) || sz(num) > 10 || (sz(num) > 1 && num[0] == '0')) re 0;
            r = 1;
            calc(left, num, last_op);
            last_op = '+';
            num.clear();
        } else if (c == '+' || c == '-') {
            if (!sz(num) || sz(num) > 10 || (sz(num) > 1 && num[0] == '0')) re 0;
            calc(r ? right : left, num, last_op);
            last_op = c;
            num.clear();
        } else {
            num += c;
        }
    }
    if (!sz(num) || sz(num) > 10 || (sz(num) > 1 && num[0] == '0')) re 0;
    calc(right, num, last_op);
//    if (s == "123456789+987654321=1111111100+11-1") {
//        cout << left << ' ' << right << '\n';
//    }
    re left == right;
}

void solve() {
    str s;
    cin >> s;
    if (check(s)) {
        cout << "Correct";
        return;
    }
//    return; //
    f0r(i,sz(s)) {
        if (s[i] == '=' || s[i] == '+' || s[i] == '-') continue;
        str t = s.substr(0,i) + s.substr(i+1);
//        cout << t << '\n'; //
        f0r(j,sz(t)+1) {
            str t2 = t.substr(0,j) + s[i] + t.substr(j);
//            cout << t2 << '\n'; //
            if (check(t2)) {
                cout << t2;
                return;
            }
        }
    }
    cout << "Impossible";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
//        cout << '\n';
    }
}
