#include <bits/stdc++.h>

#define re return
#define fi first
#define se second
#define f0r(i,n) for (int i = 0; i < (n); ++i)
#define f0rr(i,n) for (int i = (n) - 1; i >= 0; --i)
#define V vector
#define P pair
#define all(a) (a).begin(), (a).end()
#define pb push_back

using namespace std;

using ll = long long;
using ld = double;
using lld = long double;
using vi = vector<int>;
using vll = vector<ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using str = string;
using uint = unsigned int;
using ull = unsigned long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tt;
    cin >> tt;
    while (tt--) {
        ll n, m, q;
        cin >> n >> m >> q;
        vll l(m);
        V<pll> ad(n);
        f0r (i, n) cin >> ad[i].fi;
        f0r (i, n) cin >> ad[i].se;
        f0r (i, m) cin >> l[i];

        sort(all(ad), [&](pll x, pll y) { re x.se < y.se; });
        vll a, d;
        a.pb(ad[0].fi);
        d.pb(ad[0].se);

        for (int i = 1; i < n; i++) {
            if (ad[i].se == ad[i - 1].se) {
                a.back() += ad[i].fi;
            } else {
                a.pb(ad[i].fi);
                d.pb(ad[i].se);
            }
        }

        n = (ll)a.size();

        vll pa(n), pl(m);
        partial_sum(all(a), pa.begin());
        partial_sum(all(l), pl.begin());

        vll dt(n);
        dt[n - 1] = d[n - 1] - a[n - 1];
        for (int i = n - 2; i >= 0; --i) {
            dt[i] = min(dt[i + 1] - a[i], d[i] - a[i]);
        }

        while (q--) {
            ll t;
            cin >> t;
            int pos = lower_bound(all(d), t) - d.begin();
            int ch = pos;
            ll th = ch ? pa[ch - 1] : 0LL;
            if (pos != n) {
                t = min(t, dt[pos]);
            }
            ll dl = t - th;
            assert(dl >= 0);
            cout << upper_bound(all(pl), dl) - pl.begin() << ' ';
        }
        cout << '\n';
    }
}
