#pragma optimize("SEX_ON_THE_BEACH")

#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()

#ifdef HOME
    #define debug(...) { cerr << #__VA_ARGS__ << " " << __VA_ARGS__ << endl; }
    #define say(...) { cerr << __VA_ARGS__ << endl; }
#else
    #define debug(...) 0;
    #define say(...) 0;
#endif

vector<string> arr(2);
vector<vector<bool>> was(2);

vector<pair<int, int>> inv;
vector<vector<pair<int, int>>> gr[2];

void dfs(int x, int y) {
    if (arr[x][y] == '#') return;
    if (was[x][y]) return;
    was[x][y] = 1;
    inv.push_back({x, y});
    if (x && arr[x - 1][y] == '.') {
        gr[x][y].push_back({x - 1, y});
        dfs(x - 1, y);
    }
    if (x < 1 && arr[x + 1][y] == '.') {
        gr[x][y].push_back({x + 1, y});
        dfs(x + 1, y);
    }
    if (y && arr[x][y - 1] == '.') {
        gr[x][y].push_back({x, y - 1});
        dfs(x, y - 1);
    }
    if (y + 1 < was[0].size() && arr[x][y + 1] == '.') {
        gr[x][y].push_back({x, y + 1});
        dfs(x, y + 1);
    }
}

int build(int x, int y) {
    inv.clear();
    dfs(x, y);
    if (inv.size() % 2) return 0;
    set<pair<int, pair<int, int>>> tos;
    map<pair<int, int>, int> deg;
    for (auto i : inv) {
        tos.insert({deg[i], i});
    }
    while (tos.size()) {
        auto v = tos.begin()->ss;
        tos.erase(tos.begin());
        if (gr[v.ff][v.ss].size() >= 2) return 3;
        if (gr[v.ff][v.ss].size() == 0) return 0;
        auto to = gr[v.ff][v.ss][0];
        gr[v.ff][v.ss].clear();
        tos.erase({gr[to.ff][to.ss].size(), to});
        for (int j = 0; j < gr[to.ff][to.ss].size(); ++j) {
            auto toto = gr[to.ff][to.ss][j];
            if (toto == v) continue;
            tos.erase({gr[toto.ff][toto.ss].size(), toto});
            gr[toto.ff][toto.ss].erase(find(all(gr[toto.ff][toto.ss]), to));
            tos.insert({gr[toto.ff][toto.ss].size(), toto});
        }
    }
    return 1;
}

void solve(int test = 0) {
    int n;
    cin >> n;
    cin >> arr[0] >> arr[1];
    was[0].resize(n); was[0].assign(n, 0);
    was[1].resize(n); was[1].assign(n, 0);
    gr[0].clear();
    gr[0].resize(n);
    gr[1].clear();
    gr[1].resize(n);
    int ans = 3;
    bool fnd = 0;
    for (int i = 0; i < n; ++i) {
        if (arr[0][i] == '.' && !was[0][i]) ans &= build(0, i), fnd = 1;
        if (arr[1][i] == '.' && !was[1][i]) ans &= build(1, i), fnd = 1;
    }
    if (!fnd) cout << "Unique";
    else if (ans == 0) cout << "None";
    else if (ans == 1) cout << "Unique";
    else cout << "Multiple";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << '\n';
        say("=================================================");
    }
}