#include <bits/stdc++.h>


using namespace std;

#define int long long
#define all(a) (a).begin(),(a.end())

void solve() {
    int n;
    cin >> n;
    vector<int> a(2 * n);
    for (int q = 0; q < 2 * n; q++) {
        cin >> a[q];
        a[q]--;
    }
    vector<vector<int> > g(2 * n);
    for (int q = 1; q < 2 * n; q++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    vector<pair<int, int> > pp;
    pp.reserve(n);
    auto find_pp = [&](int cur, int prev, auto &find_pp) -> bool {
        int x = -1;
        for (int q: g[cur]) {
            if (q == prev) continue;
            if (find_pp(q, cur, find_pp)) {
                x = q;
            }
        }
        if (x != -1) {
            pp.push_back({cur, x});
            return false;
        }
        return true;
    };
    find_pp(0, -1, find_pp);
//    for (auto [q, w]: pp) {
//        cout << q << " " << w << endl;
//    }


    vector<vector<int>> color_to_vertex(n + 1);
    vector<pair<int, int>> res;

    vector<vector<int> > gg(2 * n);
    for (auto [q, w]: pp) {
        gg[q].push_back(w);
        gg[w].push_back(q);
    }
    for (int i = 0; i < 2 * n; i++) {
        color_to_vertex[a[i]].push_back(i);
    }
    for (int q = 0; q < n; q++) {
        int x = color_to_vertex[q][0];
        int y = color_to_vertex[q][1];
        gg[y].push_back(x);
        gg[x].push_back(y);
    }


    vector<bool> us(2 * n, false);
    vector<int> comp;
    auto dfs = [&](int cur, auto &dfs) -> void {
        comp.push_back(cur);
        us[cur] = true;
        for (int q: gg[cur]) {
            if (!us[q]) {
                dfs(q, dfs);
            }
        }
    };

    auto solve_chain = [&]() {
        if (comp.size() == 2) {
            return;
        }
        int l = 1, r = (int) (comp.size()) - 1;
        while (l < r) {
            res.push_back({comp[l], comp[r]});
            swap(a[comp[l]], a[comp[r]]);
            l++, r--;
        }
    };

    auto solve_cycle = [&]() {
        if (comp.size() == 2) {
            return;
        }
        int l = 1, r = (int) (comp.size()) - 1;
        while (l < r) {
            res.push_back({comp[l], comp[r]});
            swap(a[comp[l]], a[comp[r]]);
            l++, r--;
        }
    };


    for (int q = 0; q < 2 * n; q++) {
        if (gg[q].size() == 1 && us[q] == 0) {
            comp.clear();
            dfs(q, dfs);
            solve_chain();
//            for (int q = 0; q < 2 * n; q++) {
//                cout << a[q];
//            }
//            cout<<endl;
        }
    }
    for (int q = 0; q < 2 * n; q++) {
        if (!us[q]) {
            comp.clear();
            dfs(q, dfs);
            solve_cycle();
//            for (int q = 0; q < 2 * n; q++) {
//                cout << a[q];
//            }
//            cout<<endl;
        }
    }

//    for (auto [q, w]: pp) {
//        if (a[q] != a[w]) {
//            cout << "kek" << endl;
//        }
//    }
    cout << res.size() << endl;
    for (auto [q, w]: res) {
        cout << q + 1 << " " << w + 1 << "\n";
    }
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
