#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define all(x) (x).begin(), (x).end()

using namespace std;

const int inf = 1e16;

void solve(){
    int n, m, q;
    cin >> n >> m >> q;
    vector<pii> tasks(n);
    for(auto &[x, y]: tasks) cin >> y;
    for(auto &[x, y]: tasks) cin >> x;
    sort(all(tasks));
    vector<int> c(n), b(n);
    int cur_x = 0;
    for(int i = 0; i < n; i++){
        b[i] = cur_x;
        cur_x += tasks[i].s;
        c[i] = tasks[i].f - cur_x;
    }
    vector<int> suf(n + 1);
    suf[n] = inf;
    for(int i = n - 1; i >= 0; i--){
        suf[i] = min(suf[i + 1], c[i]);
    }
    vector<int> films(m);
    for(auto &x: films) cin >> x;
    vector<int> finished(m);
    int shifted = 0, task_suf = 0;
    cur_x = 0;
    for(int i = 0; i < m; i++){
//        cerr << suf[task_suf] - shifted << '\n';
        while(task_suf < n && suf[task_suf] - shifted < films[i]){
            cur_x = b[task_suf] + tasks[task_suf].s + shifted;
            task_suf++;
        }
//        cerr << task_suf << ' ' << cur_x << '\n';
        cur_x += films[i];
        shifted += films[i];
        finished[i] = cur_x;
//        cerr << cur_x << " cur\n";
    }
//    for(auto x: b) cerr << x << ' ';
//    cerr << '\n';
//    for(auto x: suf) cerr << x << ' ';
//    cerr << '\n';
//    for(auto x: finished) cerr << x << ' ';
//    cerr << '\n';
    while(q--) {
        int t;
        cin >> t;
        cout << upper_bound(all(finished), t) - finished.begin() << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
