#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<int> final (n+1);
    vector<int> cur (n+1);
    unordered_map <int, int> pos_by_number;
    vector<pair<int,int>> ans;
    int x;
    for (int i = 1; i <= n; ++i){
        cin >> x;
        final[i] = x;
        cur[i] = i;
        pos_by_number[i]=i;
    }
    for (int i = 1; i < n; ++i) {
        int cur_num = final[i];
        int j = pos_by_number[cur_num];
        while(j < n){
            ans.push_back(make_pair(cur[j+1], cur[j]));
            swap(cur[j], cur[j+1]);
            pos_by_number[cur[j]] = j;
            pos_by_number[cur[j+1]] = j+1;
            j++;
        }
        while(j > i){
            ans.push_back(make_pair(cur[j], cur[j-1]));
            swap(cur[j], cur[j-1]);
            pos_by_number[cur[j]] = j;
            pos_by_number[cur[j-1]] = j-1;
            j--;
        }
    }
    if (ans.empty()){
        cout << 0;
        return 0;
    }
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); ++i){
        cout << ans[i].first <<" "<<ans[i].second << "\n";
    }
    return 0;
}
