#include <iostream>
#include <vector>
#include <list>
#include <queue>
#include <functional>
using namespace std;

void solve(){
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<long long, int>> tasks(n);
    for(int i = 0; i < n; i++){
        cin >> tasks[i].second;
    }
    for(int i = 0; i < n; i++){
        cin >> tasks[i].first;
    }
    queue<long long> series;
    for(long long i = 0, next; i < m; i++){
        cin >> next;
        series.push(next);
    }
    vector<pair<long long, int>> meets(q);
    for(int i = 0; i < q; i++){
        cin >> meets[i].first;
        meets[i].second = i;
    }
    sort(tasks.begin(), tasks.end(), greater<pair<long long, int>>());
    sort(meets.begin(), meets.end());

    list<pair<long long, long long>> times;
    times.push_back({0, 1e16});
    for(int i = 0; i < n; i++){
        if(times.back().second <= tasks[i].first){
            times.back().second -= tasks[i].second;
        }
        else{
            times.back().first = tasks[i].first;
            times.push_back({0, tasks[i].first - tasks[i].second});
        }
    }
    reverse(times.begin(), times.end());
    auto time = times.begin();
    size_t cnt = 0;
    vector<int> ans(q);
    for(int i = 0; i < q; i++){
        while(!series.empty() && (*time).first + series.front() <= meets[i].first){
            while((*time).second - (*time).first < series.front()){
                auto next = time;
                next++;
                (*next).first -= (*time).second - (*time).first;
                time++;
            }

            if((*time).first + series.front() <= meets[i].first){
                cnt++;
                (*time).first += series.front();
                series.pop();
            }
        }
        ans[meets[i].second] = cnt;
    }
    for(int i = 0; i < q; i++)
        cout << ans[i] << " ";
    cout << '\n';
}

int main()
{
    size_t t;
    cin >> t;
    while(t--)
        solve();
}
