#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pll pair<ll, ll>
#define ld long double
#define pld pair<ld, ld>

#define INF 1000000000000000ll

vector <pll> dirs = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

void solve() {
    ll n; cin >> n;
    ll broken_am = 0; 
    vector <vector <char> > s(n + 2, vector <char> (4, '#'));
    for (ll i = 1; i <= n; i++) {
        cin >> s[i][1];
        if (s[i][1] == '.')
            broken_am++;
    }
    for (ll i = 1; i <= n; i++) {
        cin >> s[i][2];
        if (s[i][2] == '.')
            broken_am++;
    }

    vector <vector <ll> > nms(n + 2, vector <ll> (4, -1));

    for (ll i = 1; i <= n; i++) {
        nms[i][1] = i;
    }
    for (ll i = 1; i <= n; i++) {
        nms[i][2] = i + n;
    }

    vector <set <ll> > g(2 * (n + 2));
    for (ll i = 1; i <= n; i ++) {
        if (s[i][1] == '#')
            continue;

        ll x = i;
        ll y = 1;
        for (auto dir : dirs) {
            ll xx = x + dir.first;
            ll yy = y + dir.second;
            if (s[xx][yy] == '#')
                continue;
            
            g[nms[x][y]].insert(nms[xx][yy]);
        }
    }

    for (ll i = 1; i <= n; i ++) {
        if (s[i][2] == '#')
            continue;

        ll x = i;
        ll y = 2;
        for (auto dir : dirs) {
            ll xx = x + dir.first;
            ll yy = y + dir.second;
            if (s[xx][yy] == '#')
                continue;
            
            g[nms[x][y]].insert(nms[xx][yy]);
        }
    }

    set <pll> q;
    for (ll i = 1; i <= 2 * n; i++) {
        if (g[i].size()) {
            q.insert({g[i].size(), i});
        }
    }

    bool flag_mult = false;

    vector <bool> was(2 * (n + 2));

    while (!q.empty()) {
        auto cur = *q.begin();
        q.erase(cur);

        if (cur.first == 0) {
            continue;
        }

        if (cur.first >= 2)
            flag_mult = true;

        auto sec = *g[cur.second].begin();
        q.erase({g[sec].size(), sec});

        // cout << cur.second << " " << sec << " -> " << cur.first << "\n";

        for (auto to : g[cur.second]) {
            if (q.count({g[to].size(), to})) {
                q.erase({g[to].size(), to});
                g[to].erase(cur.second);
                q.insert({g[to].size(), to});
            }
        }
        g[cur.second].clear();

        for (auto to : g[sec]) {
            if (q.count({g[to].size(), to})) {
                q.erase({g[to].size(), to});
                g[to].erase(sec);
                q.insert({g[to].size(), to});
            }
        }
        g[sec].clear();

        broken_am -= 2;
    }

    if (broken_am) {
        cout << "None\n";
    } else if (flag_mult) {
        cout << "Multiple\n";
    } else {
        cout << "Unique\n";
    }
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll t = 1; 
    cin >> t;

    while (t--)
        solve();
}