#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <bitset>
#include <deque>
#include <string>
#include <numeric>


using namespace std;
//#define LOCAL
#define int long long

using ld = long double;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using ii = pair<int, int>;
using pii = pair<int, int>;
using vii = vector<pair<int, int>>;

#define fore(i, b, e) for (int i = (b); i < (e); ++i)
#define foree(i, b, e) for (int i = (b); i <= (e); ++i)
#define ford(i, b, e) for (int i = (e) - 1; i >= (b); --i)
#define fordd(i, b, e) for (int i = (e); i >= (b); --i)
#define pb push_back
#define ff first
#define ss second

#define all(x) (x).begin(), (x).end()



using namespace std;

void precalc();
void solve();


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	precalc();
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", 'w', stdout);
#endif

	while (t--) {
		solve();
	}

}

void precalc() {

}

int cnt[1001][1001];
int a[1001][1001];

void solve() {
	int N;
	cin >> N;
	vector<int> v(N);
	for (int i = 0; i < N; ++i) {
		cin >> v[i];
	}

	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < N; ++j) {
			if (i < j) 
				a[v[i]][v[j]] = 1;
			else
				a[v[j]][v[i]] = 1;
		}
	}

	vector<int> p(N);
	iota(all(p), 1);

	vii ans;

	int need = -2;
	while (need != -1) {
		need = -1;
		for (int i = N - 1; i > 0; --i) {
			if (cnt[p[i]][p[i - 1]] == 0 && a[p[i - 1]][p[i]] == 1) {
				ans.pb({ p[i], p[i - 1] });
				ans.pb({ p[i - 1], p[i] });
				cnt[p[i]][p[i - 1]] = 2;
				cnt[p[i - 1]][p[i]] = 2;
			}
			if (a[p[i - 1]][p[i]] == 0 && need == -1) {
				need = i;
			}
		}

		if (need != -1) {
			ans.pb({ p[need], p[need - 1] });
			swap(p[need], p[need - 1]);
			cnt[p[need]][p[need - 1]] = 1;
			cnt[p[need - 1]][p[need]] = 1;
		}
	}
	int k = ans.size();
	cout << k << '\n';
	for (int i = 0; i < k; ++i) {
		cout << ans[i].first << " " << ans[i].second << '\n';
	}
}