
def to_int(a):
	if (a == ['0']):
		return 0
	V = 0
	for c in a:
		V *= 10
		intovoe = int(c)
		if intovoe == 0 and V == 0:
			raise 123
		V += int(c)
	if V >= 10000000000:
		raise 123
	return V

def get(s):
	N = len(s)
	poses = []
	for i in range(N):
		if s[i] == '+' or s[i] == '-':
			poses.append(i)

	if (len(poses) != 0):
		if (poses[0] == 0 or poses[-1] == N - 1):
			return False

	nums = []
	last = 0
	for V in poses:
		nums.append(s[last: V])
		last = V + 1
	nums.append(s[last: N])
	for i in range(len(nums)):
		nums[i] = to_int(nums[i])

	if len(nums) != len(poses) + 1:
		raise 123

	for i in range(len(poses)):
		poses[i] = s[poses[i]]

	for i in range(1, len(nums)):
		v1 = nums[i - 1]
		v2 = nums[i]

		if (poses[i - 1] == '+'):
			nums[i] = v1 + v2
		else:
			nums[i] = v1 - v2
	return nums[-1]

def check_correct(s):
	N = len(s)
	poses = []
	for i in range(N):
		if s[i] == '=':
			poses.append(i)
	if len(poses) != 1:
		return False

	cheking = []
	for i in range(N):
		if s[i] == '+' or s[i] == '-' or s[i] == '=':
			cheking.append(i)

	for i in range(len(cheking) - 1):
		if (cheking[i + 1] == cheking[i] + 1):
			return False

	p = poses[0]

	s1 = s[0:p:]
	s2 = s[p + 1: N]

	try:
		v1 = get(s1)
		v2 = get(s2)
		return v1 == v2
	except:
		return False


t = input()
s = []
for C in t:
	s.append(C)
if (check_correct(s)):
	print("Correct")
else:
	N = len(s)
	for i in range(0, N):
		if s[i] == '-' or s[i] == '+' or s[i] == '=':
			continue
		for j in range(i + 1, N):
			s[j - 1], s[j] = s[j], s[j - 1]
			if (check_correct(s)):
				print(*s, sep = '')
				exit(0)

		for j in range(N - 1, 0, -1):
			s[j - 1], s[j] = s[j], s[j - 1]
			if (check_correct(s)):
				print(*s, sep = '')
				exit(0)

		for j in range(1, i + 1):
			s[j], s[j - 1] = s[j - 1], s[j]

	print("Impossible")