#include <bits/stdc++.h>
#define i2 array<int,2>
#define i3 array<int,3>
#define l2 array<ll,2>
using namespace std;
typedef long long ll;

const ll MAX_T = 1e16;

int n;
vector<vector<int>> g;
vector<vector<i3>> new_g;
vector<int> mrk;
vector<i2> prs;
vector<int> cur_v;
vector<int> cur_e;
vector<int> col;
vector<i2> ans;
vector<i2> INDS;

void GetPrs(int v, int p) {
    assert(v >= 0);
    assert(v < 2 * n);
    for (int u : g[v]) {
        if (u == p) continue;

        GetPrs(u, v);

        if (!mrk[v] && !mrk[u]) {
            if (col[v] != col[u]) {
                prs.push_back({u, v});
                mrk[u] = 1;
                mrk[v] = 1;
            }
        }
    }
}

void GetPath(int cl) {
    mrk[cl] = 1;
    cur_v.push_back(cl);

    assert(cl >= 0);
    assert(cl < n);
    for (auto [u, ed_1, ed_2] : new_g[cl]) {
        if (mrk[u]) continue;

        cur_e.push_back(ed_1);
        cur_e.push_back(ed_2);
        GetPath(u);
    }
}

int GET_SEC_IND(int cl, int id) {
    assert(0 <= cl);
    assert(cl < n);
    if (INDS[cl][0] == id) {
        return INDS[cl][1];
    } else {
        return INDS[cl][0];
    }
}

void HANDLE(int VER) {
    // handler
    cur_v.clear();
    cur_e.clear();
    GetPath(VER);

    if (cur_e.size() == 2) {
//        if (new_g[cur_v[0]].size() == 2) {
            // cycle
            int new_id = GET_SEC_IND(cur_v[0], cur_e[0]);
            ans.push_back({cur_e[1], new_id});
//        } else {
//            // path
//            int new_id = GET_SEC_IND(cur_v[0], cur_e[cur_v[0]]);
//            ans.push_back({cur_e[1], new_id});
//        }
        return;
    }

//    assert(false);

//        int used_col[]
    int mid = (cur_v.size() + 1) / 2;
    int id_2 = mid * 2;
    int id_1 = id_2 - 2;

    assert(id_1 >= 0 && id_1 < cur_e.size());
    assert(id_2 >= 0 && id_2 < cur_e.size());

    while (id_1 >= 0 && id_2 < cur_e.size()) {
        ans.push_back({cur_e[id_1], cur_e[id_2]});
        --id_1;
        ++id_2;
    }

    if (id_1 < 0) {
//        assert(id_2 == cur_e.size() - 1);
        int new_id = GET_SEC_IND(cur_v[0], cur_e[0]);
        ans.push_back({new_id, cur_e[id_2]});
    } else {
//        assert(id_2 == cur_e.size());
//        assert(id_1 == 0);
        int new_id = GET_SEC_IND(cur_v.back(), cur_e.back());
        ans.push_back({new_id, cur_e[id_1]});
    }
}

void solve() {
    cin >> n;
    col.resize(2 * n);

//    cerr << n << '\n';

    INDS.resize(n);
    for (int i = 0; i < n; ++i) {
        INDS[i] = {-1, -1};
    }

    for (int i = 0; i < 2 * n; ++i) {
        cin >> col[i];
        --col[i];

        if (INDS[col[i]][0] != -1) {
            INDS[col[i]][1] = i;
        } else {
            INDS[col[i]][0] = i;
        }
    }

    g.clear();
    g.resize(2 * n);

    mrk.resize(2 * n);

    for (int i = 0; i < 2 * n; ++i) {
        g[i].clear();
        mrk[i] = false;
    }
    for (int i = 1; i < 2 * n; ++i) {
        int u, v; cin >> u >> v;
        --u; --v;

        g[u].push_back(v);
        g[v].push_back(u);
    }

//    cerr << g.size() << '\n';
    prs.clear();
    GetPrs(0, -1);

    new_g.clear();
    new_g.resize(n);
    for (int i = 0; i < n; ++i) {
        new_g[i].clear();
    }

    for (int i = 0; i < prs.size(); ++i) {
        auto [x, y] = prs[i];
        assert(0 <= x && x < 2 * n);
        assert(0 <= y && y < 2 * n);
        new_g[col[x]].push_back({col[y], x, y});
        new_g[col[y]].push_back({col[x], y, x});
    }

    for (int i = 0; i < n; ++i) {
        mrk[i] = false;
    }

    assert(new_g.size() == n);

    ans.clear();
    // cnt[v] == 1
    for (int VER = 0; VER < n; ++VER) {
        if (mrk[VER] || new_g[VER].size() != 1) continue;

        HANDLE(VER);
    }
    for (int VER = 0; VER < n; ++VER) {
        if (mrk[VER] || new_g[VER].size() != 2) continue;

        HANDLE(VER);
    }


    cout << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x + 1 << " " << y + 1 << '\n';
    }
}

signed main() {
    int t = 1;
#ifdef KEK
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> t;
#else
    cin.tie(0); cout.tie(0); std::ios::sync_with_stdio(false);
    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
}