#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cassert>
using namespace std;
using ll = long long;


void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	vector<pair<ll, ll>>a(n);
	vector<ll>len(m);
	for (auto& x : a) {
		cin >> x.second;
	}
	for (auto& x : a) {
		cin >> x.first;
	}
	for (auto& x : len) {
		cin >> x;
	}
	sort(a.begin(), a.end());
	for (int i = 1; i < n; ++i) {
		a[i].second += a[i - 1].second;
	}
	vector<ll>zap(n + 1);
	zap.back() = 1e18;
	for (int i = n - 1; i >= 0; --i) {
		ll tmp = a[i].first - a[i].second;
		zap[i] = min(tmp, zap[i + 1]);
	}
	for (int i = 1; i < m; ++i) {
		len[i] += len[i - 1];
	}
	while (q--) {
		ll t;
		cin >> t;
		ll it = lower_bound(a.begin(), a.end(), make_pair(t, 0LL))
			- a.begin();
		ll hs_tmr = min(zap[it], t);
		if (it > 0) {
			hs_tmr = min(hs_tmr, t - a[it - 1].second);
		}
		ll it1 = upper_bound(len.begin(), len.end(), hs_tmr)
			- len.begin();

		cout << it1 << " ";
	}
	cout << "\n";

}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(20);
#ifdef _MY
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}