#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

int n;
vector <string> s(2);
vector <vector <int>> l(2);
vector <vector <bool>> used(2); 
vector <int> tek;

void dfs(int i, int j) {
    used[i][j] = true;
    if (i % 2 != j % 2) --tek[tek.size() - 1];
    else ++tek[tek.size() - 1];
    for (int k = fmax(0, j-1); k <= fmin(n - 1, j+1); ++k) {
        if (k == j) {
            if (l[1-i][j] == 0 && !used[1-i][j]) dfs(1-i, j);
        } else {
            if (l[i][k] == 0 && !used[i][k]) dfs(i, k);
        }
    }
}

void solve() {
    cin >> n;
    cin >> s[0] >> s[1];
    l[0].resize(n);
    l[1].resize(n);
    // cout << s[0] << ' ' << s[1] << '\n';
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            if (s[i][j] == '#') l[i][j] = 1;
            else l[i][j] = 0;
        }
    }
    int cnt;
    for (int o = 0; o < 3; ++o) {
        for (int i = 0; i < 2; ++i) {
            for (int j = 0; j < n; ++j) {
                if (l[i][j] == 0) {
                    cnt = 0;
                    for (int k = fmax(0, j-1); k <= min(n - 1, j+1); ++k) {
                        ++cnt;
                        if (k == j) {
                            cnt -= l[1-i][k];
                        } else {
                            cnt -= l[i][k];
                        }
                    }
                    if (cnt == 1) {
                        // cout << i+1 << ' ' << j+1 << '\n';
                        for (int k = fmax(0, j-1); k <= min(n - 1, j+1); ++k) {
                            if (k == j && l[1-i][k] == 0) {
                                l[i][j] = l[1-i][k] = 1;
                            } else if (l[i][k] == 0) {
                                l[i][j] = l[i][k] = 1;
                            }
                        }
                    }
                }
            }
        }
    }
    while (tek.size()) tek.pop_back();
    used[0].assign(n, false);
    used[1].assign(n, false);
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            if (l[i][j] == 0 && !used[i][j]) tek.push_back(0), dfs(i, j);
        }
    }
    if (tek.size() == 0) {
        cout << "Unique\n";
    } else {
        string ans = "Multiple\n";
        for (auto it : tek) {
            if (it != 0) {
                ans = "None\n";
                break;
            } 
        }
        cout << ans;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(); cout.tie();
    int t; cin >> t;
    for (; t; --t) {
        solve();
    }
}