#include <iostream>
#include <string>

int main()
{
	int T;
	std::cin >> T;

	while (T--)
	{
		int n;
		std::cin >> n;

		std::string up, down;
		std::cin >> up >> down;

		std::string state = "";
		for (int i = 0; i < n; i++)
		{
			if (up[i] == '#' && down[i] == '#')
			{
				state += 'Z';
			}
			else if (up[i] == '#' && down[i] == '.')
			{
				state += 'N';
			}
			else if (up[i] == '.' && down[i] == '#')
			{
				state += 'V';
			}
			else
			{
				state += 'O';
			}
		}
	
		state += "ZZZZZ";

		int i = 0;
		bool multiple = false, solve = true;

		while (i < state.size() - 2)
		{
			if (state[i] == 'Z') i++;
			else if (state[i] == 'V')
			{
				if (state[i + 1] == 'Z' || state[i + 1] == 'N')
				{
					solve = false;
					break;
				}
				else if (state[i + 1] == 'V') i += 2;
				else
				{
					state[i + 1] = 'N';
					i++;
				}
			}
			else if (state[i] == 'N')
			{
				if (state[i + 1] == 'Z' || state[i + 1] == 'V')
				{
					solve = false;
					break;
				}
				else if (state[i + 1] == 'N') i += 2;
				else
				{
					state[i + 1] = 'V';
					i++;
				}
			}
			else if (state[i] == 'O')
			{
				
				if (state[i + 1] == 'O')
				{
					multiple = true;
				}
				i++;
			}
		}

		if (!solve)
		{
			std::cout << "None\n";
		}
		else if (multiple)
		{
			std::cout << "Multiple\n";
		}
		else
		{
			std::cout << "Unique\n";
		}
	}

	return 0;
}
