def is_digit(c):
    return c != '-' and c != '=' and c != '+'


def ok(s):
    a, b = s.split('=')
    for i in range(len(s)):
        if i == 0 or not is_digit(s[i - 1]):
            if not is_digit(s[i]):
                return False
        if i == len(s) - 1 and not is_digit(s[i]):
            return False
        if s[i] == '0' and (i == 0 or not is_digit(s[i - 1])):
            if i + 1 < len(s) and is_digit(s[i + 1]):
                return False
    l, r = [0], [0]
    l_sign, r_sign = [], []
    for i in range(len(a)):
        if a[i] == '-':
            l_sign.append(-1)
            l.append(0)
        elif a[i] == '+':
            if i == 0:
                return False
            l_sign.append(1)
            l.append(0)
        else:
            l[-1] = 10 * l[-1] + int(a[i])
    for i in range(len(b)):
        if b[i] == '-':
            r_sign.append(-1)
            r.append(0)
        elif b[i] == '+':
            r_sign.append(1)
            r.append(0)
        else:
            r[-1] = r[-1] * 10 + int(b[i])
    for x in l:
        if x >= 10 ** 10:
            return False
    for y in r:
        if y >= 10 ** 10:
            return False
    x = l[0]
    y = r[0]
    for i in range(1, len(l)):
        if l_sign[i - 1] == 1:
            x += l[i]
        else:
            x -= l[i]
    for i in range(1, len(r)):
        if r_sign[i - 1] == 1:
            y += r[i]
        else:
            y -= r[i]
    return x == y


def solve():
    s = input()
    if ok(s):
        print('Correct')
        quit()
    for i in range(len(s)):
        if s[i] == '+' or s[i] == '-' or s[i] == '=':
            continue
        q = s[:i] + s[i + 1:]
        for j in range(len(q) + 1):
            qq = q[:j] + s[i] + q[j:]
            if ok(qq):
                print(qq)
                quit()
    print('Impossible')

solve()