#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define int long long

void solve() {
    int n; cin >> n;
    vector<char> line1(n);
    for (auto& c: line1) cin >> c;
    vector<char> line2(n);
    for (auto& c: line2) cin >> c;

    vector<vector<int>> dp(n + 1, vector<int>(4, 0));
    dp[0][3] = 1;
    for (int i = 1; i <= n; ++i) {
        if (line1[i - 1] == '.' && line2[i - 1] == '.') {
            dp[i][0] = dp[i - 1][3];
            dp[i][1] = dp[i - 1][2];
            dp[i][2] = dp[i - 1][1];
            dp[i][3] = dp[i - 1][3] + dp[i - 1][0];
        } else if (line1[i - 1] == '#' && line2[i - 1] == '.') {
            dp[i][0] = dp[i][2] = 0;
            dp[i][1] = dp[i - 1][3];
            dp[i][3] = dp[i - 1][1];
        } else if (line1[i - 1] == '.' && line2[i - 1] == '#') {
            dp[i][0] = dp[i][1] = 0;
            dp[i][2] = dp[i - 1][3];
            dp[i][3] = dp[i - 1][2];
        } else {
            dp[i][0] = dp[i][1] = dp[i][2] = 0;
            dp[i][3] = dp[i - 1][3];
        }
    }

    if (dp[n][3] == 0) {
        cout << "None\n";
    } else if (dp[n][3] == 1) {
        cout << "Unique\n";
    } else {
        cout << "Multiple\n";
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    int test_cnt = 1;
    cin >> test_cnt;

    while (test_cnt--) {
        solve();
    }
}