#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
map<ll, set<ll>> mp;
vector<pair<ll,ll>> ans;
vector<ll> vc;

#define int long long

const int INF = 1e16;

void solve() {
    int n, m, Q; cin >> n >> m >> Q;
    vector<pair<int, int>> arr(n);
    for (auto& i: arr) {
        cin >> i.second;
    }
    for (auto& i: arr) {
        cin >> i.first;
    }
    vector<int> lrr(m);
    for (auto& i: lrr) cin >> i;
    vector<int> qrr(Q);
    for (auto& i: qrr) cin >> i;

    vector<int> pref2(m, 0);
    for (int i = 0; i < m; ++i) {
        pref2[i] = (i == 0 ? 0 : pref2[i - 1]) + lrr[i];
    }

    sort(all(arr));
    vector<int> pref(n, 0);
    for (int i = 0; i < n; ++i) {
        pref[i] = (i == 0 ? 0 : pref[i - 1]) + arr[i].second;
    }

    vector<int> deltas(n);
    for (int i = n - 1; i >= 0; --i) {
        deltas[i] = arr[i].first - pref[i];
        if (i + 1 < n) {
            deltas[i] = min(deltas[i], deltas[i + 1]);
        }
    }

    for (auto q: qrr) {
        int idx = lower_bound(all(arr), make_pair(q + 1, (int)0)) - arr.begin();
        int window = INF;
        if (idx > 0) {
            window = q - pref[idx - 1];
        }
        if (idx < n) {
            window = min(window, deltas[idx]);
        }
        cout << lower_bound(all(pref2), window + 1) - pref2.begin() << " ";
    }
    cout << "\n";
}


signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    // rifstream cin("../test.txt");

    int test_cnt = 1;
    cin >> test_cnt;

    while (test_cnt--) {
        solve();
    }
}