#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <cstdint>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i,n) for(int i = 0; i < int(n); i++)
#define fore(i,l,n) for(int i = l; i < int(n); i++)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define endl '\n'

void solve()
{
	int n; cin >> n;
	vector<int> a(n);
	forn(i, n) cin >> a[i];
	vector<int> b(n);
	iota(all(b), 1);
	vector<pair<int, int>> ans;
	forn(i, n)
	{
		int x = a[i];
		int ind = -1;
		forn(j, n)
		{
			if (b[j] == x)
			{
				for (int e = j + 1; e < n; e++)
					ans.pb({ b[e], x });
				ind = j;
				break;
			}
		}
		b.erase(b.begin() + ind);
		b.pb(x);
	}
	cout << ans.size() << endl;
	forn(i, ans.size()) cout << ans[i].first << ' ' << ans[i].second << endl;
}


int32_t main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	
	int tests = 1;
	// cin >> tests;

	while (tests--)
		solve();
}