#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <utility>
#include <numeric>

#define all(e) (e).begin(), (e).end()

using namespace std;

typedef long long ll;

int solve() {
    int n, m, q;
    cin >> n >> m >> q;
    struct T {
        int a;
        ll d;
    };
    vector<T> ts(n);
    for (auto &i : ts) {
        cin >> i.a;
    }
    for (auto &i : ts) {
        cin >> i.d;
    }
    vector<ll> l(m);
    for (auto &i : l) {
        cin >> i;
    }
    vector<ll> pref_l(m + 1);
    for (int i = 0; i < m; i++) {
        pref_l[i + 1] = pref_l[i] + l[i];
    }
    sort(all(ts), [&](auto a, auto b) { return a.d < b.d; });
    ll when = LLONG_MAX;
    vector<ll> wh(n);
    for (int i = n - 1; i >= 0; i--) {
        when = min(when, ts[i].d) - ts[i].a;
        wh[i] = when;
    }
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + ts[i].a;
    }
    while (q--) {
        ll tk;
        cin >> tk;
        int pos = upper_bound(all(wh), tk) - wh.begin() - 1;
        ll left = tk;
        if (pos >= 0) {
            ll time = pref[pos];
            time += min(tk, wh[pos] + ts[pos].a) - wh[pos];
            left -= time;
        }
        auto res = upper_bound(all(pref_l), left) - pref_l.begin() - 1;
        cout << res << " ";
    }
    cout << "\n";

    return 0;
}

int main() {
#ifdef LOCAL
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
