#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define endl '\n'
#define ll long long
#define sz(a) int32_t(a.size())
//#define int long long

const int N = 3e5 + 100;
const int M = 20;
const int mod = 1e9 + 7;
const int inf = 1e9 + 7;

vector < pair < string, string > > a;
vector < int > g[N];
vector < int > order;
int u[N], pos[N];

void DFS(int v) {
    u[v] = 1;
    for (auto to : g[v]) {
        if (!u[to]) DFS(to);
    }
    order.pb(v);
}


int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    int n;
    cin >> n;
    int st = 0;
    int ut = 0;
    for (int i = 0; i < n; i++) {
        string s, ver;
        cin >> s >> ver;
        a.pb({s, ver});
        if (ver == "true") {
            if (s == "set") st++;
            else ut++;
        }
    }
    int m;
    cin >> m;
    vector < pair < int, int > > e;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        g[x].pb(y);
        e.pb({x, y});
    }

    if (!(st == 0 && ut == 0) && !(st == 1 && ut == 0) && !(st == 1 && ut == 1)) {
        cout << -1;
        return 0;
    }

    if (st == 0 && ut == 0) {
        for (int i = 0; i < n; i++) {
            if (!(a[i].F == "unset" && a[i].S == "false")) {
                cout << -1;
                return 0;
            }
        }
        for (int i = 0; i < n; i++)
            if (!u[i]) DFS(i);
        reverse(order.begin(), order.end());
        for (auto to : order) {
            cout << to + 1 << " ";
        }
        return 0;
    }

    if (st == 1 && ut == 0) {
        for (int i = 0; i < n; i++) {
            if (u[i]) continue;
            if (a[i].F == "set" && a[i].S == "false") DFS(i);
        }
        for (int i = 0; i < n; i++) {
            if (u[i]) continue;
            if (a[i].F == "set" && a[i].S == "true") DFS(i);
        }
        for (int i = 0; i < n; i++) {
            if (u[i]) continue;
            if (a[i].F == "unset" && a[i].S == "false") DFS(i);
        }
        reverse(order.begin(), order.end());

        for (int i = 0; i < n; i++)
            pos[order[i]] = i;

        for (auto to : e) {
            if (pos[to.F] > pos[to.S]) {
                cout << -1;
                return 0;
            }
        }

        int flag = 0;
        for (auto to : order) {
            if (a[to].F == "set" && a[to].S == "true") flag = 1;
            if (flag && a[to].F == "unset") {
                cout << -1;
                return 0;
            }
        }

        for (auto to : order) {
            cout << to + 1 << " ";
        }

        return 0;
    }

    for (int i = 0; i < n; i++) {
        if (a[i].F == "unset" && a[i].S == "false") continue;
        if (u[i]) continue;
        DFS(i);
    }
    for (int i = 0; i < n; i++) {
        if (u[i]) continue;
        if (a[i].F == "unset" && a[i].S == "false") DFS(i);
    }
    reverse(order.begin(), order.end());

    vector < int > pref, suf, res;
    int flag = 0;
    for (auto to : order) {
        if (!(a[to].F == "unset" && a[to].S == "false")) {
            flag = 1;
            continue;
        }
        if (a[to].F != "unset") continue;
        if (flag) suf.pb(to);
        else pref.pb(to);
    }

    for (auto to : pref)
        res.pb(to);

    for (int i = 0; i < n; i++) {
        if (a[i].F == "set" && a[i].S == "true") {
            res.pb(i);
            break;
        }
    }

    order.clear();
    for (int i = 0; i < n; i++)
        u[i] = 0;
    for (int i = 0; i < n; i++) {
        if (!u[i] && a[i].F == "set" && a[i].S == "false") DFS(i);
    }
    reverse(order.begin(), order.end());
    for (auto to : order)
        if (a[to].F == "set" && a[to].S == "false") res.pb(to);
    for (int i = 0; i < n; i++) {
        if (a[i].F == "unset" && a[i].S == "true") {
            res.pb(i);
            break;
        }
    }
    for (auto to : suf)
        res.pb(to);

    order = res;


    if (sz(order) != n) {
        cout << -1;
        return 0;
    }

    for (int i = 0; i < n; i++)
        pos[order[i]] = i;
    for (auto to : e) {
        if (pos[to.F] > pos[to.S]) {
            cout << -1;
            return 0;
        }
    }

    flag = 0;
    for (auto to : order) {
        if (a[to].F == "set" && a[to].S == "true") { flag = 1; continue; }
        if (flag == 0 && !(a[to].F == "unset" && a[to].S == "false")) {
            cout << -1;
            return 0;
        }
        if (a[to].F == "unset" && a[to].S == "true") { flag = 2; continue; }
        if (flag == 1 && !(a[to].F == "set" && a[to].S == "false")) {
            cout << -1;
            return 0;
        }
        if (flag == 2 && !(a[to].F == "unset" && a[to].S == "false")) {
            cout << -1;
            return 0;
        }
    }

    for (auto to : order) {
        cout << to + 1 << " ";
    }
}
