#include <bits/stdc++.h>

using namespace std;

string add(string a, string b) {
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    while (a.size() < b.size()) a += '0';
    while (b.size() < a.size()) b += '0';
    a += '0';
    b += '0';
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());

    int ost = 0;
    string c(a.size(), '0');
    for (int i = a.size() - 1; i >= 0; i--) {
        int x = a[i] + b[i] - '0'*2 + ost;
        c[i] = x % 10 + '0';
        ost = x / 10;
    }
    while (c[0] == '0' && c.size() > 1) c.erase(0, 1);
    return c;
}

string sub(string a, string b) {
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    while (a.size() < b.size()) a += '0';
    while (b.size() < a.size()) b += '0';
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    int neg = 0;
    if (a < b){
        neg = 1;
        swap(a, b);
    }
    int ost = 0;
    string c(a.size(), '0');
    for (int i = a.size() - 1; i >= 0; i--) {
        int x = (a[i] - '0') - (b[i] - '0') - ost;
        if (x < 0) ost = 1, x += 10;
        else ost = 0;
        c[i] = x + '0';
    }
    while (c[0] == '0' && c.size() > 1) c.erase(0, 1);
    if (neg == 1) c = "-" + c;
    return c;
}

string ADD(string a, string b) {
    if (a[0] == '-' && b[0] == '-') {
        return '-' + add(a.substr(1), b.substr(1));
    } else if (a[0] != '-' && b[0] != '-') {
        return add(a, b);
    } else if (a[0] != '-' && b[0] == '-') {
        return sub(a, b);
    } else if (a[0] == '-' && b[0] != '-') {
        return sub(b, a);
    }
}

string SUB(string a, string b) {
    if (a[0] != '-' && b[0] != '-') {
        return sub(a, b);
    } else if (a[0] == '-' && b[0] == '-') {
        return sub(b, a);
    } else if (a[0] != '-' && b[0] == '-') {
        return add(a, b);
    } else if (a[0] == '-' && b[0] != '-') {
        return '-' + add(a.substr(1), b);
    }
}

void to_op(string s, vector<string> & a, vector<string> & b, vector<char> & a2, vector<char> & b2) {
    a.clear();
    b.clear();
    a2.clear();
    b2.clear();

    bool sec = false;
    string x = "";
    for (int i = 0; i < s.size(); i++) {
        if (!isdigit(s[i])) {
            if (!sec) a.push_back(x);
            else b.push_back(x);
            x = "";
            if (s[i] == '=') sec = true;
            else if (!sec) a2.push_back(s[i]);
            else b2.push_back(s[i]);
        } else x += s[i];
    }
    b.push_back(x);

    assert(a.size() - 1 == a2.size());
    assert(b.size() - 1 == b2.size());

    /*
    for (int i = 0; i < a.size(); i++) {
        if (i) cout << a2[i - 1];
        cout << a[i];
    }
    cout << "=";
    for (int i = 0 ;i < b.size(); i++) {
        if (i) cout << b2[i - 1];
        cout << b[i];
    }
    cout << "\n";*/
}

long long calc(const vector<string> & a, const vector<char> & a2) {
    assert(a.size() - 1 == a2.size());
    long long res = stoll(a[0]);
    for (int i = 1; i < a.size(); i++) {
        if (a2[i - 1] == '+') {
            res += stoll(a[i]);
        } else {
            res -= stoll(a[i]);
        }
    }
    return res;
}

int main() {
    string s;
    cin >> s;

    vector<string> a, b;
    vector<char> a2, b2;

    to_op(s, a, b, a2, b2);

    long long ff = calc(a, a2);
    long long ss = calc(b, b2);

    if (ff == ss) {
        cout << "Correct\n";
        return 0;
    }

    for (int i = 0; i < s.size(); i++) {
        string str = s;
        for (int j = i; j + 1 < str.size(); j++) {
            swap(str[j], str[j + 1]);

            int check = 1;
            if (str.size() > 1 && str[0] == '0' && isdigit(str[1])) check = 0;
            for (int k = 0; k + 1 < str.size(); k++) {
                if (str.size() && !isdigit(str[k]) && !isdigit(str[k + 1])) {
                    check = 0;
                    break;
                }
                if (str[0] == '0') {
                    check = 0;
                    break;
                }
                if (k + 2 < str.size() && !isdigit(str[k]) && str[k + 1] == '0' && isdigit(str[k + 2])) {
                    check = 0;
                    break;
                }
            }
            if (!isdigit(str[0]) || !isdigit(str.back())) check = 0;

            if (!check) continue;

            to_op(str, a, b, a2, b2);

            for (int i = 0; i < a.size(); i++) {
                if (a[i].size() > 10) {
                    check = 0;
                    break;
                }
            }
            for (int i = 0; i < b.size(); i++) {
                if (b[i].size() > 10) {
                    check = 0;
                    break;
                }
            }

            if (!check) continue;

            long long ff = calc(a, a2);
            long long ss = calc(b, b2);

            if (ff == ss) {
                cout << str << "\n";
                return 0;
            }
        }
        str = s;
        for (int j = i; j > 0; j--) {
            swap(str[j], str[j - 1]);

            int check = 1;
            if (str.size() > 1 && str[0] == '0' && isdigit(str[1])) check = 0;
            for (int k = 0; k + 1 < str.size(); k++) {
                if (str.size() && !isdigit(str[k]) && !isdigit(str[k + 1])) {
                    check = 0;
                    break;
                }
                if (k + 2 < str.size() && !isdigit(str[k]) && str[k + 1] == '0' && isdigit(str[k + 2])) {
                    check = 0;
                    break;
                }
            }
            if (!isdigit(str[0]) || !isdigit(str.back())) check = 0;
            if (!check) continue;

            to_op(str, a, b, a2, b2);

            for (int i = 0; i < a.size(); i++) {
                if (a[i].size() > 10) {
                    check = 0;
                    break;
                }
            }
            for (int i = 0; i < b.size(); i++) {
                if (b[i].size() > 10) {
                    check = 0;
                    break;
                }
            }

            if (!check) continue;

            long long ff = calc(a, a2);
            long long ss = calc(b, b2);
            if (ff == ss) {
                cout << str << "\n";
                return 0;
            }
        }
    }

    cout << "Impossible\n";

    return 0;
}
/*
1
6
#....#
###..#
*/
