#include <bits/stdc++.h>

#define ll long long
#define pl pair<ll,ll>
#define vl vector<ll>
#define all(a) a.begin(), a.end()

using namespace std;


const ll N = (1<<12) - 1;
uint16_t bitmem[N];

char hexcodes[16];

string to_hex(uint16_t n) {
    string res = "";
    while (n) {
        res += hexcodes[n & 15];
        n >>= 4;
    }
    while (res.size() < 4) res += "0";
    reverse(all(res));
    return res;
}

void solve() {
    for (ll i = 0; i < 10; i++) hexcodes[i] = '0' + i;
    for (ll i = 0; i < 6; i++) hexcodes[10+i] = 'a' + i;

    ll x; cin >> x;
    vl const_words(2);
    bitmem[49] = 0b0010;
    for (ll i = 0; i < 16; i++) {
        ll off = i * 3;
        bitmem[off + 0] = 0xfff0 + i;
        bitmem[off + 1] = (48 + i) << 4;
        bitmem[off + 2] = off + 3;
    }

    for (ll i = 0; i < 16; i++) {
        ll off = i * 3 + 48;
        bitmem[off + 0] = (96 << 4);
        bitmem[off + 1] = 112 << 4;
        bitmem[off + 2] = off + 3;
    }

    for (ll i = 0; i < 16; i++) {
        ll off = 96 + i;
        ll bit = (x >> i) & 1;
        bitmem[off] = (bit ? 2 : 1);
    }

    bitmem[95] = 112;
    bitmem[112] = 115 << 4;
    bitmem[113] = 0xfff0;
    bitmem[114] = 125;

    bitmem[115] = 0x0001;

    // Terminator
    bitmem[125] = 0;
    bitmem[126] = 0;
    bitmem[127] = 125;

    // ll x; cin >> x;
    // vl const_words(2);
    // const_words[0] = (49 << 4) | 0;
    // const_words[1] = (49 << 4) | 1;
    // bitmem[49] = 0b0010;
    // for (ll i = 0; i < 16; i++) {
    //     ll off = i * 3;
    //     bitmem[off + 0] = const_words[x >> i & 1];
    //     bitmem[off + 1] = 0xfff0 + i;
    //     bitmem[off + 2] = off + 3;
    // }
    // bitmem[48] = 50;
    // bitmem[52] = 52;

    for (ll i = 0; i <= 150; i++) cerr << i << " -> " << "(" << bitmem[i] << ": " << (bitmem[i] >> 4) << ", " << (bitmem[i] & 15) << ")" << '\n';
    for (ll i = 0; i <= 150; i++) cout << to_hex(bitmem[i]) << ' ';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) solve();
}