#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;
#define long long long

void solve()
{
	long n, m, q;
	cin >> n >> m >> q;

	vector<pair<long, long>> ord;

	vector<long> a(n), d(n);

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	for (int i = 0; i < n; i++)
	{
		cin >> d[i];
	}

	for (int i = 0; i < n; i++)
	{
		ord.push_back({d[i], a[i]});
	}

	sort(ord.begin(), ord.end());

	vector<long> l(m);

	for (int i = 0; i < m; i++)
	{
		cin >> l[i];
	}

	vector<long> sufMin(n + 1, 1e18);
	vector<long> delta(n);
	long sm = 0;

	for (int i = 0; i < ord.size(); i++)
	{
		sm += ord[i].second;

		delta[i] = ord[i].first - sm;
	}

	for (int i = (long)ord.size() - 1; i >= 0; i--)
	{
		sufMin[i] = min(sufMin[i + 1], delta[i]);
	}

	vector<long> timeSeries;

	long smCur = 0;
	long serie = 0;
	long curT = 0;

	for (int i = 0; i <= n; i++)
	{
		if (i == n)
		{
			while (serie < m)
			{
				smCur += l[serie];
				serie++;
				timeSeries.push_back(curT + smCur);
			}
		}
		else
		{
			while (serie < m && smCur + l[serie] <= sufMin[i])
			{
				smCur += l[serie];
				serie++;
				timeSeries.push_back(curT + smCur);
			}

			curT += ord[i].second;
		}
	}

	for (int i = 0; i < q; i++)
	{
		long tm;
		cin >> tm;

		long ub = upper_bound(timeSeries.begin(), timeSeries.end(), tm) - timeSeries.begin();

		cout << ub << ' ';
	}

	cout << '\n';
}

int main()
{
	long t;
	cin >> t;

	for (int i = 1; i <= t; i++)
	{
		solve();
	}
}
