from copy import copy, deepcopy

color = 0


def dfs(data, i, j):
    global color
    count = 1
    color += 1
    data[j][i] = color

    for j1 in range(2):
        for i1 in range(i, min(i + 2, len(data[0]))):
            if data[j1][i1] == '.':
                count += dfs(data, i1, j1)
            elif data[j1][i1] == '#':
                break

    return count


def get_ans(n, data):
    f_counts = 0
    for j in range(2):
        for i in range(n):
            if data[j][i] == '#':
                continue

            if data[j][i] == '.':
                count = dfs(data, i, j)
                f_counts += count
                if count % 2 != 0:
                    return None
    if f_counts == 0:
        return 12
    return 12


def main():
    t = int(input())
    global color

    for _ in range(t):
        color = 0
        n = int(input())
        data = [list(input()), list(input())]
        data2 = deepcopy(data)

        squares = []
        for i in range(n - 1):
            if data[0][i] == data[0][i + 1] == data[1][i] == data[1][i + 1] == '.':
                squares.append(i)

        f = False
        f_counts = 0
        for j in range(2):
            for i in range(n):
                if data[j][i] == '#':
                    continue

                if data[j][i] == '.':
                    count = dfs(data, i, j)
                    f_counts += count
                    if count % 2 != 0:
                        print('None')
                        f = True
                        break
            if f:
                break
        if f:
            continue

        if f_counts == 0:
            print('Unique')
            continue

        f = True
        for i in squares:
            data1 = deepcopy(data2)
            data1[0] = data1[0][:i] + ["#", "#"] + data1[0][i + 2:]
            data1[1] = data1[1][:i] + ["#", "#"] + data1[1][i + 2:]

            ans = get_ans(len(data1[0]), data1)
            if ans is not None:
                print('Multiple')
                f = False
                break
        if f:
            print('Unique')


if __name__ == '__main__':
    main()
# 4
# 10
# #.......##
# ##..#.##..
# 6
# ...#..
# ..#...
# 8
# ........
# ........
# 3
# ###
# ###
