#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <pair <int, int>> ans;

    vector <int> cur(n);
    for (int i = 0; i < n; ++i) {
        cur[i] = i + 1;
    }
    
    auto make_oper = [&](int ind) {
        swap(cur[ind], cur[ind + 1]);
        ans.emplace_back(cur[ind], cur[ind + 1]);
    };

    for (int cnt = n - 1; cnt >= 0; --cnt) {
        int ind = 0;
        for (int oper = 0; oper < cnt; ++oper) {
            make_oper(ind);
            ind++;
        }
    }

    for (int pos = 0; pos < n; ++pos) {
        for (int ind = pos; ind < n; ++ind) {
            if (cur[ind] == a[pos]) {
                for (int j = ind - 1; j >= pos; --j) {
                    make_oper(j);
                }
                break;
            }
        }
    }

    cout << ans.size() << "\n";
    for (auto i : ans) {
        cout << i.first << " " << i.second << "\n";
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}