#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define int ll

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}

const int INF = 1e17;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector <pair <int, int>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].second;
    for (int i = 0; i < n; ++i) cin >> a[i].first;
    sort(all(a));
    vector <int> suf_max(n + 1, -INF);
    vector <int> psum(n + 1);
    for (int i = 0; i < n; ++i) psum[i + 1] = psum[i] + a[i].second;
    for (int i = n - 1; i >= 0; --i) {
        suf_max[i] = max(suf_max[i + 1], psum[i + 1] - a[i].first);
    }

    vector <int> ser_lens(m);
    for (int i = 0; i < m; ++i) cin >> ser_lens[i];

    int task_ind = 0;
    int ser_ind = 0;

    vector <int> series_mom;

    int cur_time = 0;

    auto check_bad = [&](int tm, int tsk_ind, int sr_ind) {
        return suf_max[tsk_ind] + tm - psum[tsk_ind] > 0;
    };

    if (check_bad(0, 0, 0)) {
        while (q--) {
            int x;
            cin >> x;
            cout << "0 ";
        }
        cout << "\n";
        return;
    }

    while (ser_ind < m) {
        if (check_bad(cur_time + ser_lens[ser_ind], task_ind, ser_ind + 1)) {
            cur_time += a[task_ind].second;
            ++task_ind;
        } else {
            series_mom.push_back(cur_time + ser_lens[ser_ind]);
            cur_time += ser_lens[ser_ind];
            ++ser_ind;
        }
    }   

    while (q--) {
        int x;
        cin >> x;
        auto it = lower_bound(all(series_mom), x + 1);
        cout << it - series_mom.begin() << " ";
    }
    cout << "\n";
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}