#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pr;

#define all(v) v.begin(), v.end()

mt19937_64 rnd(228);
const ll maxn = 2e5;



vector<vector<ll>> graph(maxn);
vector<bool> used(maxn);
vector<ll> order;

void solve() {
    int n;
    cin >> n;

    vector<string> s(2);
    cin >> s[0] >> s[1];
    s[0] += '#';
    s[1] += '#';

    bool multi = false;
    for (int i = 0; i != n; ++i) {
        int j = 0;
        if (s[j][i] == '#' && s[j + 1][i + 1] == '#' && s[j + 1][i] == '.') {
            cout << "None" << endl;
            return;
        }
        
        if (s[j][i + 1] == '#' && s[j + 1][i] == '#' && s[j][i] == '.') {
            cout << "None" << endl;
            return;
        }

        if (s[j][i] == '.' && s[j + 1][i] == '.' && s[j][i + 1] == '.' && s[j + 1][i + 1] == '.') {
            multi = true;
        }

        if (s[j][i] == '.' && s[j + 1][i] == '.') {
            s[j][i] = '#';
            s[j + 1][i] = '#';
        }

        if (s[j][i] == '.' && s[j][i + 1] == '.') {
            s[j][i] = '#';
            s[j][i + 1] = '#';
        }

        if (s[j + 1][i] == '.' && s[j + 1][i + 1] == '.') {
            s[j + 1][i] = '#';
            s[j + 1][i + 1] = '#';
        }
    }

    if (multi) {
        cout << "Multiple" << endl;
    } else {
        cout << "Unique" << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int t;
    cin >> t;

    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}