#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <unordered_map>
#include <algorithm>
#include <stdlib.h>
#include <stdio.h>

//#define int long long
#define ll long long

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> c(n);
    for(int i = 0; i < n; i++){
        cin >> c[i];
        c[i]--;
    }

    vector<pair<int, int>> changes;
    vector<bool> used(n);
    for(int i = n-1; i >= 0; i--){
        for(int j = c[i] - 1; j >= 0; j--){
            if(!used[j]){
                changes.push_back({c[i], j});
            }
        }
        for(int j = n-1; j > i; j--){
            changes.push_back({c[i], c[j]});
        }

        used[c[i]] = true;
    }

    cout << changes.size() << "\n";
    for(pair<int, int> p : changes){
        cout << p.first + 1 << " " << p.second + 1 << "\n";
    }
}

int main() {
    std:ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    for(int i = 0; i < t; i++){
        solve();
    }
    return 0;
}
