#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <algorithm>
#include <stdlib.h>
#include <stdio.h>

//#define int long long
#define ll long long

using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<pair<int, int>> vertex(n);
    for(int i = 0; i < n; i++){
        string s1, s2;
        if(s1 == "set" && s2 == "true"){
            vertex[i] = {0, 1};
        }
        if(s1 == "set" && s2 == "false"){
            vertex[i] = {1, 1};
        }
        if(s1 == "unset" && s2 == "true"){
            vertex[i] = {1, 0};
        }
        if(s1 == "unset" && s2 == "false"){
            vertex[i] = {0, 0};
        }
    }

    vector<vector<int>> nodes(n);
    vector<vector<int>> parent(n);

    int m;
    cin >> m;
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        nodes[u].push_back(v);
        parent[v].push_back(u);
    }

    queue<int> t;
    queue<int> f;
    vector<bool> used(n);

    for(int i = 0; i < n; i++){
        if(parent[i].size() == 0){
            if(vertex[i].first == 0){
                f.push(i);
            }else{
                t.push(i);
            }
        }
    }

    int curr = 0;
    vector<int> res;
    while(!t.empty() || !f.empty()){
        int el = 0;
        if(curr == 0){
            if(f.empty()) {
                cout << -1;
                return;
            }
            el = f.front();
            f.pop();
        }else{
            if(t.empty()) {
                cout << -1;
                return;
            }
            el = t.front();
            t.pop();
        }
        res.push_back(el);
        for(int node : nodes[el]){
            if(vertex[node].first == 0){
                f.push(node);
            }else{
                t.push(node);
            }
        }
        curr = vertex[el].second;
    }

    for(int i : res){
        cout << i + 1 << " ";
    }
}

int main() {
    std:ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    for(int i = 0; i < t; i++){
        solve();
    }
    return 0;
}
