#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    ll n, m, q;
    cin >> n >> m >> q;

    vector<pair<ll, ll>> a(n);
    for(int i=0;i<n;i++) {
        cin >> a[i].second;
    }
    for(int i=0;i<n;i++) {
        cin >> a[i].first;
    }
    vector<ll> s(m);
    for(int i=0;i<m;i++)
        cin >> s[i];

    sort(a.begin(), a.end());

    for(int i=1;i<n;i++) {
        a[i].second += a[i-1].second;
    }

    while(q--) {
        ll t;
        cin >> t;

        ll free = t;
        for(int i=0;i<n;i++) {
            free = min(free, a[i].first - a[i].second);
        }

        ll sum = 0;
        ll cnt = 0;

        for(int i=0;i<m;i++) {
            if (sum + s[i] > free) break;
            sum += s[i];
            cnt++;
        }
        cout << cnt << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}