#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    ll n, m, q;
    cin >> n >> m >> q;

    vector<pair<ll, ll>> a(n);
    for(int i=0;i<n;i++) {
        cin >> a[i].second;
    }
    for(int i=0;i<n;i++) {
        cin >> a[i].first;
    }
    vector<ll> s(m);
    for(int i=0;i<m;i++)
        cin >> s[i];

    sort(a.begin(), a.end());

    for(int i=1;i<n;i++) {
        a[i].second += a[i-1].second;
    }

    vector<ll> d(n + 1, 8e18);
    vector<ll> mn(n + 1, 0);

    for(int i=n-1;i>=0;i--) {
        d[i] = min(d[i + 1], a[i].first - a[i].second);
        mn[i] = max(mn[i + 1], a[i].second);
    }

    vector<ll> pref(n + 1, 0);

    for(int i=1;i<=m;i++) {
        pref[i] = pref[i-1] + s[i-1];
    }

    while(q--) {
        ll t;
        cin >> t;


        int l = 0, r = n - 1;

        while(l < r) {
            ll mid = (l + r) / 2;
            if (a[mid].first >= t) r = mid;
            else l = mid + 1;
        }

        ll free = max(t - mn[l], d[l]);

        ll sum = 0;
        ll cnt = 0;

        l = 0, r = m;
        while(l < r) {
            ll mid = (l + r) / 2;
            if (pref[mid] >= free) r = mid;
            else l = mid + 1;
        }

        cout << l << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}