#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <string>

#define ll long long;
#define nl "\n";

using namespace std;

long long expr(string& exp) {
	long long res = 0;
	long long currnum = 0;
	long long currsign = 1;
	long long n = exp.length();
	for (long long i = 0; i < n; i++) {
		if (exp[i] == '+' || exp[i] == '-') {
			res += currnum * currsign;
			currnum = 0;
			currsign = exp[i] == '-' ? -1 : 1;
		}
		else {
			currnum = currnum * 10 + (exp[i] - '0');
		}
	}
	res += currnum * currsign;
	return res;
}

bool isok(string& s) {
	long long n = s.length();
	long long ind;
	for (long long i = 0; i < n; i++) {
		if (s[i] == '=') {
			ind = i;
			break;
		}
	}
	string s1 = "", s2 = "";
	for (long long i = 0; i < ind; i++) {
		s1 += s[i];
	}
	for (long long i = ind + 1; i < n; i++) {
		s2 += s[i];
	}
	return expr(s1) == expr(s2);
}

bool check(vector<string> v, int x, int y) {
	if (y % 2 == 0 && x + 1 < v[0].size()) {
		if (v[y][x] = '.' && v[y + 1][x] == '.' && v[y + 1][x + 1] == '.' && v[y][x + 1] == '.') {
			return true;
		}
	}
	return false;
}



signed main()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;

		vector<string> v(2);
		for (int i = 0; i < 2; i++) {
			cin >> v[i];
		}
		bool flag = false;
		bool res = true;
		for (int x = 0; x < n; x++) {
			for (int y = 0; y < 2; y++) {
				if (v[y][x] == '#') {
					continue;
				}
				if (y % 2 == 0) {
					flag = flag || check(v, x, y);

					if (v[y + 1][x] == '.') {
						v[y][x] = '#';
						v[y + 1][x] = '#';
					}
					else if (x + 1 < n && v[y][x + 1] == '.') {
						v[y][x + 1] = '#';
						v[y][x] = '#';
					}
					else {
						res = false;
						break;
					}
				}
				else {
					if (x < n && v[y][x + 1] == '.') {
						v[y][x] = '#';
						v[y][x + 1] = '#';
					}
					else {
						res = false;
						break;
					}
				}
			}
		}

		if (res) {
			if (flag) {
				cout << "Multiple";
			}
			else {
				cout << "Unique";
			}
		}
		else {
			cout << "None";
		}
		cout << endl;
	}

	return 0;
}