#include <bits/stdc++.h>
using namespace std;

long long convert(string s)
{
    long long k = 1;
    long long res = 0;
    for (int i = 1; i <= (int) s.size(); i++) {
        res += k * (s[(int)s.size() - i] - '0');
        k *= 10;
    }
    return res;
}

long long convert_ex(string s, int j)
{
    long long k = 1;
    long long res = 0;
    for (int i = 1; i <= (int) s.size(); i++) {
        if ((int)s.size() - i == j) continue;
        res += k * (s[(int)s.size() - i] - '0');
        k *= 10;
    }
    return res;
}

long long convert_inc(string s, int j, int c)
{
    long long k = 1;
    long long res = 0;
    for (int i = 1; i <= (int) s.size(); i++) {
        if ((int)s.size() - i == j) {
            res += k * c;
            k *= 10;
            res += k * (s[(int)s.size() - i] - '0');
            k *= 10;
        }
        else {
            res += k * (s[(int)s.size() - i] - '0');
            k *= 10;
        }
    }
    if (j == (int) s.size()) {
        res = k * c + res;
    }
    return res;
}

long long convert_inc_ex(string s, int u, int j, int c)
{
    long long k = 1;
    long long res = 0;
    for (int i = 1; i <= (int) s.size(); i++) {
        if ((int)s.size() - i == j) {
            res += k * c;
            k *= 10;
            if ((int)s.size() - i == u) continue;
            res += k * (s[(int)s.size() - i] - '0');
            k *= 10;
        }
        else {
            if ((int)s.size() - i == u) continue;
            res += k * (s[(int)s.size() - i] - '0');
            k *= 10;
        }
    }
    if (j == (int) s.size()) {
        res = k * c + res;
    }
    return res;
}

int main()
{
    string s;
    cin >> s;
    string ex1 = "", ex2 = "";
    bool eqf = false;
    for (int i = 0; i < (int) s.size(); i++)
    {
        if (s[i] == '=') eqf = true;
        else if (!eqf) ex1 += s[i];
        else ex2 += s[i];
    }
    vector<string> exp1, exp2;
    vector<int> coef1, coef2;
    string tmp = "";
    coef1.push_back(1);
    for (int i = 0; i < (int) ex1.size(); i++)
    {
        if (ex1[i] == '-' || ex1[i] == '+') {
            exp1.push_back(tmp);
            coef1.push_back(ex1[i] == '+' ? 1 : -1);
            tmp = "";
        }
        else tmp += ex1[i];
    }
    exp1.push_back(tmp);
    tmp = "";
    coef2.push_back(1);
    for (int i = 0; i < (int) ex2.size(); i++)
    {
        if (ex2[i] == '-' || ex2[i] == '+') {
            exp2.push_back(tmp);
            coef2.push_back(ex2[i] == '+' ? 1 : -1);
            tmp = "";
        }
        else tmp += ex2[i];
    }
    exp2.push_back(tmp);
    vector<long long> exp1_i, exp2_i;
    for (int i = 0; i < (int) exp1.size(); i++)
    {
        exp1_i.push_back(convert(exp1[i]));
    }
    for (int i = 0; i < (int) exp2.size(); i++)
    {
        exp2_i.push_back(convert(exp2[i]));
    }
    long long cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < (int) exp1_i.size(); i++) {
        cnt1 += exp1_i[i] * coef1[i];
    }
    for (int i = 0; i < (int) exp2_i.size(); i++) {
        cnt2 += exp2_i[i] * coef2[i];
    }
    if (cnt1 == cnt2) {
        cout << "Correct";
    }
    else {
        for (int i = 0; i < (int) exp1_i.size(); i++) {
            if ((int) exp1[i].size() == 1) continue;
            for (int j = 0; j < (int) exp1_i.size(); j++) {
                if ((int)exp1[j].size() == 10 && i != j) continue;
                for (int u = 0; u < (int) exp1[i].size(); u++) {
                    if (u == 0 && (int) exp1[i].size() > 2 && exp1[i][1] == '0')
                        continue;
                    if (u == 0 && (int) exp1[i].size() == 2 && exp1[i][1] == '0' && i == j)
                        continue;
                    int c = exp1[i][u] - '0';
                    for (int v = 0; v <= (int) exp1[j].size(); v++) {
                        if (exp1_i[j] == 0 && v == 0) continue;
                        if (c == 0 && v == (int) exp1[j].size()) continue;
                        long long cnt3 = cnt1, newn1 = 0, newn2 = 0;
                        if (i == j) {
                            if (u == v) continue;
                            cnt3 -= exp1_i[i] * coef1[i];
                            newn1 = convert_inc_ex(exp1[i], u, v, c);
                            cnt3 += newn1 * coef1[i];
                        }
                        else {
                            newn1 = convert_ex(exp1[i], u);
                            newn2 = convert_inc(exp1[j], v, c);
                            cnt3 -= exp1_i[i] * coef1[i];
                            cnt3 += newn1 * coef1[i];
                            cnt3 -= exp1_i[j] * coef1[j];
                            cnt3 += newn2 * coef1[j];
                        }
                        if (cnt3 == cnt2) {
                            for (int _i = 0; _i < (int) exp1.size(); _i++) {
                                if (_i  > 0) {
                                    if (coef1[_i]>0) cout << '+';
                                    else cout << '-';
                                }
                                if (i == _i) cout << newn1;
                                else if (_i == j) cout << newn2;
                                else cout << exp1[_i];
                            }
                            cout << '=';
                            for (int _i = 0; _i < (int) exp2.size(); _i++) {
                                if (_i > 0) {
                                    if (coef2[_i]>0) cout << '+';
                                    else cout << '-';
                                }
                                cout << exp2[_i];
                            }
                            return 0;
                        }
                    }
                }
            }
        }
        for (int i = 0; i < (int) exp1_i.size(); i++) {
            if ((int) exp1[i].size() == 1) continue;
            for (int j = 0; j < (int) exp2_i.size(); j++) {
                if ((int)exp2[j].size() == 10) continue;
                for (int u = 0; u < (int) exp1[i].size(); u++) {
                    if (u == 0 && (int) exp1[i].size() > 2 && exp1[i][1] == '0')
                        continue;
                    int c = exp1[i][u] - '0';
                    for (int v = 0; v <= (int) exp2[j].size(); v++) {
                        if (exp2_i[j] == 0 && v == 0) continue;
                        if (c == 0 && v == (int) exp2[j].size()) continue;
                        long long cnt3 = cnt1, cnt4 = cnt2;
                        long long newn1 = convert_ex(exp1[i], u);
                        long long newn2 = convert_inc(exp2[j], v, c);
                        cnt3 -= exp1_i[i] * coef1[i];
                        cnt3 += newn1 * coef1[i];
                        cnt4 -= exp2_i[j] * coef2[j];
                        cnt4 += newn2 * coef2[j];
                        if (cnt3 == cnt4) {
                            for (int _i = 0; _i < (int) exp1.size(); _i++) {
                                if (_i > 0) {
                                    if (coef1[_i]>0) cout << '+';
                                    else cout << '-';
                                }
                                if (i == _i) cout << newn1;
                                else cout << exp1[_i];
                            }
                            cout << '=';
                            for (int _i = 0; _i < (int) exp2.size(); _i++) {
                                if (_i > 0) {
                                    if (coef2[_i]>0) cout << '+';
                                    else cout << '-';
                                }
                                if (_i == j) cout << newn2;
                                else cout << exp2[_i];
                            }
                            return 0;
                        }
                    }
                }
            }
        }
        for (int i = 0; i < (int) exp2_i.size(); i++) {
            if ((int) exp2[i].size() == 1) continue;
            for (int j = 0; j < (int) exp2_i.size(); j++) {
                if ((int)exp2[j].size() == 10 && i != j) continue;
                for (int u = 0; u < (int) exp2[i].size(); u++) {
                    if (u == 0 && (int) exp2[i].size() > 2 && exp2[i][1] == '0')
                        continue;
                    if (u == 0 && (int) exp2[i].size() == 2 && exp2[i][1] == '0' && i == j)
                        continue;
                    int c = exp2[i][u] - '0';
                    for (int v = 0; v <= (int) exp2[j].size(); v++) {
                        if (exp2_i[j] == 0 && v == 0) continue;
                        if (c == 0 && v == (int) exp2[j].size()) continue;
                        long long cnt3 = cnt2, newn1 = 0, newn2 = 0;
                        if (i == j) {
                            if (u == v) continue;
                            cnt3 -= exp2_i[i] * coef2[i];
                            newn1 = convert_inc_ex(exp2[i], u, v, c);
                            cnt3 += newn1 * coef2[i];
                        }
                        else {
                            newn1 = convert_ex(exp2[i], u);
                            newn2 = convert_inc(exp2[j], v, c);
                            cnt3 -= exp2_i[i] * coef2[i];
                            cnt3 += newn1 * coef2[i];
                            cnt3 -= exp2_i[j] * coef2[j];
                            cnt3 += newn2 * coef2[j];
                        }
                        if (cnt3 == cnt1) {
                            for (int _i = 0; _i < (int) exp1.size(); _i++) {
                                if (_i > 0) {
                                    if (coef1[_i]>0) cout << '+';
                                    else cout << '-';
                                }
                                cout << exp1[_i];
                            }
                            cout << '=';
                            for (int _i = 0; _i < (int) exp2.size(); _i++) {
                                if (_i > 0) {
                                    if (coef2[_i]>0) cout << '+';
                                    else cout << '-';
                                }
                                if (i == _i) cout << newn1;
                                else if (_i == j) cout << newn2;
                                else cout << exp2[_i];
                            }
                            return 0;
                        }
                    }
                }
            }
        }
        for (int i = 0; i < (int) exp2_i.size(); i++) {
            if ((int) exp2[i].size() == 1) continue;
            for (int j = 0; j < (int) exp1_i.size(); j++) {
                if ((int)exp1[j].size() == 10) continue;
                for (int u = 0; u < (int) exp2[i].size(); u++) {
                    if (u == 0 && (int) exp2[i].size() > 2 && exp2[i][1] == '0')
                        continue;
                    int c = exp2[i][u] - '0';
                    for (int v = 0; v <= (int) exp1[j].size(); v++) {
                        if (exp1_i[j] == 0 && v == 0) continue;
                        if (c == 0 && v == (int) exp1[j].size()) continue;
                        long long cnt3 = cnt2, cnt4 = cnt1;
                        long long newn1 = convert_ex(exp2[i], u);
                        long long newn2 = convert_inc(exp1[j], v, c);
                        cnt3 -= exp2_i[i] * coef2[i];
                        cnt3 += newn1 * coef2[i];
                        cnt4 -= exp1_i[j] * coef1[j];
                        cnt4 += newn2 * coef1[j];
                        if (cnt3 == cnt4) {
                            for (int _i = 0; _i < (int) exp1.size(); _i++) {
                                if (_i > 0) {
                                    if (coef1[_i]>0) cout << '+';
                                    else cout << '-';
                                }
                                if (_i == j) cout << newn2;
                                else cout << exp1[_i];
                            }
                            cout << '=';
                            for (int _i = 0; _i < (int) exp2.size(); _i++) {
                                if (_i > 0) {
                                    if (coef2[_i]>0) cout << '+';
                                    else cout << '-';
                                }
                                if (i == _i) cout << newn1;
                                else cout << exp2[_i];
                            }
                            return 0;
                        }
                    }
                }
            }
        }
        cout << "Impossible";
    }
}
