import sys

def print(*a, end="\n", sep=" ", flush=False, file=sys.stdout):
    file.write(sep.join([str(i) for i in a]) + end)
    if flush: file.flush()

def input():
    return sys.stdin.readline().rstrip()

def dfs(x):
    used[x] = 1
    for i in g[x]:
        if used[i] == 1:
            print(-1)
            exit(0)
        elif used[i] == 0:
            dfs(i)
    used[x] = 2
    if x == n or ops[x] == (False, False):
        tsort.append(x)
    else:
        tsort1.append(x)

n = int(input())
ops = [input().split() for i in range(n)]
ops = [(i[0]=="set", i[1]=="true") for i in ops]

g = [[] for i in range(n+1)]
m = int(input())
for j in range(m):
    a, b = map(int,input().split())
    a -= 1
    b -= 1
    if ops[a] == (False, False) and ops[b] != (False, False):
        g[a].append(n)
    elif ops[a] != (False, False) and ops[b] == (False, False):
        g[n].append(b)
    g[a].append(b)

if ops.count((True, True)) == 2 or ops.count((False, True)) == 2:
    print(-1)
    exit(0)
if ops.count((True, True)) + ops.count((False, True)) == 2:
    itru = ops.index((True, True))
    ifls = ops.index((False, True))
    g[itru].append(ifls)
    for i in range(n):
        if ops[i] == (True, False):
            g[i].append(ifls)
            g[itru].append(i)
elif ops.count((True, True)) == 1:
    itru = ops.index((True, True))
    for i in range(n):
        if ops[i] == (True, False):
            g[itru].append(i)
        elif ops[i] == (False, False):
            g[i].append(n)
elif ops.count((False, True)) == 1:
    print(-1)
    exit(0)
else:
    if any(map(lambda x: x[0], ops)):
        print(-1)
        exit(0)

used = [0] * (n+1)
tsort = []
tsort1 = []
for i in range(n+1):
    if not used[i]:
        dfs(i)
for i in tsort[::-1]:
    if i == n:
        for j in tsort1[::-1]:
            print(j+1, end=" ")
        continue
    print(i+1, end=" ")
