#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

using ll = long long;
using vll = vector<ll>;
using p = pair<ll, ll>;
using vp = vector<p>;

struct task {
	ll i;
	ll a;
	ll d;
};

int main()
{
	ll ttt;
	cin >> ttt;

	while (ttt--) {
		ll n, m, q;
		cin >> n >> m >> q;

		vll a(n), d(n), l(m);
		vp t(q);
		vll pa(n + 1), pd(n + 1), pp(n + 1), pl(m + 1);
		vector<task> tasks(n);

		for (int i = 0; i < n; ++i)
			cin >> tasks[i].a, tasks[i].i = i;

		for (int i = 0; i < n; ++i)
			cin >> tasks[i].d;

		sort(tasks.begin(), tasks.end(), [](task a, task b) {return a.d < b.d; });

		for (int i = 0; i < n; ++i)
			pa[i + 1] = pa[i] + tasks[i].a,
			pd[i + 1] = pd[i] + tasks[i].d,
			d[i] = tasks[i].d;

		for (int i = 0; i < m; ++i)
			cin >> l[i], pl[i + 1] = pl[i] + l[i];

		for (int i = 0; i < q; ++i)
			cin >> t[i].first, t[i].second = i;

		ll minp = 1e9;
		for (int i = n - 1; i >= 0; --i) {
			minp = min(minp, pd[i + 1] - pa[i + 1]);
			pp[i] = minp + pa[i] - pd[i];
		}

		sort(t.begin(), t.end(), [](p l, p r) {return l.first < r.first; });
		pp[n] = 1e16;
		vll ans(q);

		for (int i = 0; i < q; ++i) {
			int di = upper_bound(d.begin(), d.end(), t[i].first) - d.begin();
			ll ft = min(t[i].first, pp[di]) - pa[di];
			ll y = upper_bound(pl.begin(), pl.end(), ft) - pl.begin();
			ans[t[i].second] = y - 1;
		}

		for (int i = 0; i < q; ++i)
			cout << ans[i] << " ";

		cout << "\n";
	}
}

/*
2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10

*/
