#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define int long long

signed main() {
    int tt;
    cin >> tt;
    while (tt--){
        int n, m, q;
        cin >> n >> m >> q;

        vector<int> a(n);
        for (int i = 0; i < n; ++i){
            cin >> a[i];
        }

        vector<pair<int, int>> d(n);
        for (int i = 0; i < n; ++i){
            int x;
            cin >> x;

            d[i] = {x, i};
        }

        vector<int> l(m);
        for (int i = 0; i < m; ++i){
            cin >> l[i];
        }

        vector<pair<int, int>> t(q);
        vector<int> aa(q);
        for (int i = 0; i < q; ++i){
            cin >> aa[i];
            t[i] = {aa[i], i};
        }
        sort(t.begin(), t.end());

        sort(d.begin(), d.end());

        int cur = d[n - 1].first;

        vector<int> dead(n);

        for (int i = n - 1; i >= 0; --i){
            int task_dead = d[i].first;
            int task_num = d[i].second;
            int task_len = a[task_num];
            cur = min(cur - task_len, task_dead - task_len);
            dead[task_num] = cur;
        }

        int serial_i = 0;

        int cur_time = 0;

        vector<int> que(m + 1);
        que[0] = 0;
        for (int i = 0; i < n; ++i){
            int task_num = d[i].second;
            while (serial_i < m and cur_time + l[serial_i] <= dead[task_num]){
                cur_time += l[serial_i];
                que[serial_i + 1] = cur_time;
                serial_i++;

            }
            cur_time += a[task_num];
        }
        for (;serial_i < m; ++serial_i){
            cur_time += l[serial_i];
            que[serial_i + 1] = cur_time;
        }

        int u = 0;

        map<int, int> ans;
        for (int i = 0; i < q; ++i){
            while (u <= m and que[u] <= t[i].first)
                u++;
            ans[t[i].first] = u - 1;
        }

        for (auto x : aa){
            cout << ans[x] << ' ';
        }


        cout << "\n";
    }
}
