#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <iterator>
#include <set>
#include <map>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
	ll n;
	cin >> n;
	vector<ll> vcur(n), vend(n);
	for (ll i = 0; i < n; i++)
	{
		cin >> vend[i];
		vcur[i] = i + 1;
	}
	vector<pair<ll, ll>> ans;
	for (ll i = n - 1; i > -1; i--)
	{
		ll cur = 0;
		for (ll j = 0; j < n; j++)
		{
			if (vcur[j] == vend[i]) {
				cur = j;
				break;
			}
		}
		for (ll j = cur - 1; j > -1; j--)
		{
			ans.push_back({ vcur[j + 1], vcur[j] });
			swap(vcur[j], vcur[j + 1]);
		}
	}
	cout << ans.size() << "\n";
	for (ll i = 0; i < ans.size(); i++)
	{
		cout << ans[i].first << " " << ans[i].second << "\n";
	}
}

void multitest() {
	ll t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

void fastIO();

void preCalc();

int main()
{
#ifdef _OVERMINDS
	freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
#endif // _OVERMINDS
	preCalc();
	multitest();
}

void preCalc() {

}

void fastIO() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}
