#include <bits/stdc++.h>

using namespace std;

pair<bool, long long> get(string s) {
    if (s[0] == '+' || s[0] == '-') {
        return {false, 0};
    }
    bool ok = true;
    long long res = 0;
    int it = 0, n = (int) s.size();
    while (it < n) {
        long long g = 1;
        if (s[it] == '+') {
            it++;
        } else if (s[it] == '-') {
            it++;
            g = -1;
        } else if (it != 0) {
            return {false, 0};
        }
        if (it == n || s[it] == '+' || s[it] == '-') {
            ok = false;
            return {ok, 0};
        }
        long long f = 0;
        int was = it;
        bool fl = s[it] == '0';
        while (it < n && s[it] >= '0' && s[it] <= '9') {
            f = f * 10 + s[it] - '0';
            it++;
        }
        if (it - was >= 11) {
            return {false, 0};
        }
        if (fl && it - was > 1) {
            return {false, 0};
        }
        res += f * g;
    }
    return {ok, res};
}

bool check(string s) {
    int pos = 0, n = s.size();
    while (pos < n && s[pos] != '=') pos++;
//    if (pos == n) assert(false);
    if (pos == 0 || pos == n - 1 || pos == n) {
        return false;
    }
    auto [x, X] = get(s.substr(0, pos));
    auto [y, Y] = get(s.substr(pos + 1));
    if (x && y && X == Y) return true;
    return false;
}

void solve() {
    string s;
    cin >> s;
    if (check(s)) {
        cout << "Correct\n";
        return;
    }
    int n = (int) s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] >= '0' && s[i] <= '9') {
            string t = s;
            t.erase(t.begin() + i);
            for (int j = 0; j < n; j++) {
                string st = t;
                st.insert(st.begin() + j, s[i]);
                if (check(st)) {
                    cout << st;
                    return;
                }
            }
        }
    }
    cout << "Impossible\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
