#include <iostream>
#include <vector>

#define ll long long

using namespace std;

int main() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);

    vector<pair<ll, ll>> ans;
    for(int i = 0; i < n; i++){
        cin >> a[i];
        b[i] = i + 1;
    }

    vector<vector<bool>> swapped(n + 1, vector<bool>(n + 1));

    vector<pair<ll, ll>> tmp_ans;
    for(int number = 1; number <= n; number++) {
        ll pos = 0;
        for(; pos < n; pos++){
            if(a[pos] == number){
                break;
            }
        }

        tmp_ans = vector<pair<ll, ll>> ();

        for(;pos < n - number; pos++){
            swapped[a[pos]][a[pos + 1]] = true;
            swapped[a[pos + 1]][a[pos]] = true;

            tmp_ans.push_back(make_pair(number, a[pos + 1]));
            ll t = a[pos + 1];
            a[pos + 1] = a[pos];
            a[pos] = t;
        }

        for(int i = 0; i < tmp_ans.size(); i++){
            ans.push_back(tmp_ans[i]);
        }
    }


    for(int i = 0; i < n; i++){
        for(int j = 0; j < n - i - 1; j++){
            ans.push_back(make_pair(a[j], a[j + 1]));
            ll t = a[j];
            a[j] = a[j + 1];
            a[j + 1] = t;
        }
    }


    ans = vector<pair<ll, ll>>(ans.rbegin(), ans.rend());

    cout << ans.size() << endl;
    for(int i = 0; i < ans.size(); i++){
        cout << ans[i].first << " " << ans[i].second << endl;
    }

    return 0;
}
