#include <bits/stdc++.h>

using namespace std;
#define ll long long

const int MAXN = 1e5 + 1;

vector<int> graph[MAXN];
vector<int> color(MAXN);
vector<int> top;
bool cycle = false;

void dfs(int v) {
    color[v] = 1;
    for (int u : graph[v]) {
        if (color[u] == 0) dfs(u);
        else if (color[u] == 1) cycle = true;
    }
    color[v] = 2;
    top.push_back(v);
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, x, y;
    string a, b;
    cin >> n;
    int two = -1, four = -1;
    vector<int> ones, threes;
    vector<int> op(n);
    bool ok = true;
    for (int i = 0; i < n; i++) {
        cin >> a >> b;
        if (a == "set" && b == "true") {
            if (two == -1) two = i;
            else ok = false;
            op[i] = 2;
        } else if (a == "unset" && b == "true") {
            if (four == -1) four = i;
            else ok = false;
            op[i] = 4;
        } else if (a == "set" && b == "false") {
            ones.push_back(i);
            op[i] = 1;
        } else if (a == "unset" && b == "false") {
            threes.push_back(i);
            op[i] = 3;
        }
    }

    cin >> m;
    for (int i = 0; i < m; i++) {
        cin >> x >> y;
        x--, y--;
        graph[x].push_back(y);
        if (op[x] == 3 && op[y] == 1 && two != -1)
            graph[x].push_back(two);
        if (op[x] == 1 && op[y] == 3) {
            if (four != -1) graph[four].push_back(y);
            else ok = false;
        }

        if (op[x] == 2 && op[y] == 3) {
            if (four != -1) graph[four].push_back(y);
            else ok = false;
        }
        if (op[x] == 3 && op[y] == 4 && two != -1)
            graph[x].push_back(two);
    }

    if (two == -1 && four == -1) {
        if (threes.size() != n) ok = false;
    } else if (two == -1 && four != -1) {
        ok = false;
        for (int one : ones) graph[one].push_back(four);
    } else if (two != -1 && four == -1) {
        for (int one : ones) graph[two].push_back(one);
    } else { // two != -1 && four != -1
        graph[two].push_back(four);
        for (int one : ones) graph[one].push_back(four);
        for (int one : ones) graph[two].push_back(one);
    }

    for (int x : threes)
        if (color[x] == 0) dfs(x);
    for (int i = 0; i < n; i++) {
        if (color[i] == 0) dfs(i);
    }
    reverse(top.begin(), top.end());

    if (cycle) ok = false;

    if (!ok) cout << -1;
    else for (int x : top) cout << x + 1 << " ";
}