#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e5;

set <int> vp[MAXN];

void solve(){
    int n;
    cin >> n;
    for(int i = 0; i < 2 * n; i++){
        vp[i].clear();
    }
    vector <string> vs;
    string s;
    cin >> s;
    vs.push_back(s);
    cin >> s;
    vs.push_back(s);
    vector <pair<int, int>> vv = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
    for(int i = 0; i < 2; i++){
        for(int j = 0; j < n; j++){
            for(auto [dx, dy]:vv){
                if(vs[i][j] == '.' && i + dx < 2 && i + dx >= 0 && j + dy >= 0 && j  + dy < n && vs[i + dx][j + dy] == '.'){
                    vp[i * n + j].insert((i + dx) * n + j + dy);
                }
            }
        }
    }
    set <pair<int, int>> sp;
    for(int i = 0; i < 2 * n; i++){
        if(vp[i].size()) {
            sp.insert({vp[i].size(), i});
        }
    }
    bool flag = 0;
    while(sp.size()){
        if(sp.begin()->first == 0){
            cout << "None";
            return;
        }
        if(sp.begin()->first == 1) {
            int from = sp.begin()->second;
            sp.erase(sp.begin());
            int to = *vp[from].begin();
            vs[from / n][from % n] = '#';
            vs[to / n][to % n] = '#';
            for (auto toto: vp[to]) {
                if (vs[toto / n][toto % n] == '.') {
                    sp.erase({vp[toto].size(), toto});
                    vp[toto].erase(to);
                    sp.insert({vp[toto].size(), toto});
                }
            }
            sp.erase({vp[to].size(), to});
        } else {
            flag = 1;
            int from = sp.begin()->second;
            sp.erase(sp.begin());
            sp.erase({vp[from + 1].size(), from + 1});
            sp.erase({vp[from + n + 1].size(), from + n + 1});
            sp.erase({vp[from + n].size(), from + n});
            vs[from / n][from % n] = '#';
            vs[from / n][from % n + 1] = '#';
            vs[from / n + 1][from % n] = '#';
            vs[from / n + 1][from % n + 1] = '#';
            for (auto toto: vp[from + 1]) {
                if (vs[toto / n][toto % n] == '.') {
                    sp.erase({vp[toto].size(), toto});
                    vp[toto].erase(from + 1);
                    sp.insert({vp[toto].size(), toto});
                }
            }
            for (auto toto: vp[from + n + 1]) {
                if (vs[toto / n][toto % n] == '.') {
                    sp.erase({vp[toto].size(), toto});
                    vp[toto].erase(from + n + 1);
                    sp.insert({vp[toto].size(), toto});
                }
            }
        }
    }
    cout << (flag ? "Multiple" : "Unique");
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        solve();
        cout << endl;
    }
}