#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define pi pair<int, int>
#define fi first
#define se second
const int N = 1e6;
#define dbg(x) cout << #x << ": " << x << endl;
int a[N];
vector<int> vec[N], pos[N];
int good[N], bad[N], used[N], best[N];
void dfs(int v, int p = -1) {
    int cnt = 0;
    for (int u: vec[v]) {
        if (u != p) {
            dfs(u, v);
            cnt++;
        }
    }
    if (cnt == 0) {
        good[v] = 0;
        bad[v] = 0;
    } else {
        int sum = 0;
        for (int u: vec[v]) {
            if (u == p) continue;
            sum += bad[u];
        }
        int mx = -1, arg = -1;
        for (int u: vec[v]) {
            if (u == p) continue;
            int cur = sum - bad[u] + good[u] + 1;
            if (cur > mx) {
                mx = cur;
                arg = u;
            }
        }
        best[v] = arg;
        bad[v] = mx;
        good[v] = sum;
    }
}
vector<pi> edges;
void restore_answer(int v, int p = -1, bool can = 1) {
    if (can) {
        if (good[v] > bad[v] || best[v] == -1) {
            for (int u: vec[v]) {
                if (u == p) continue;
                restore_answer(u, v, 1);
            }
        } else {
            edges.pb({v, best[v]});
            for (int u: vec[v]) {
                if (u == p) continue;
                if (u == best[v]) restore_answer(u, v, 0);
                else restore_answer(u, v, 1);
            }
        }
    } else {
        for (int u: vec[v]) {
            if (u == p) continue;
            restore_answer(u, v, 1);
        }
    }
}
vector<int> g[N];
vector<int> bebrik;
vector<pi> nasos;
void smart(int v) {
    used[v] = 1;
    bool good = 0;
    for (int u: g[v]) {
        if (used[u]) continue;
        nasos.pb({v, u});
        smart(u);
        good = 1;
    }
    if (!good) {
        bebrik.pb(v);
    }
}
vector<pi> res;
set<int> adj[N];
bool used2[N];
set<int> st[N];
void compute(const vector<pi>& edges) {
    if (edges.size() == 1) {
        return;
    }
    vector<pi> reb;
    vector<int> ver;
    for (auto [a, b]: edges) {
        ver.pb(a);
        ver.pb(b);
        if (::a[a] != ::a[b]) reb.pb({a, b});
        st[::a[a]].clear();
        st[::a[b]].clear();
    }
    for (int i = 0; i < reb.size(); i++) {
        auto [v1, v2] = reb[i];
        st[a[v1]].insert(i);
        st[a[v2]].insert(i);
    }
    if (reb.size() == 0) return;
    int cur_edge = 0;
    while (1) {
        auto [v1, v2] = reb[cur_edge];
        if (a[v1] == a[v2]) break;
        int other = *st[a[v1]].begin() == cur_edge ? *st[a[v1]].rbegin() : *st[a[v1]].begin();
        if (a[reb[other].fi] == a[v1]) swap(reb[other].fi, reb[other].se);
        int nv = reb[other].se;
        res.pb({v2, nv});
        st[a[v2]].erase(cur_edge);
        st[a[v2]].insert(other);
        st[a[nv]].erase(other);
        st[a[nv]].insert(cur_edge);
        swap(reb[cur_edge].se, reb[other].se);
        cur_edge = other;
        swap(reb[cur_edge].fi, reb[cur_edge].se);
    }
}
void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < 2 * n; i++) cin >> a[i], a[i]--, vec[i].clear(), g[i].clear();
    res.clear();
    for (int i = 0; i < 2 * n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        vec[a].pb(b);
        vec[b].pb(a);
    }
    for (int i = 0; i < 2 * n; i++) {
        used[i] = 0;
        bad[i] = 0;
        good[i] = 0;
        best[i] = -1;
    }
    dfs(0);
    edges.clear();
    restore_answer(0);
//    cout << edges.size() << "\n";
    for (int i = 0; i < 2 * n; i++) used[i] = 0;
    for (int i = 0; i < n; i++) pos[i].clear();
    for (int i = 0; i < 2 * n; i++) {
        pos[a[i]].pb(i);
    }
    for (int i = 0; i < n; i++) {
        int v1 = pos[i][0];
        int v2 = pos[i][1];
        g[v1].pb(v2);
        g[v2].pb(v1);
    }
    vector<bool> buka(2*n, 0);
    for (auto [a, b] : edges) {
        g[a].pb(b);
        g[b].pb(a);
        buka[a] = buka[b] = 1;
    }
    for (int i = 0; i < 2 * n; i++) used[i] = 0;
    for (int i = 0; i < 2 * n; i++) {
        if (!used[i] && buka[i]) {
            nasos.clear();
            bebrik.clear();
            smart(i);
            if (bebrik.size() == 1) bebrik.pb(i);
            assert(bebrik.size() == 2);
            if (bebrik.size()) {
                nasos.pb({bebrik[0], bebrik[1]});
            }
            compute(nasos);
        }
    }
    cout << res.size() << "\n";
    for (auto [v, u] : res) cout << v + 1 << " " << u + 1 << "\n";
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        solve();
//        cout << "\n";
    }
}