#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <bits/stdc++.h>
#define int long long

#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()

using namespace std;
const int inf = 1e18 + 1e9;

int32_t main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, q, m;
        cin >> n >> m >> q;
        vector<pair<int, int> > a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i].second;
        }
        for (int i = 0; i < n; i++) {
            cin >> a[i].first;
        }
        vector<int> episode(m);
        for (int i = 0; i < m; i++) {
            cin >> episode[i];
        }
        sort(all(a));
        vector<int> a_pref(n + 1);
        for (int i = 0; i < n; i++) {
            a_pref[i + 1] = a_pref[i] + a[i].second;
        }
        vector<int> possible_delay(n + 1);
        possible_delay[n] = inf;
        for (int i = n - 1; i >= 0; i--) {
            possible_delay[i] = min(possible_delay[i + 1], a[i].first - a_pref[i + 1]);
        }
        vector<int> l_pref(m + 1);
        for (int i = 0; i < m; i++) {
            l_pref[i + 1] = l_pref[i] + episode[i];
        }
        for (int query = 0; query < q; query++) {
            int p;
            cin >> p;
            int l = 0, r = m + 1; // l - possible to take, r - impossible to take
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                int l1 = -1, r1 = n; // l1 - impossible to insert in, r1 - possible to insert in
                while (l1 + 1 < r1) {
                    int mid1 = (l1 + r1) / 2;
                    if (possible_delay[mid1] >= l_pref[mid]) {
                        r1 = mid1;
                    } else {
                        l1 = mid1;
                    }
                }
                if (a_pref[r1] + l_pref[mid] <= p) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            cout << l << " ";
        }
        cout << '\n';
    }
}