#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <bits/stdc++.h>


#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()
#define pb push_back
#define F first
#define S second

using namespace std;
const int inf = 1e18 + 1e9;

const int KL=4e5+10;


int n,a[KL];
vector<int> adj[KL];
set<int> pos[KL];

int dp[KL][2],nxt[KL];

void solveTS(){
    cin>>n;
    n*=2;
    for(int i=0;i<n;i++){
        pos[i].clear();
        adj[i].clear();
    }
    for(int i=0;i<n;i++){
        cin>>a[i];
        a[i]--;
    }
    for(int i=1;i<n;i++){
        int u,v;
        cin>>u>>v;
        u--,v--;
        adj[u].pb(v);
        adj[v].pb(u);
    }

    for(int i=0;i<n;i++){
        dp[i][0]=dp[i][1]=-1;
        nxt[i]=-1;
    }

    function<int(int,int,int)> dfs=[&](int node,int pr,int used){
        if(dp[node][used]!=-1)return dp[node][used];
        if(used==1){
            int path=0;
            for(auto v:adj[node]){
                if(v==pr)continue;
                path+=dfs(v,node,0);
            }
            return dp[node][used]=path;
        }
        else {
            int sum0=0;
            for(auto v:adj[node]){
                if(v==pr)continue;
                sum0+=dfs(v,node,0);
            }
            int mx=sum0;
            for(auto v:adj[node]){
                if(v==pr)continue;
                if(mx<1+dfs(v,node,1)+sum0-dfs(v,node,0)){
                    mx=1+dfs(v,node,1)+sum0-dfs(v,node,0);
                    nxt[node]=v;
                }
            }
            return dp[node][used]=mx;
        }
    };

    int max_matching=dfs(0,0,0);
//    cout<<"Max matching: "<<max_matching<<"\n";

    set<pair<int,int>> matching;
    vector<int> matched(n,-1);
    function<void(int,int,int)> build=[&](int node,int pr,int used){
        if(used==1){
            for(auto v:adj[node]){
                if(v==pr)continue;
                build(v,node,0);
            }
        }
        else {
            if(nxt[node]!=-1){
                int x=min(node,nxt[node]);
                int y=max(node,nxt[node]);
                matching.insert({x,y});
                matched[x]=y;
                matched[y]=x;
            }
            for(auto v:adj[node]){
                if(v==pr)continue;
                if(v==nxt[node])build(v,node,1);
                else build(v,node,0);
            }
        }
    };
    build(0,0,0);
//    for(auto v:matching){
//        cout<<v.F+1<<" "<<v.S+1<<"\n";
//    }cout<<"\n";

    set<int> un_matched;
    vector<pair<int,int>> steps;
    for(int i=0;i<n;i++){
        pos[a[i]].insert(i);
    }
    for(int i=0;i<n;i++){
        if(matched[i]==-1){
            un_matched.insert(a[i]);
        }
    }
    auto other=[&](int color,int place){
        for(auto v:pos[color]){
            place^=v;
        }
        return place;
    };
    while(!matching.empty()){
        auto [x,y]=*matching.begin();
        matching.erase(matching.begin());
        if(a[x]==a[y])continue;
        int val=a[x];
        while(true){
            int o=other(val,x);
            un_matched.erase(val);
            steps.pb({y,o});
            pos[val].erase(o);
            pos[val].insert(y);
            pos[a[y]].erase(y);
            pos[a[y]].insert(o);
            swap(a[y],a[o]);
            if(matched[o]!=-1){
                x=o;
                val=a[o];
                y=matched[o];
                matching.erase({min(x,y),max(x,y)});
                if(a[x]==a[y])break;
            }
            else {
                un_matched.erase(a[o]);
                int oth=other(a[o],o);
                if(matched[oth]==-1){
                    break;
                }
                assert(!un_matched.empty());
                int clr=*un_matched.begin();
                un_matched.erase(un_matched.begin());

                int p=*pos[clr].begin();
                pos[clr].erase(p);
                pos[clr].insert(oth);
                pos[a[oth]].erase(oth);
                pos[a[oth]].insert(p);
                swap(a[oth],a[p]);
                x=oth;
                val=a[oth];
                y=matched[oth];
                matching.erase({min(x,y),max(x,y)});
                if (a[x] == a[y]) break;
            }

        }
    }
    cout<<steps.size()<<"\n";
    for(auto v:steps){
        cout<<v.F+1<<" "<<v.S+1<<"\n";
    }

}

int32_t main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif

    int TS;
    cin>>TS;
    while(TS--){
        solveTS();
    }

}