#include <bits/stdc++.h>

using namespace std;
using ll = long long ;
using ull = unsigned long long;
using ld = long double;
struct triple{
    ll first, second, third;
    auto operator<=>(const triple&) const = default;
};

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;

using pll = pair<ll,ll>;
using vll = vector<pll>;
using vvll = vector<vll>;

using vlll = vector<triple>;
using vvlll = vector<vlll>;

using vs = vector<string>;
using vld = vector<ld>;

#define fi first
#define se second
#define th third

#define X first
#define Y second
#define Z third

#define con continue
#define pb push_back
#define re return

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(x) (int)(x).size()

template <typename T>
inline void sort(T & v) {
    sort(all(v));
}

template <typename T>
inline void reverse(T & v) {
    reverse(all(v));
}

template <typename T>
inline void unique( T & v) {
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
}

template <typename T>
void smin(T& s, const T& ot) {
    s = min(s, ot);
}

template <typename T>
void smax(T& s, const T& ot) {
    s = max(s, ot);
}

template <typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.fi >> p.se; return in;
}

template <typename T>
istream& operator>>(istream &in, vector<T> &p) {
    for (auto &x : p) in >> x; return in;
}

template <typename T>
ostream& operator<<(ostream &ostr, const vector<T> &v) {
    for (const auto& el : v) cout << el << ' ';
    return ostr;
}

template <typename T1, typename T2>
ostream& operator<<(ostream &out, pair<T1, T2> &p) {
    out << p.fi << p.se; return out;
}

//template <typename T1, typename T2>
//ostream& operator<<(ostream &out, pair<T1, T2> &p) {
//    out << p.fi << p.se; return out;
//}

ll mask = (1 << 16) - 1;
vl mem(200);

vl go(16);
vl ba(16);

string to = "0123456789abcdef";
void print_mem() {
    ll c = 0;
    for (auto x : mem) {
        string s;
        for (int i = 0; i < 4; i++) {
            ll v = (x >> (i * 4)) & 15;
            s += to[v];
        }
        reverse(all(s));
        cout << s;

        if (c++ % 4 == 3) cout << "\n";
        else cout << " ";
    }
}


void solve() {
    ll x; cin >> x;
    ll w = (1 << 16) - 16;

    for (int i = 0; i < 16; i++) {
        go[i] = (i + 1) * 4;
        ba[i] = (i + 1) * 4 + 64;
    }

    ll bit0 = 2240;
    ll bit1 = 2241;
    mem[140] = 2;

    ll e0 = 132;
    mem[e0] = w;
    mem[e0 + 1] = bit0;
    mem[e0 + 2] = (1 << 12) - 1;

    ll e1 = 136;
    mem[e1] = w;
    mem[e1 + 1] = bit1;
    mem[e1 + 2] = (1 << 16) - 1;

    ll ne = 0;
    for (int i = 0; i < 16; i ++) {
        ll iw = ne;
        mem[iw] = w + i;
        mem[iw + 1] = (iw + 2) * 16 + 10;
        mem[iw + 2] = go[i];

        if (x & (1 << i)) {
            ne = go[i] ^ 64;
        } else {
            ne = go[i];
        }

        if (i == 15) {
            mem[iw] = mem[iw + 1] = 0;
            mem[iw + 2] = e1;
            break;
        }

        ll ne1 = ne ^ 64;
        mem[ne1] = mem[ne1 + 1] = 0;
        mem[ne1 + 2] = e0;
    }

    print_mem();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    // cin >> t;
    while(t--)
        solve();

    return 0;
}
