#include <bits/stdc++.h>

using namespace std;

int dfs(int v, vector<set<int>>& g, vector<int>& used) {
    int ans = 1;
    used[v] = true;
    for (auto x : g[v]) {
        if (!used[x]) {
            ans += dfs(x, g, used);
        }
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    //cout << n << endl;
    string a, b;
    cin >> a >> b;
    vector<set<int>> g(n + n);
    vector<int> used(n + n);
    for (int i = 1; i < n; ++i) {
        if (a[i] == '.' && a[i - 1] == '.') {
            g[i].insert(i - 1);
            g[i - 1].insert(i);
        }
    }
    for (int i = 1; i < n; ++i) {
        if (b[i] == '.' && b[i - 1] == '.') {
            g[i + n].insert(i - 1 + n);
            g[i - 1 + n].insert(i + n);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] == '.' && b[i] == '.') {
            g[i].insert(i + n);
            g[i + n].insert(i);
        }
    }
    set<pair<int, int>> non_empty_nod;
    n += n;
    for (int i = 0; i < n; ++i) {
        if (g[i].size()) {
            non_empty_nod.insert({g[i].size(), i});
            if (!used[i]) {
                int KAL = dfs(i, g, used);
                if (KAL % 2 == 1) {
                    cout << "None\n";
                    return;
                }
            }
        }
    }
    while (non_empty_nod.size()) {
        assert (non_empty_nod.begin()->first != 0);
        if (non_empty_nod.begin()->first != 1) {
            cout << "Multiple\n";
            return;
        }
//        for (auto [x, y] : non_empty_nod) {
//            cout << x << " sdf " << y << endl;
//        }
//        cout << endl << endl;
        auto tmp = non_empty_nod.begin()->second;
        non_empty_nod.erase(non_empty_nod.begin());
        for (auto to : g[tmp]) {
            non_empty_nod.erase({g[to].size(), to});
            for (auto it_s : g[to]) {
                if (it_s != tmp) {
                    non_empty_nod.erase({g[it_s].size(), it_s});
                    g[it_s].erase(to);
                    non_empty_nod.insert({g[it_s].size(), it_s});
                }
            }

        }
    }
    cout << "Unique\n";
}

int main() {
    //freopen("input.txt", "r", stdin);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    cout.flush();
}
