#include<iostream>
#include<cmath>
#include<vector>
#include<map>
using namespace std;
using pint = pair<int, int>;
#define pb push_back
#define fr first
#define sc second
#define ll long long 
#define vll vector<ll>
void solve() {
	ll n; cin >> n;

	vector<string> s(2);
	cin >> s[0] >> s[1];

	s[0].push_back('#');
	s[1].push_back('#');

	vector<vector<vll>> dp(n + 1, vector<vll>(2, vll(2, 0)));

	dp[0][s[0][0] == '#'][s[1][0] == '#'] = 1;

	for (ll i = 0; i < n; ++i) {
		bool check = true;
		for (ll fir = 0; fir <= 1; ++fir) {
			for (ll sec = 0; sec <= 1; ++sec) {
				if (!check) {
					continue;
				}
				ll nextfir = s[0][i + 1] == '#';
				ll nextsec = s[1][i + 1] == '#';

				if (!fir && !sec && !nextfir && !nextsec && dp[i][fir][sec]) {
					dp[i + 1][nextfir][nextsec] += dp[i][fir][sec];
					dp[i + 1][1][1] += dp[i][fir][sec];
					check = false;
				}
				if (!fir && !sec) {
					dp[i + 1][nextfir][nextsec] += dp[i][fir][sec];
								}
				if (fir && sec) {
					dp[i + 1][nextfir][nextsec] += dp[i][fir][sec];
				}
				
				if (!fir && sec && s[0][i + 1] == '.') {
					dp[i + 1][1][nextsec] += dp[i][fir][sec];
				}
				if (!sec && fir && s[1][i + 1] == '.') {
					dp[i + 1][nextfir][1] += dp[i][fir][sec];
				}
			}
		}
	}

	/*for (auto& i : dp) {
		cout << i[0][0] << ' ';
	}
	cout << '\n';
	for (auto& i : dp) {
		cout << i[0][1] << ' ';
	}
	cout << '\n';
	for (auto& i : dp) {
		cout << i[1][0] << ' ';
	}
	cout << '\n';
	for (auto& i : dp) {
		cout << i[1][1] << ' ';
	}
	cout << '\n';
	*/
	ll ans = dp[n][0][0] + dp[n][0][1] + dp[n][1][0] + dp[n][1][1];

	if (ans == 0) {
		cout << "None";
	}
	else if (ans == 1) {
		cout << "Unique";
	}
	else {
		cout << "Multiple";
	}

	cout << '\n';
}
int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);

	ll t; cin >> t;
	while (t--)
		solve();
}