#include<algorithm>
#include <iostream>
#include<sstream>
#include<string>
#include <cmath>
#include<cstdio>
#include<cstdint>
#include<deque>
#include<iomanip>
#include<iostream>
#include<list>
#include<map>
#include<set>
#include<stack>
#include<vector>
#include<unordered_map>
#include<unordered_set>
using namespace std;
typedef long long ll;
#define all(v) v.begin, v.end();
template <typename T> using vc = vector<T>;
using vi = vector<int>;
using vvi = vector<vi>;

void solve() {
	int n;
	cin >> n;
	int set_idx = -1, unset_idx = -1;
	vi ops(n + 1);
	vector<pair<int, int>> vp;
	for (int i = 0; i < n; i++) {
		string s, flag; cin >> s >> flag;
		if (flag == "true") {
			if (s == "set") {
				set_idx = i + 1;
			}
			if (s == "unset") {
				unset_idx = i + 1;
			}
		}
		else {
			
			if (s == "set") {
				ops[i] = 0;
				vp.push_back({ 0, i + 1 });
			}
			if (s == "unset") {
				ops[i] = 1;
				vp.push_back({ 1, i + 1 });
			}
		}
	}
	int m; cin >> m;
	vvi g(n + 1, vi());
	vvi inv_g(n + 1, vi());
	vi degrees(n + 1);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		g[a].push_back(b);
		inv_g[b].push_back(a);
	}
	for (int i = 1; i <= n; i++) {
		degrees[i] = inv_g[i].size();
	}
	set<pair<int, int>> _set;
	set<pair<int, int>> _unset;

	
	for (auto oper : vp) {
		int type = oper.first;
		int op_num = oper.second;
		if (type) {
			_unset.insert(make_pair(inv_g[op_num].size(), op_num));
		}
		else {
			_set.insert(make_pair(inv_g[op_num].size(), op_num));
		}
	}
	bool cur = false;
	vi ans;
	bool set_used = 0, unset_used = 0;
	while (_set.size() + _unset.size() + (!set_used) + (!unset_used) > 0) {
		if (!cur &&_unset.size() >= 1) {
			auto vx = *_unset.begin();
			if (vx.first == 0) {
				ans.push_back(vx.second);
				_unset.erase(_unset.begin());
				for (int to : g[vx.second]) {
					if (_set.find({ degrees[to], to }) != _set.end()) {
						_set.erase({ degrees[to], to });
						_set.insert({ degrees[to] - 1, to });
					}
					if (_unset.find({ degrees[to], to }) != _unset.end()) {
						_unset.erase({ degrees[to], to });
						_unset.insert({ degrees[to] - 1, to });
					}
					degrees[to]--;
				}
			}
			else {
				if (!set_used) {
					cur = true;
					set_used = true;
					ans.push_back(set_idx);
					for (int to : g[set_idx]) {
						if (_set.find({ degrees[to], to }) != _set.end()) {
							_set.erase({ degrees[to], to });
							_set.insert({ degrees[to] - 1, to });
						}
						if (_unset.find({ degrees[to], to }) != _unset.end()) {
							_unset.erase({ degrees[to], to });
							_unset.insert({ degrees[to] - 1, to });
						}
						degrees[to]--;
					}
				}
				else {
					cout << -1;
					return;
				}
			}
		}
		else if (cur && _set.size() >= 1) {
			auto vx = *_set.begin();
			if (vx.first == 0) {
				ans.push_back(vx.second);
				_set.erase(_set.begin());
				for (int to : g[vx.second]) {
					if (_set.find({ degrees[to], to }) != _set.end()) {
						_set.erase({ degrees[to], to });
						_set.insert({ degrees[to] - 1, to });
					}
					if (_unset.find({ degrees[to], to }) != _unset.end()) {
						_unset.erase({ degrees[to], to });
						_unset.insert({ degrees[to] - 1, to });
					}
					degrees[to]--;
				}
			}
			else {
				if (!unset_used) {
					ans.push_back(unset_idx);
					cur = false;
					unset_used = true;
					for (int to : g[unset_idx]) {
						if (_set.find({ degrees[to], to }) != _set.end()) {
							_set.erase({ degrees[to], to });
							_set.insert({ degrees[to] - 1, to });
						}
						if (_unset.find({ degrees[to], to }) != _unset.end()) {
							_unset.erase({ degrees[to], to });
							_unset.insert({ degrees[to] - 1, to });
						}
						degrees[to]--;
					}
				}
				else {
					cout << -1;
					return;
				}
			}
		}
		else {
			if (!cur && !set_used) {
				cur = true;
				set_used = true;
				ans.push_back(set_idx);
				for (int to : g[set_idx]) {
					if (_set.find({ degrees[to], to }) != _set.end()) {
						_set.erase({ degrees[to], to });
						_set.insert({ degrees[to] - 1, to });
					}
					if (_unset.find({ degrees[to], to }) != _unset.end()) {
						_unset.erase({ degrees[to], to });
						_unset.insert({ degrees[to] - 1, to });
					}
					degrees[to]--;
				}
			}
			else if (cur && !unset_used) {
				ans.push_back(unset_idx);
				cur = false;
				unset_used = true;
				for (int to : g[unset_idx]) {
					if (_set.find({ degrees[to], to }) != _set.end()) {
						_set.erase({ degrees[to], to });
						_set.insert({ degrees[to] - 1, to });
					}
					if (_unset.find({ degrees[to], to }) != _unset.end()) {
						_unset.erase({ degrees[to], to });
						_unset.insert({ degrees[to] - 1, to });
					}
					degrees[to]--;
				}
			}
			else {
				cout << -1;
				return;
			}
			
			
		}
	}

	for (int it : ans) {
		cout << it << " ";
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;

#ifdef _DEBUG 
	FILE* file = new FILE;
	freopen_s(&file, "../input.txt", "r", stdin);
#endif
	//cout << setprecision(10);
	//cout << fixed;
	//cin >> tests;
	while (tests--) { solve(); cout << "\n"; }
}

