#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int T;
    cin >> T;
    for (int t = 0; t < T; ++t) {
        int n, m, q;
        cin >> n >> m >> q;
        vector<pair<int, int>> tasks;
        for (int i = 0; i < n; ++i) {
            int len;
            cin >> len;
            tasks.push_back({0, len});
        }
        for (int i = 0; i < n; ++i) {
            int dead;
            cin >> dead;
            tasks[i].first = dead;
        }

        sort(tasks.begin(), tasks.end());
        vector<int> epis;
        for (int i = 0 ; i < m; ++i) {
            int len;
            cin >> len;
            epis.push_back(len);
        }

        vector<int> tests;
        for (int i = 0; i < q; ++i) {
            int time;
            cin >> time;
            tests.push_back(time);
        }

        int rtime = tasks[n-1].first; // last deadline
        vector<int> tstart(n, 0); // latest possible time to start task
        for (int i = n-1; i >= 0; --i) {
            rtime = min(rtime, tasks[i].first);
            rtime = rtime - tasks[i].second;
            tstart[i] = rtime;
        }

        vector<int> estart(m);
        int ltime = 0;
        int task_i = 0;
        for (int ep_i = 0; ep_i < m; ++ep_i) {
            if (ltime + epis[ep_i] <= tstart[task_i]) {
                // good
                estart[ep_i] = ltime;
                ltime += epis[ep_i];
            } else {
                tstart[task_i] = ltime;
                ltime += tasks[task_i].second;
                task_i += 1;
                ep_i -= 1; // повторить пихнуть эпизод
            }
        }

        for (int i = 0; i < q; ++i) {
            int tk = tests[i];

            int l = 0; 
            int r = m;
            while (r - l > 1) {
                int m = (r + l) / 2;
                if (estart[m] <= tk) l = m;
                else r = m;
            }
            cout << r << " ";
        }
        cout << endl;
    }
}