#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector<pair<string, string> > a(200200);
vector<vector<int> > g(200200);

queue<int> res[2][2];
vector<int> ans;
int inp[200200];

void Add(int x) {
    if (a[x].first == "unset" && a[x].second == "false") {
        res[0][0].push(x);
    }
    if (a[x].first == "unset" && a[x].second == "true") {
        res[1][0].push(x);
    }
    if (a[x].first == "set" && a[x].second == "false") {
        res[1][1].push(x);
    }
    if (a[x].first == "set" && a[x].second == "true") {
        res[0][1].push(x);
    }
}

void Apply(int x) {
    ans.push_back(x);
    for (auto to : g[x]) {
        inp[to]--;
        if (inp[to] == 0) {
            Add(to);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int f, f1;
        cin >> f >> f1;
        g[f].push_back(f1);
        inp[f1]++;
    }
    for (int i = 1; i <= n; i++) {
        if (inp[i] == 0) {
            Add(i);
        }
    }
    bool cur = false;
    while (!res[0][0].empty()) {
        int x = res[0][0].front();
        res[0][0].pop();
        cur = false;
        Apply(x);
    }
    if (cur == 0) {
        while (!res[0][1].empty()) {
            int x = res[0][1].front();
            res[0][1].pop();
            Apply(x);
            cur = 1;
        }
    }
    if (cur == 1) {
        while (!res[1][1].empty()) {
            int x = res[1][1].front();
            res[1][1].pop();
            Apply(x);
        }
    }
    if (cur == 1) {
        while (!res[1][0].empty()) {
            int x = res[1][0].front();
            res[1][0].pop();
            Apply(x);
            cur = 0;
        }
    }
    if (cur == 0) {
        while (!res[0][0].empty()) {
            int x = res[0][0].front();
            res[0][0].pop();
            Apply(x);
        }
    }

    if (ans.size() == n) {
        for (auto x : ans) {
            cout << x << " ";
        }
        return 0;
    }
    cout << -1 << endl;
    return 0;
}
