#define _GLIBCXX_DEBUG 1
#pragma gcc optimize ("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define rsort(a) sort(a, [&] (auto b, auto c) {return b > c;})
using ll = long long;
using ld = long double;
using ull = unsigned long long; 
const ll inf = 1e18;
const ll MOD = 998244353;

bool check_char(char x){
    if(x > '9' || x < '0'){
        return true;
    }
    return false;
}

long long get(string s){
    if(s.size() > 10){
        return -1;
    }
    if(s[0] == '0' && s.size() > 1){
        return -1;
    }
    long long answ = 0;
    for(auto to: s){
        answ *= 10;
        answ += to - '0';
    }
    return answ;
}
const int N = 1e6;
vector<char> v = {};
vector<ll> num = {};

bool fill(string s){
    string tmp = "";
    num = {};
    v = {};
    for(int i = 0; i < s.size(); i ++){
        auto to = s[i];
        if(!check_char(to)){
            tmp += to;
        }else{
            num.pb(get(tmp));
            if(get(tmp) == -1){
                return false;
            }
            v.pb(to);
            tmp = "";
        }
    } 
    num.pb(get(tmp));
    if(get(tmp) == -1){
        return false;
    }
    return true;
}
bool check(){
    ll answl = 0;
    ll answr = 0;
    int ind = 0;
    for(int i = 0; i < v.size(); i ++){
        if(v[i] == '='){
            ind = i;
            break;
        }
    }
    answl = num[0];
    for(int i = 0 ; i < ind; i ++){
        if(v[i] == '-'){
            answl -= num[i + 1];
        }else{
            answl += num[i + 1];
        }
    }
    answr = num[ind + 1];
    for(int i = ind + 1; i < v.size(); i ++){
        if(v[i] == '-'){
            answr -= num[i + 1];
        }else{
            answr += num[i + 1];
        }
    }
    return answl == answr;
}

signed main(){
    string s;
    cin >> s;
    fill(s);
    if(check()){
        cout << "Correct" << endl;
        return 0;
    }
    for(int i = 0; i < s.size(); i ++){
        if(check_char(s[i])){
            continue;
        }
        bool f1 = false;
        bool f2 = false;
        if(i > 0){
            if(!check_char(s[i - 1])){
                f1 = true;
            }
        }
        if(i < s.size() - 1){
            if(!check_char(s[i + 1])){
                f2 = true;
            }
        }
        if(f1 == false && f2 == false){
            continue;
        }
        for(int j = 0; j < s.size() + 1; j ++){
            if(i == j){
                continue;
            }
            string t = "";
            for(int k = 0; k < s.size() + 1; k ++){
                if(k == i){
                    continue;
                }
                if(k == j){
                    t += s[i];
                }
                if(k < s.size()){
                    t += s[k];
                }
            }
            auto tec = fill(t);
            if(tec == false){
                continue;
            }
            if(check()){
                cout << t;
                return 0;
            }
        }
    }
    cout << "Impossible";
}