#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
mt19937 engine;

void solve();

int used[200100][10];
int dp[200100][10];
string upper;
string down;
int n;
const int INF = 1e9;
int sch = 0;

int rec(int x, int prev) {
	if (x >= n)
		return (prev == 0);
	if (used[x][prev] == sch)
		return dp[x][prev];
	dp[x][prev] = 0;
	used[x][prev] = sch;
	int prevup = ((prev >> 1) & 1);
	int prevdown = (prev & 1);
	int curup = (upper[x] == '.');
	int curdown = (down[x] == '.');
	if (prevup + prevdown == 2) {
		if (curup + curdown == 2)
			return dp[x][prev] = min(INF, rec(x + 1, 0));
		else
			return dp[x][prev] = 0;
	}
	if (prevup == 1) {
		if (curup == 1)
			return dp[x][prev] = min(INF, rec(x + 1, curdown));
		else
			return dp[x][prev] = 0;
	}
	if (prevdown == 1) {
		if (curdown == 1)
			return dp[x][prev] = min(INF, rec(x + 1, curup << 1));
		else
			return dp[x][prev] = 0;
	}
	if (curdown && curup)
		dp[x][prev] += min(INF, rec(x + 1, 0));
	dp[x][prev] += min(INF, rec(x + 1, (curup << 1) + curdown));
	return dp[x][prev];
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	engine.seed(time(nullptr));

	int T = 1;
	cin >> T;
	while (T--) {
		sch++;
		solve();
	}
}

void solve() {
	cin >> n;
	cin >> upper;
	cin >> down;
	int res = rec(0, 0);
	if (res > 1)
		cout << "Multiple";
	else if (res == 1)
		cout << "Unique";
	else
		cout << "None";
	cout << '\n';
}