/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("tree-vectorize")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//*/
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define f first
#define s second
#define x first
#define y second

const int MAXN = 200'010;

int dp[MAXN][2][2];

void solve()
{
    int n;
    cin >> n;

    string a, b;
    cin >> a >> b;
    

    if (a[0] == '.' && b[0] == '.') dp[0][1][1] = 1;

    dp[0][a[0] == '#'][b[0] == '#'] = 1;


    for (int i = 1; i < n; ++i)
    {
        if (a[i] == '.' && b[i] == '.')
        {
            dp[i][1][1] = dp[i - 1][0][0] * 2;
            dp[i][1][1] += dp[i - 1][1][1];
            dp[i][1][0] = dp[i - 1][0][1];
            dp[i][0][1] = dp[i - 1][1][0];
        }

        if (a[i] == '.' && b[i] == '#')
        {
            dp[i][1][1] = dp[i - 1][0][1];
            dp[i][0][1] = dp[i - 1][1][1];
        }

        if (a[i] == '#' && b[i] == '.')
        {
            dp[i][1][1] = dp[i - 1][1][0];
            dp[i][1][0] = dp[i - 1][1][1];
        }

        if (a[i] == '#' && b[i] == '#')
        {
            dp[i][1][1] = dp[i - 1][1][1];
        }

        for (int q = 0; q < 2; ++q) {
            for (int p = 0; p < 2; ++p) dp[i][q][p] = min(dp[i][q][p], 2);
        }
    }

    if (dp[n - 1][1][1] == 0) {
        cout << "None" << endl;
    }

    if (dp[n - 1][1][1] == 1) {
        cout << "Unique" << endl;
    }

    if (dp[n - 1][1][1] == 2) {
        cout << "Multiple" << endl;
    }

    for (int i = 0; i < n ; ++i)
    for (int q = 0; q < 2; ++q) {
        for (int p = 0; p < 2; ++p) dp[i][q][p] = 0;
    }
}

int main()
{
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
   #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}