#include <bits/stdc++.h>
using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> c(n);
  for (int i = 0; i < n; i++) {
    cin >> c[i];
  }
  vector<pair<int, int>> ans;
  vector<int> order(n, 0);
  for (int i = 0; i < n; i++) {
    order[i] = i + 1;
  }
  vector<vector<bool>> was(n + 1, vector<bool>(n + 1, false));
  for (int i = 0; i < n; i++) {
    order[i] = i + 1;
  }
  for (int i = n - 1; i >= 0; i--) {
    int pos = -1;
    for (int j = 0; j < n; j++) {
      if (order[j] == c[i]) {
        pos = j;
        break;
      }
    }
    vector<pair<int, int>> candidates;
    for (int j = pos; j > 0; j--) {
      candidates.push_back({order[j], order[j - 1]});
      swap(order[j - 1], order[j]);
    }
    for (int j = 0; j < i; j++) {
      candidates.push_back({order[j + 1], order[j]});
      swap(order[j], order[j + 1]);
    }
    bool bad = false;
    for (auto [x, y] : candidates) {
      if (was[x][y]) {
        bad = true;
        break;
      }
    }
    if (bad) {
      if (i < pos) {
        for (int j = pos; j > i; j--) {
          ans.push_back({c[i], order[j - 1]});
          was[c[i]][order[j - 1]] = true;
          swap(order[j], order[j - 1]);
        }
      } else {
        for (int j = pos; j < i; j++) {
          ans.push_back({order[j + 1], c[i]});
          was[order[j + 1]][c[i]] = true;
          swap(order[j], order[j + 1]);
        }
      }
    } else {
      for (auto [x, y] : candidates) {
        ans.push_back({x, y});
        was[x][y] = true;
      }
    }
    candidates.clear();
    for (int j = i - 1; j >= 0; j--) {
      candidates.push_back({order[i], order[j]});
    }
    for (int j = 0; j < i; j++) {
      candidates.push_back({order[j], order[i]});
    }
    for (auto [x, y] : candidates) {
      if (was[x][y]) {
        candidates.clear();
        break;
      }
    }
    for (auto vl : candidates) {
      ans.push_back(vl);
      was[vl.first][vl.second] = true;
    }
  }
  cout << (int)ans.size() << '\n';
  for (auto el : ans)
    cout << el.first << " " << el.second << '\n';
}