#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

string to_hex_c(int t) {
    if (t < 10) return string(1, '0' + t);
    return string(1, 'a' + t - 10);
}

string to_hex(int t) {
    string res = "";
    for (int d = 0; d < 3; ++d) {
        res += to_hex_c(t & 15);
        t >>= 4;
    }
    reverse(res.begin(), res.end());
    return res;
}

signed main() {
    int x; cin >> x;
    vector<string> res((1 << 7), "0000");
    bool cur = 0;
    for (int i = 0; i < 16; ++i) {
        if (x & (1 << i)) {
            res[3 * i + cur * (1 << 6)] = "fff" + to_hex_c(i);
            res[3 * i + 1 + cur * (1 << 6)] = to_hex(3 * i + 2 + cur * (1 << 6)) + "6";
            res[3 * i + 2 + cur * (1 << 6)] = "0" + to_hex(3 * i + 3 + (1 << 6));
            res[3 * i + 3] = "0000";
            res[3 * i + 3 + 1] = "fff0";
            res[3 * i + 3 + 2] = "0fff";
            cur = true;
        } else {
            res[3 * i + cur * (1 << 6)] = "fff" + to_hex_c(i);
            res[3 * i + 1 + cur * (1 << 6)] = to_hex(3 * i + 2 + cur * (1 << 6)) + "6";
            res[3 * i + 2 + cur * (1 << 6)] = "0" + to_hex(3 * i + 3);
            res[3 * i + 3 + (1 << 6)] = "0000";
            res[3 * i + 3 + 1 + (1 << 6)] = "fff0";
            res[3 * i + 3 + 2 + (1 << 6)] = "0fff";
            cur = false;
        }
    }
    res[3 * 16 + cur * (1 << 6)] = "000f";
    res[3 * 16 + 1 + cur * (1 << 6)] = "fff0";
    res[3 * 16 + 2 + cur * (1 << 6)] = "0fff";
     
    for (int i = 0; i < (1 << 7); ++i) {
        cout << res[i] << ' ';
    } cout << '\n';
}