#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define F first
#define S second
#define endl '\n'

typedef long long ll;

#define int ll

using namespace std;

vector<vector<int>> g;

void coutAns(vector<int> &ans) {
    for(auto u : ans) {
        cout << u + 1 << ' ';
    }
}

bool checkOps(vector<int> &ops) {
    vector<int> cnt(4);
    for(auto u : ops) {
        cnt[u]++;
    }
    if(cnt[1] > 1 || cnt[2] > 1) {
        return false;
    }
    return true;
}

void solve() {
    int n; cin >> n;
    g.assign(n, vector<int>(0));

    vector<int> ops(n);
    for(int i = 0; i < n; i++) {
        string type, result;
        cin >> type >> result;
        int val = 0;
        if(type == "set" && result == "true") {
            val = 1;
        }
        if(type == "set" && result == "false") {
            val = 3;
        }
        if(type == "unset" && result == "true") {
            val = 2;
        }
        if(type == "unset" && result == "false") {
            val = 0;
        }
        ops[i] = val;
    }

    if(!checkOps(ops)) {
        cout << -1;
        return;
    }

    int edge_cnt;
    cin >> edge_cnt;

    vector<int> need_prev(n);

    for(int i = 0; i < edge_cnt; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        need_prev[b]++;
    }

    vector<vector<int>> acc_ops(4);
    for(int i = 0; i < n; i++) {
        if(need_prev[i] == 0) {
            acc_ops[ops[i]].push_back(i);
        }
    }

    vector<int> ans;

    while(acc_ops[0].size()) {
        int cur_idx = acc_ops[0].back();
        ans.push_back(cur_idx);
        acc_ops[0].pop_back();

        for(auto u : g[cur_idx]) {
            need_prev[u]--;
            if(need_prev[u] == 0) {
                acc_ops[ops[u]].push_back(u);
            }
        }
    }

    if(ans.size() != n && acc_ops[1].size() == 0) {
        cout << -1;
        return;
    }
    if(ans.size() == n) {
        coutAns(ans);
        return;
    }

    ans.push_back(acc_ops[1].back());
    for(auto u : g[acc_ops[1].back()]) {
        need_prev[u]--;
        if(need_prev[u] == 0) {
            acc_ops[ops[u]].push_back(u);
        }
    }
    acc_ops[1].pop_back();

    while(acc_ops[3].size()) {
        int cur_idx = acc_ops[3].back();
        ans.push_back(cur_idx);
        acc_ops[3].pop_back();

        for(auto u : g[cur_idx]) {
            need_prev[u]--;
            if(need_prev[u] == 0) {
                acc_ops[ops[u]].push_back(u);
            }
        }
    }

    if(ans.size() != n && acc_ops[2].size() == 0) {
        cout << -1;
        return;
    }
    if(ans.size() == n) {
        coutAns(ans);
        return;
    }
    ans.push_back(acc_ops[2].back());
    for(auto u : g[acc_ops[2].back()]) {
        need_prev[u]--;
        if(need_prev[u] == 0) {
            acc_ops[ops[u]].push_back(u);
        }
    }
    acc_ops[2].pop_back();

    while(acc_ops[0].size()) {
        int cur_idx = acc_ops[0].back();
        ans.push_back(cur_idx);
        acc_ops[0].pop_back();

        for(auto u : g[cur_idx]) {
            need_prev[u]--;
            if(need_prev[u] == 0) {
                acc_ops[ops[u]].push_back(u);
            }
        }
    }

    if(ans.size() != n) {
        cout << -1;
        return;
    }

    coutAns(ans);
}

signed main() {
    int tc;
    tc = 1;

    while(tc--) {
        solve();
    }
}


/*
5
set true
unset true
set false
unset false
unset false
2
1 4
5 2


3
unset true
unset false
set true
0

2
unset false
set true
1
2 1

2
unset false
set false
0

*/