#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>

using ll = long long;

using namespace std;

int main() {
	int t; cin >> t;
	while (t--) {
		int n, m, q;
		cin >> n >> m >> q;
		vector<ll> a(n);
		for (auto& i : a) {
			cin >> i;
		}
		vector<ll> d(n);
		for (auto& i : d) {
			cin >> i;
		}
		struct dt {
			ll a, d;
		};
		vector<dt> ds(n);
		for (int i = 0; i < n; i++) {
			ds[i].a = a[i];
			ds[i].d = d[i];
		}
		sort(ds.begin(), ds.end(), [&](dt x, dt y) {
			if (x.d != y.d) return x.d < y.d;
			return x.a > y.a;
		});
		struct pr {
			ll l, r;
		};
		vector<pr> ls(n);
		for (int i = n - 1; i >= 0; i--) {
			ls[i].l = ds[i].d - ds[i].a;
			ls[i].r = ds[i].d - 1;
			if (i == n - 1) continue;
			if (ls[i].r >= ls[i + 1].l) {
				ll dx = ls[i].r - ls[i + 1].l + 1;
				ls[i].l -= dx;
				ls[i].r -= dx;
			}
		}
		vector<ll> l(m);
		for (auto& i : l) {
			cin >> i;
		}
		for (int i = 1; i < m; i++) {
			l[i] += l[i - 1];
		}
		struct Q {
			ll t; int id;
		};
		vector<Q> tt(q);
		for (int i = 0; i < q; i++) {
			cin >> tt[i].t;
			tt[i].id = i;
		}
		sort(tt.begin(), tt.end(), [&](Q a, Q b) {
			return a.t < b.t;
		});
		vector<int> ans(q);
		for (int i = 0; i < q; i++) {
			ll s1 = 0;
			ll mt = tt[i].t;
			for (int j = 0; j < n; j++) {
				if (ls[j].l < tt[i].t && ls[j].r >= tt[i].t) {
					mt = ls[j].l;
				}
			}
			for (int j = 0; j < n; j++) {
				if (ls[j].r < tt[i].t) {
					s1 += ds[j].a;
				}
			}
			int mx = 0;
			for (int j = 0; j < m; j++) {
				if (s1 + l[j] <= mt) {
					mx = j + 1;
				}
			}
			ans[tt[i].id] = mx;
		}
		for (auto i : ans) cout << i << ' ';
		cout << endl;
	}
	return 0;
}

/*

*/