#include <bits/stdc++.h>
#define sz(_a) ((int)((_a).size()))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const par tur[4] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

bool is_ok(const string& st) {
    ll cur = 0;
    ll res = 0;
    ll prev = 0;
    int cnt_zer = 0;
    int cnt_dig = 0;
    char s = ' ';

    auto push_res = [&]() {
        if (s != '-') {
            res += cur;
        } else {
            res -= cur;
        }
        cur = 0;
        cnt_zer = 0;
        cnt_dig = 0;
    };

    for (char c : st) {
        if (c == '+' || c == '-') {
            push_res();
            s = c;
        } else if (c == '=') {
            push_res();
            s = ' ';
            swap(res, prev);
        } else {
            if (cur == 0 && c == '0') {
                ++cnt_zer;
                if (cnt_zer > 1) {
                    // cerr << "cnt_zer\n";
                    return false;
                }
            } else {
                if (cnt_zer > 0) {
                    // cerr << "cnt_zer>0\n";
                    return false;
                }
                cnt_zer = 0;
            }
            cur = cur * 10 + c - '0';
            ++cnt_dig;
        }
        if (cnt_dig > 10) {
            return false;
        }
    }
    push_res();
    // cerr << prev << ' ' << res << '\n';
    return prev == res;
}

bool is_dig(char c) {
    return c >= '0' && c <= '9';
}

inline signed solve() {

    string s;
    cin >> s;
    if (is_ok(s)) {
        return cout << "Correct", 0;
    }
    int n = sz(s);

    for (int i = 0; i < n; ++i) {
        if (is_dig(s[i])) {
            if ((i > 0 && is_dig(s[i - 1])) || (i < n - 1 && is_dig(s[i + 1]))){
                for (int j = 0; j <= n; ++j) {
                    if (i == j) {
                        continue;
                    }
                    if ((j < n && is_dig(s[j])) || (j > 0 && is_dig(s[j - 1]))) {
                        string o;
                        if (j < i) {
                            o = s.substr(0, j) + s[i] + s.substr(j, i - j) + s.substr(i + 1);
                        } else {
                            o = s.substr(0, i) + s.substr(i + 1, j - i - 1) + s[i] + s.substr(j);
                        }
                        if (is_ok(o)) {
                            return cout << o, 0;
                        }
                    }
                }
            }
        }
    }
    cout << "Impossible";

    return 0;
}

signed main() {
#ifdef MAKS
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    cerr << fixed << setprecision(3);
    int t_t = 1;
    // cin >> t_t;
    while (t_t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
