#include <iostream>
#include <vector>
#include <unordered_set>
#include <set>
#include <algorithm>
#include <deque>

using namespace std;

void solve() {
    ios::sync_with_stdio(0);
    cin.tie();
    int n;
    cin >> n;
    vector<int> a(n*2);
    for (int i = 0; i <2* n; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<pair<int, int>> con;
    unordered_set<int> g[2*n];
    for (int i = 0; i < 2*n-1; i++) {
        int u, v;
        cin >> u >> v; u--; v--;
        g[u].insert(v);
        g[v].insert(u);
    }
    set<pair<int, int>> q;
    vector<int> num2conInd[n];
    for (int i = 0; i < 2*n; i++) {
        q.insert({g[i].size(), i});
    }
    while (!q.empty()) {
        auto p = *q.begin();
        q.erase(q.begin());
        if (p.first == 0) continue;
        if (p.first > 1) {
            while (true);
        }
        int root = *g[p.second].begin();
        con.push_back({p.second, root});
        num2conInd[a[root]].push_back(con.size()-1);
        num2conInd[a[p.second]].push_back(con.size()-1);
        q.erase({g[root].size(), root});
        for (auto to: g[root]) {
            q.erase({g[to].size(), to});
            g[to].erase(root);
            q.insert({g[to].size(), to});
        }

    }

    // con -- набор ребер, которые хотим оставить
    // num2conInd -- соответствие чисел индексу
    vector<pair<int ,int>> ans;
    vector<bool> used(con.size());
    for (int i = 0; i < con.size(); i++) {
        if (used[i]) continue;
        if (a[con[i].first] == a[con[i].second]) continue;
        deque<pair<int, int>> cur;
        cur.push_back(con[i]);
        used[i] = true;
        int left = con[i].first;
        int t = i;
        int first = -1;
        int second = -1;
        while (true) {
            auto nums = num2conInd[a[left]];
            if (nums.size() == 1) {
                first = a[left];
                break;
            } else {
                if (nums[0] != t)
                    t = nums[0];
                else
                    t = nums[1];
            }
            if (used[t]) break;
            used[t] = true;
            cur.push_back(con[t]);
            if (a[con[t].first] != a[left])
                left = con[t].first;
            else
                left = con[t].second;
        }
        left = con[i].second;
        t = i;
        while (true) {
            auto nums = num2conInd[a[left]];
            if (nums.size() == 1) {
                second = a[left];
                break;
            } else {
                if (nums[0] != t)
                    t = nums[0];
                else
                    t = nums[1];
            }
            if (used[t]) break;
            used[t] = true;
            cur.push_front(con[t]);
            if (a[con[t].first] != a[left])
                left = con[t].first;
            else
                left = con[t].second;
        }
        if (first != -1 && second != -1) {
            int first_num = num2conInd[first][0];
            if (a[con[first_num].first] == first) {
                first_num = con[first_num].first;
            } else {
                first_num = con[first_num].second;
            }
            for (int j = 0; j < 2*n; j++) {
                if (a[j] == first && j != first_num) {
                    first_num = j;
                    break;
                }
            }
            int second_num = num2conInd[second][0];
            if (a[con[second_num].first] == first) {
                second_num = con[second_num].first;
            } else {
                second_num = con[second_num].second;
            }
            for (int j = 0; j < 2*n; j++) {
                if (a[j] == second && j != second_num) {
                    second_num = j;
                    break;
                }
            }
            cur.push_back({first_num, second_num});
        } else {

        }
        for (int i = 0; i < cur.size(); i++) {
            if (a[cur[i].first] > a[cur[i].second]) {
                swap(cur[i].first, cur[i].second);
            }
        }
        int l = 0;
        int r = cur.size()-1;
        int l_a = -1;
        int r_a = -1;
        while (l < r) {
            if (l == 0) {
                if (r == 1) {
                    ans.push_back({cur[l].first, cur[r].second});
                    break;
                }
                if (a[cur[l].first] == a[cur[r].second] || a[cur[l].first] == a[cur[r].first]) {
                    l_a = a[cur[l].second];
                    if (a[cur[r].second] == a[cur[l].first]) {
                        ans.push_back({cur[l].first, cur[r].first});
                        r_a = cur[r].first;
                    } else {
                        ans.push_back({cur[l].first, cur[r].second});
                        r_a = cur[r].second;
                    }
                    if (a[cur[r-1].second] == r_a) {
                        ans.push_back({cur[l].second, cur[r-1].second});
                        r_a = a[cur[r-1].first];
                    } else {
                        ans.push_back({cur[l].second, cur[r-1].first});
                        r_a = a[cur[r-1].second];
                    }
                } else {
                    l_a = a[cur[l].first];
                    if (a[cur[r].second] == a[cur[l].second]) {
                        ans.push_back({cur[l].second, cur[r].first});
                        r_a = cur[r].first;
                    } else {
                        ans.push_back({cur[l].second, cur[r].second});
                        r_a = cur[r].second;
                    }
                    if (a[cur[r-1].second] == r_a) {
                        ans.push_back({cur[l].first, cur[r-1].second});
                        r_a = a[cur[r-1].first];
                    } else {
                        ans.push_back({cur[l].first, cur[r-1].first});
                        r_a = a[cur[r-1].second];
                    }
                }
                r -= 1;
                l += 1;
                continue;
            }
            if (a[cur[l].first] != l_a) {
                swap(cur[l].first, cur[l].second);
            }
            if (a[cur[r].first] != r_a) {
                swap(cur[r].first, cur[r].second);
            }
            if (l == r-1) {
                ans.push_back({cur[l].first, cur[r].first});
                break;
            }
            if (a[cur[r-1].second] != r_a) {
                swap(cur[r-1].first, cur[r-1].second);
            }
            ans.push_back({cur[l].first, cur[r].first});
            ans.push_back({cur[l].second, cur[r-1].second});
            l_a = cur[l].second;
            r_a = cur[r-1].first;
            l+=1;
            r-=1;
            continue;
        }
    }
    cout << ans.size() << "\n";
    for (auto ab: ans) {
        cout << ab.first +1<< " " << ab.second+1 << "\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie();
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
