#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18 + 100;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].second;
    for (int i = 0; i < n; ++i) cin >> a[i].first;
    sort(a.begin(), a.end());
    for (int i = 1; i < n; ++i) {
        a[i].second += a[i - 1].second;
    }
    vector<ll> t(m);
    for (int i = 0; i < m; ++i) cin >> t[i];
    for (int i = 1; i < m; ++i) t[i] += t[i - 1];
    vector<int> p(n + 1);
    ll mn = INF;
    for (int i = n; i >= 0; --i) {
        if (i < n) {
            mn = min(mn, a[i].first - a[i].second);
        }
        p[i] = upper_bound(t.begin(), t.end(), mn) - t.begin();
    }
    while (q--) {
        ll x;
        cin >> x;
        int l = -1, r = n + 1;
        while (r - l > 1) {
            int md = (l + r) / 2;
            ll y = t[p[md]];
            if (md > 0)
                y += a[md - 1].second;
            if (y <= x)
                l = md;
            else
                r = md;
        }
        int ans = 0;
        if (l > -1) ans = max(ans, p[l]);
        if (r < n + 1) {
            ll y = 0;
            if (r != 0) y = a[r - 1].second;
            ans = max(ans, (int)(upper_bound(t.begin(), t.end(), x - y) - t.begin()));
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int ts;
    cin >> ts;
    while (ts--) {
        solve();
    }
}
