#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int N = 2e5 + 5, inf = 1e9;

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n; cin >> n;
    vector<int> a(n + 1, 0);
    vector<array<int ,2>> in(n + 1);
    vector<int> pos(n + 1, 0);
    in[0][0] = in[0][1] = 0;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
        in[a[i]][0] = i;
        pos[a[i]] = i;
        in[a[i]][1] = a[i];
    }
    vector<pair<int, int>> ans;
    set<pair<int, int>> used;
    for(int i = n; i > 0; i--) {
        for(int j = i - 1; j > 0; j--) {
            used.insert({i, j});
            ans.push_back(make_pair(i, j));
        }
    }
    vector<int> cur(n + 1, 0);
    sort(in.rbegin(), in.rend());
    for(int i = 1; i <= n; i++) cur[i] = n - i + 1;
    for(int i = 0; i < n; i++) {
        for(int j = in[i][1] - 1; j > 0; j--) {
            if(used.count({i, j})) continue;
            if(in[i][0] > pos[j]) {
                used.insert({j, in[i][1]});
                ans.push_back(make_pair(j, in[i][1]));
            }
        }

    }
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= n; j++) {
            if(used.count({i, j}) || used.count({j, i})) continue;
            if(pos[i] - pos[j] == 1) {
                used.insert({i, j});
                ans.push_back(make_pair(i, j));
                used.insert({j, i});
                ans.push_back(make_pair(j, i));
            }
        }
    }
    cout << ans.size() << endl;
    for(auto &u : ans) {
        cout << u.first << ' ' << u.second << endl;
    }
    return 0;
}
