#include <iostream>
#include <vector>
#include <algorithm>
#define ff first
#define ss second
#define ll long long
#define pb push_back
using namespace std;
const int N = 2e5+5;

ll dp[2][4][N];

ll mod[2] = {(ll)1e9+7, (ll)1e9+9};

void test_case() {
    int n, m, q;
    cin >> n >> m >> q;

    pair<ll,ll> A[n+5], C[q];
    ll B[m+5] = {}, suf[m+5] = {};
    for (int i = 0; i < n; i++) cin >> A[i].ss;
    for (int i = 0; i < n; i++) cin >> A[i].ff;

    sort(A, A+n);

    vector<ll> pre(n, 0);
    ll answer[q+5] = {};
    pre[0] = A[0].ss;
    for (int i = 1; i < n; i++) pre[i] = pre[i-1] + A[i].ss;

    for (int i = 0; i < m; i++) {
        cin >> B[i];
    }

    suf[n] = 1e18;
    suf[n-1] = A[n-1].ff-pre[n-1];
    for (int i = n-2; i >= 0; i--){
        suf[i] = min(suf[i+1], A[i].ff-pre[i]);
    }

    for (int i = 0; i < q; i++) {
        cin >> C[i].ff;
        C[i].ss = i;
    }

    if (suf[0] <= 0) {
        for (int i = 0; i < q; i++) {
            cout << 0 << " ";
        }
        return ;
    }

    sort(C, C+q);

    ll res = 0, cur = 0;
    for (auto [t, ind] : C) {
        if (res == m) {
            answer[ind] = res;
            continue;
        }

        while (res < m) {
            cur += B[res];
            auto i = upper_bound(pre.begin(), pre.end(), t-cur)-pre.begin();
            if (suf[i] >= cur) {
                res++;
            } else {
                cur -= B[res];
                break;
            }
        }
        answer[ind] = res;
    }

    for (int i = 0; i < q; i++) {
        cout << answer[i] << " ";
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        test_case();
    }


}
