#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#define ff first
#define ss second
#define ll long long
#define pb push_back
using namespace std;
const int N = 2e5+5;



void test_case() {
    int n, m, q;
    cin >> n >> m >> q;

    pair<ll,ll> A[n+5], C[q];
    ll B[m+5] = {}, suf[n+5] = {};
    for (int i = 0; i < n; i++) cin >> A[i].ss, A[i].ss = -A[i].ss;
    for (int i = 0; i < n; i++) cin >> A[i].ff;

    sort(A, A+n);

    vector<ll> pre(n+5, 0);
    ll answer[q+5] = {};
    pre[0] = -A[0].ss;
    for (int i = 1; i < n; i++) pre[i] = pre[i-1] - A[i].ss;

    for (int i = 0; i < m; i++) {
        cin >> B[i];
    }

    suf[n] = 1e18;
    for (int i = n-1; i >= 0; i--){
        suf[i] = min(suf[i+1], A[i].ff-pre[i]);
    }

    for (int i = 0; i < q; i++) {
        cin >> C[i].ff;
        C[i].ss = i;
    }

    assert(suf[0] >= 0);

    sort(C, C+q);

    ll res = 0, cur = 0, p = 0;
    for (auto [t, ind] : C) {
        if (res == m) {
            answer[ind] = res;
            continue;
        }

        while (res < m) {
            cur += B[res];
            while (suf[p] < cur) p++;
            ll k = 0;
            if (p > 0) k = pre[p-1];
            if (k + cur <= t) {
                res++;
            } else {
                cur -= B[res];
                break;
            }
        }
        answer[ind] = res;
    }

    for (int i = 0; i < q; i++) {
        cout << answer[i] << " ";
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        test_case();
    }


}
