#include <iostream>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <numeric>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <fstream>
#include <memory>
#include <thread>
// cout<<fixed<<setprecision(10)<<res<<endl;


using namespace std;

void solve() {
	int n; cin >> n;

	vector<vector<int>> v(2 * n);
	vector<bool> vbool(2 * n, false);
	string s, m;
	cin >> s >> m;
	int count = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '.') { vbool[i] = true; count++; }
		if (m[i] == '.') { vbool[i + n] = true; count++; }

		if (i == 0 && s[i] == '.') {
			if (s[1] == '.') {
				v[0].push_back(1);
				v[1].push_back(0);
			}

			if (m[0] == '.') {
				v[0].push_back(n);
				v[n].push_back(0);
			}
		}

		else if (i == n - 1 && s[i] == '.' && m[i] == '.') {
			v[n - 1].push_back(2 * n - 1);
			v[2 * n - 1].push_back(n - 1);
		}

		else if (s[i] == '.') {
			if (s[i + 1] == '.') {
				v[i].push_back(i + 1);
				v[i + 1].push_back(i);
			}

			if (m[i] == '.') {
				v[i].push_back(i + n);
				v[i + n].push_back(i);
			}
		}

		if (i != n - 1 && m[i] == '.' && m[i + 1] == '.') {
			v[i + n].push_back(i + 1 + n);
			v[i + 1 + n].push_back(i + n);
		}
	}

	if (count % 2 == 1) {
		cout << "None" << endl;
		return;
	}

	queue<int> q;

	for (int i = 0; i < 2 * n; i++) {

		if (v[i].size() == 1) {
			q.push(i);
		}
	}



	int x, bro;
	while (q.size() != 0) {
		int cur = q.size();
		while (cur--) {
			x = q.front(); q.pop();
			if (v[x].size() == 0) continue;
			vbool[x] = false;
			bro = v[x][0];
			vbool[bro] = false;
			v[x].pop_back();

			for (int i = 0; i < v[bro].size(); i++) {
				for (int j = 0; j < v[v[bro][i]].size(); j++) {
					if (v[v[bro][i]][j] == bro) {
						v[v[bro][i]].erase(v[v[bro][i]].begin() + j);
					}
				}

				if (v[v[bro][i]].size() == 1) q.push(v[bro][i]);
			}

			int z = v[bro].size();
			for (int i = 0; i < z; i++) v[bro].pop_back();

		}
	}

	for (int i = 0; i < 2 * n; i++) {
		if (vbool[i] == true && v[i].size() == 0) {
			cout << "None" << endl;
			return;
		}
	}


	for (int i = 0; i < 2 * n; i++) {
		if (vbool[i] && v[i].size() == 0) {
			cout << "None" << endl;
			return;
		}
	}

	for (int i = 0; i < 2 * n; i++) {
		if (v[i].size()!= 0) {
			cout << "Multiple" << endl;
			return;
		}
	}

	cout << "Unique" << endl;
	return;
}



int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);

	int T; cin >> T;
	while (T--) {
		solve();
	}
}