#include "bits/stdc++.h"

using namespace std;

    struct
    {
        bool operator()(pair<int, int> a, pair<int, int> b) const { return a.second < b.second; }
    }
    mycomp;

int main()
{
    int t;
    cin >> t;
    while (t--) {
        int n, m, q;
        cin >> n >> m >> q;

        vector<int> t(n);
        vector<int> d(n);
        vector<int> eps(m);
        vector<int> tk(q);
        vector<pair<int, int>> v;

        for (int i = 0; i < n; i++) {
            cin >> t[i];
        }

        for (int i = 0; i < n; i++) {
            cin >> d[i];
        }

        for (int i = 0; i < n; i++) {
            v.push_back(make_pair(t[i], d[i]));
        }

        sort(v.begin(), v.end(), mycomp);

        for (int i = 0; i < m; i++) {
            cin >> eps[i];
        }

        for (int i = 0; i < q; i++) {
            cin >> tk[i];
        }

        map<int, int> moviemp;
        int time = 0;
        int moviecnt = 0;
        int epidx = 0;
        for (int i = 0; i < v.size(); i++) {
            time += v[i].first;
            int freetime = v[i].second - time;
            if (freetime >= eps[epidx]) {
                time += eps[epidx];
                moviecnt++;
                moviemp[time - v[i].first] = moviecnt;
                epidx++;
            }
        }

        for (int i = epidx; i < m; i++) {
            time += eps[i];
            moviecnt++;
            moviemp[time] = moviecnt;
        }

        int last = -1;
        for (int i = 0; i < q; i++) {
            auto it = moviemp.upper_bound(tk[i]);
            if (it == moviemp.begin()) {
                cout << 0 << " ";
            } else if (it == moviemp.end()) {
                it = moviemp.lower_bound(tk[i]);
                if (it != moviemp.end())     {
                    cout << it->second << " ";
                } else {
                    if (moviemp.size() > 0) {
                        it = moviemp.end();
                        it--;
                        cout << it->second << " ";
                    } else {
                        cout << 0 << " ";
                    }
                }
                continue;
            } else {
                it--;
                cout << it->second << " ";
            }
            last = it->second;
        }
        cout << '\n';
    }
}
