#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> a(n + 1), p(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        p[i] = i;
    }

    vector<pair<int, int>> ans;
    auto op = [&](int i) -> void {
        assert(i > 1);
        ans.push_back({p[i], p[i - 1]});
        swap(p[i], p[i - 1]);
    };

    reverse(a.begin() + 1, a.end());
    for (int i = 1; i <= n; ++i) {
        int pos = -1;
        for (int j = i; j <= n; ++j) {
            if (p[j] == a[i]) {
                pos = j;
                break;
            }   
        }

        while (pos > i) {
            op(pos--);
        }
    }
    
    for (int i = 1; i <= n; ++i) {
        assert(a[i] == p[i]);
    }

    for (int i = n; i >= 1; --i) {
        int j = n;
        while (j > n - i + 1) {
            op(j--);
        }
    }

    reverse(a.begin() + 1, a.end());
    for (int i = 1; i <= n; ++i) {
        assert(a[i] == p[i]);
    }

    cout << (int)ans.size() << '\n';
    for (pair<int, int> p : ans) {
        cout << p.first << ' ' << p.second << '\n';
    }
}

int main() {
    int t = 1; // cin >> t;
    for (int _ = 0; _ < t; ++_) {
        solve();
    }
}
/*
1 2 3
1 3 2
1 2 3
2 1 3
2 3 1


*/