#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 201;

void solve() {
    int n; cin >> n;
    vector<int> v(n + 1), cnt(4);
    for (int i = 1; i <= n; ++i) {
        string a, b; cin >> a >> b;
        v[i] = ((a == "set") << 1) + (b == "true");
        ++cnt[v[i]];
    }

    vector<vector<int>> g(n + 1), r(n + 1);
    vector<int> deg(n + 1);
    int m; cin >> m;
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        r[v].push_back(u);
        ++deg[u];
    }

    queue<int> q[4];
    for (int i = 1; i <= n; ++i) {
        if (deg[i] == 0) {
            q[v[i]].push(i);
        }
    }

    bool is_unset_True_done = false, is_set_True_done = false;
    const int UNSET_FALSE = 0, UNSET_TRUE = 1, SET_FALSE = 2, SET_TRUE = 3;
    vector<int> order;
    if (cnt[UNSET_TRUE] > 1 || cnt[SET_TRUE] > 1) {
        cout << "-1\n";
        return;
    }

    if (cnt[SET_TRUE] + cnt[UNSET_TRUE] == 0) {
        if (cnt[SET_FALSE] > 0) {
            cout << "-1\n";
            return;
        }
    } else if (cnt[SET_TRUE] == 0 && cnt[UNSET_TRUE] == 1) {
        cout << "-1\n";
        return;
    }
    while (true) {
        int sz = 0;
        for (int i = 0; i < 4; ++i) {
            sz += (int)q[i].size();
        }
        if (sz == 0) {
            break;
        }

        // when is unset false??
        // if unset True is not done yet, or if only unset false is left
        int removed = -1;
        if (!q[UNSET_FALSE].empty() && (is_unset_True_done == false || q[UNSET_FALSE].size() == sz)) {
            removed = q[UNSET_FALSE].front();
            q[UNSET_FALSE].pop();
        } else if (is_unset_True_done == true && is_set_True_done == false && !q[SET_FALSE].empty()) {
            removed = q[SET_FALSE].front();
            q[SET_FALSE].pop();
        } else if (!q[UNSET_TRUE].empty()) {
            removed = q[UNSET_TRUE].front();
            is_unset_True_done = true;
            q[UNSET_TRUE].pop();
        } else if (!q[SET_TRUE].empty()) {
            removed = q[SET_TRUE].front();
            is_set_True_done = true;
            q[SET_TRUE].pop();
        } else {
            cout << "-1\n";
            return;
        }
        order.push_back(removed);
        for (int i : r[removed]) {
            if (--deg[i] == 0) {
                q[v[i]].push(i);
            }
        }
    }

    reverse(order.begin(), order.end());
    assert((int)order.size() == n);
    vector<int> id(n + 1);
    for (int i = 0; i < n; ++i) {
        id[order[i]] = i;
    }

    for (int i = 1; i <= n; ++i) {
        for (int j : g[i]) {
            if (id[i] > id[j]) {
                cout << "-1\n";
                return;
            }
        }
    }

    int bit = 0;
    for (int i : order) {
        int c = v[i] >> 1;
        if ((bit == (c ^ 1)) != (v[i] & 1)) {
            cout << "-1\n";
            return;
        }
        bit = c;
    }

    for (int i : order) {
        cout << i << ' ';
    }
}

main() {
    int t = 1; // cin >> t;
    for (int _ = 0; _ < t; ++_) {
        solve();
    }
}