#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 201;

void solve() {
    int n, m, q; cin >> n >> m >> q;
    vector<array<int, 2>> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i][1];
    for (int i = 1; i <= n; i++) cin >> a[i][0];
    sort (a.begin(), a.end());

    vector<int> b(m + 1), prefb(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> b[i];
        prefb[i] = prefb[i - 1] + b[i];
    }

    vector<int> can(n + 1), time(n + 1);
    int cur = 0;
    for (int i = 1; i <= n; i++) {
        cur += a[i][1];
        time[i] = cur;
        can[i] = a[i][0] - time[i];
    }

    vector<int> suff(n + 10, 1e18);
    for (int i = n; i >= 1; i--) {
        suff[i] = (i == n ? can[i] : min(suff[i + 1], can[i]));
    }

    auto check = [&] (int t, int x) -> bool {
        int left = t - prefb[x]; 
        if (left < 0) return false;

        int l = 0, r = n, res = 0;
        while (l <= r) {
            int mid = l + r >> 1;
            if (time[mid] <= left) {
                res = mid;
                l = mid + 1;
            } else {
                r = mid - 1;
            }
        }

        return suff[res + 1] >= prefb[x];
    };  

    for (int i = 1; i <= q; i++) {
        int t; cin >> t;
        int l = 0, r = m, res = -1;
        while (l <= r) {
            int mid = l + r >> 1;
            if (check(t, mid)) {
                res = mid;
                l = mid + 1;
            } else {
                r = mid - 1;
            }
        }
        cout << res << ' ';
    }
    cout << '\n';
}

main() {
    int t; cin >> t;
    for (int _ = 0; _ < t; ++_) {
        solve();
    }
}