#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<string> s(3);
    string t;
    cin >> t;
    s[1] = "#" + t + "#";
    cin >> t;
    s[2] = "#" + t + "#";

    vector<ll> a[3];
    a[1].resize(n + 2);
    a[2].resize(n + 2);
    a[1][0] = -1, a[1][n + 1] = -1;
    a[2][0] = -1, a[2][n + 1] = -1;


    vector<pii> one;
    for(int i = 1; i <= n; i++) {
        if(s[1][i] == '#') {
            a[1][i] = -1;
        }else {
            a[1][i] = (s[1][i - 1] == '.') + (s[1][i + 1] == '.') + (s[2][i] == '.');
            if(a[1][i] == 0) {
                cout << "None\n";
                return;
            }else if(a[1][i] == 1) {
                one.push_back({1, i});
            }
        }

        if(s[2][i] == '#') {
            a[2][i] = -1;
        }else {
            a[2][i] = (s[2][i - 1] == '.') + (s[2][i + 1] == '.') + (s[1][i] == '.');
            if(a[2][i] == 0) {
                cout << "None\n";
                return;
            }else if(a[2][i] == 1) {
                one.push_back({2, i});
            }
        }
    }


    while(!one.empty()) {
        int x = one.back().first;;
        int y = one.back().second;

        one.pop_back();

        if(a[x][y] < 0) continue;
        a[x][y] = -1;
        int r = x - 1;
        if(x == 1) {
            r = x + 1;
        }

        int x1 = -1, y1 = -1;
        if(a[x][y - 1] > 0) {
            a[x][y - 1] = -1;
            x1 = x, y1 = y - 1;
        }else if(a[x][y + 1] > 0) {
            a[x][y + 1] = -1;
            x1 = x, y1 = y + 1;
        }else {
            a[r][y] = -1;
            x1 = r, y1 = y;
        }


        a[r][y]--;
        a[x][y + 1]--;
        a[x][y - 1]--;
        if(a[r][y] == 0 || a[x][y + 1] == 0 || a[x][y - 1] == 0) {
            cout << "None\n";
            return;
        }else if(a[r][y] == 1) {
            one.push_back({r, y});
        }else if(a[x][y + 1] == 1) {
            one.push_back({x, y + 1});
        }else if(a[x][y - 1] == 1) {
            one.push_back({x, y - 1});
        }

        int r1 = x1 - 1;
        if(x1 == 1) {
            r1 = x1 + 1;
        }
        a[r1][y1]--;
        a[x1][y1 + 1]--;
        a[x1][y1 - 1]--;
        if(a[r1][y1] == 0 || a[x1][y1 + 1] == 0 || a[x1][y1 - 1] == 0) {
            cout << "None\n";
            return;
        }else if(a[r1][y1] == 1) {
            one.push_back({r1, y1});
        }else if(a[x1][y1 + 1] == 1) {
            one.push_back({x1, y1 + 1});
        }else if(a[x1][y1 - 1] == 1) {
            one.push_back({x1, y1 - 1});
        }
    }

    for(int i = 1; i <= n; i++) {
        if(a[1][i] == 0 || a[2][i] == 0) {
            cout << "None\n";
            return;
        }
    }

    for(int i = 1; i <= n; i++) {
        if(a[1][i] > 0 || a[2][i] > 0) {
            cout << "Multiple\n";
            return;
        }
    }

    cout << "Unique\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}
