#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define sz(x) (int)(x).size()

bool isdigit(char r) {
    int x = r - '0';
    return (x <= 9 && x >= 0);
}

long long get(string s) {
    int op = 1;
    long long res = 0, now = 0;
    for(int i = 0; i < sz(s); ++i) {
        if (isdigit(s[i])) {
            now = now * 10 + (s[i] - '0');
        }
        if (i == sz(s) - 1 || !isdigit(s[i])){
            if (op == 1) {
                res += now;
            } else {
                res -= now;
            }
            if (s[i] == '+') op = 1;
            else op = -1;
            now = 0;
        }
    }
    return res;
}

bool check_len(string s) {
    string now = "";
    for(int i = 0; i < sz(s); ++i) {
        if (isdigit(s[i])) {
            now += s[i];
        }
        if (i == sz(s) - 1 || !isdigit(s[i])){
            string nx = to_string(stoll(now));
            if (sz(now) > 10 || nx != now) {
                return false;
            }
            now = "";
        }
    }
    return true;
}

bool check(string s) {
    int pos = s.find('=');
    string first_part = s.substr(0, pos);
    if (!check_len(first_part)) return false;
    string second_part = s.substr(pos+1, (int)s.size());
    if (!check_len(second_part)) return false;
    long long Fnum = get(first_part);
    long long Snum = get(second_part);
    //cerr << Fnum << ' ' << Snum << "\n\n";
    return (Fnum == Snum);
}

void solve() {
    string s;
    cin >> s;

    if (check(s)) {
        cout << "Correct\n";
        return;
    }

    for(int i = 0; i < (int)s.size(); ++i) {
        for(int j = 0; j < (int)s.size(); ++j) {
            if (isdigit(s[i]) && i != j) {
                bool can = false;
                if (j > 0 && isdigit(s[j-1])) can = true;
                if (isdigit(s[j])) can = true;
                if (!can) continue;

                bool can1 = false;
                if (i > 0 && isdigit(s[i-1])) {
                    can1 = true;
                }
                if (i + 1 < sz(s) && isdigit(s[i+1])) {
                    can1 = true;
                }
                if (!can1) {
                    continue;
                }

                string new_s = "";
                if (i < j) {
                    int ln = j - i - 1;
                    new_s = s.substr(0, i) + s.substr(i+1, ln) + s[i] + s.substr(j, s.size());
                  //  cout << i << ' ' << j  << ' ' << new_s << '\n';
                } else {
                    int ln = i - j;
                    new_s = s.substr(0, j) + s[i] + s.substr(j, ln) + s.substr(i+1, (int)s.size());
                    //cout << i << ' ' << j  << ' ' << new_s << '\n' << '\n';
                }
                if (check(new_s)) {
                    cout << new_s << '\n';
                    return;
                }
            }
        }
    }

    cout << "Impossible";
}

int main() {
    int test = 1;
    // cin >> test;
    while(test--) {
        solve();
    }
}
