#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> v(n);
    iota(v.begin(), v.end(), 1);
    vector<array<int, 2>> ans;
    vector<vector<bool>> mp(n + 1, vector<bool>(n + 1));
    for (int i = 0; i < n; i++) {
        int id = i - 1;
        for (int j = 0; j < n; j++) {
            if (v[j] == a[i]) {
                id = j - 1;
                break;
            }
        }
        if (id == i - 1) continue;

        v.erase(v.begin() + id + 1);
        for (int j = id; j >= i; j--) {
            mp[a[i]][v[j]] = true;
            ans.push_back({a[i], v[j]});
        }
        v.insert(v.begin() + i, a[i]);
    }
    for (int i = 0; i < n - 1; i++) {
        if (mp[a[i]][a[i + 1]] || mp[a[i + 1]][a[i]]) {
            continue;
        }
        ans.push_back({a[i + 1], a[i]});
        ans.push_back({a[i], a[i + 1]});
    }
    cout << (int)ans.size() << '\n';
    for (auto& x : ans) {
        cout << x[0] << ' ' << x[1] << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
