#include <string>
#include <iostream>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <algorithm>
#include <numeric>
#include <limits>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>

#pragma GCC optimize("Ofast")

using namespace std;

bool comp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n; cin >> n;
    vector<int> a(n + 1);
    vector<int> pos(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    vector<int> order(n + 1);
    for (int i = 1; i <= n; i++) order[i] = i;
    vector<pair<int, int>> res;
    for (int i = 1; i <= n; i++) {
        if (order[i] == a[i] && i != 1 && order[i] > order[i-1]) {
            res.push_back(make_pair(order[i], order[i-1]));
            res.push_back(make_pair(order[i-1], order[i]));
            continue;
        }
        int curr;
        for (int j = 1; j <= n; j++) {
            if (order[j] == a[i]) {
                curr = j;
                break;
            }
        }
        while (curr > i) {
            res.push_back(make_pair(order[curr], order[curr-1]));
            swap(order[curr], order[curr-1]);
            curr--;
        }
        if (curr != 1 && order[curr] > order[curr-1]) {
            res.push_back(make_pair(order[i], order[i-1]));
            res.push_back(make_pair(order[i-1], order[i]));
        }
    }
    cout << res.size() << '\n';
    for (auto &v: res) {
        cout << v.first << ' ' << v.second << '\n';
    }
    return 0;
}