// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <map>
#include <math.h>

using namespace std;

map<int, int> indexes;
map<pair<int, int>, int> swaps;
vector<pair<int, int>> swap_vec;
map<int, int> indexes_rev;
int swap_cnt = 0;

void bubble_sort(vector<int>& vec) {
	int n = vec.size();

	for (int i = 0; i < n; i++) {
		for (int j = i; j < n; j++) {
			if (vec[i] > vec[j]) {
				swap(vec[i], vec[j]);
				swaps[make_pair(vec[i], vec[j])]++;
				swap_vec.push_back(make_pair(vec[i], vec[j]));
				swap_cnt++;
			}

		}
	}
}

pair<int, int> get_pair(int a, int b) {
	if (a > b)
		swap(a, b);

	return make_pair(a, b);
}

int get_swaps(int a, int b) {
	return swaps[get_pair(a, b)];
}

int main()
{
	int n;
	cin >> n;

	vector<int> vec(n);

	for (int i = 0; i < n; i++) {
		int tmp;
		cin >> tmp;
		indexes[tmp] = i;
		indexes_rev[i] = tmp;
	}

	for (int i = 1; i <= n; i++) {
		vec[i - 1] = indexes[i];
	}

	bubble_sort(vec);

	for (int i = 0; i < n - 1; i++) {
		int j = i, k = i + 1;

		int cnt = 0;

		while (true) {
			if (get_swaps(vec[j], vec[k]) != 0)
				break;

			swap_cnt++;
			swap_vec.push_back({ vec[k], vec[j] });
			swap(vec[k], vec[j]);
			swaps[get_pair(vec[j], vec[k])]++;

			cnt++;
			j++;
			k++;

			if (k == n)
				break;
		}

		while(cnt--) {
			j--;
			k--;

			swap_cnt++;
			swap_vec.push_back({ vec[k], vec[j] });
			swap(vec[k], vec[j]);
			swaps[get_pair(vec[j], vec[k])]++;
		}
	}

	for (int i = 0; i < swap_vec.size(); i++)
	{
		cout << indexes_rev[swap_vec[i].first] << " " << indexes_rev[swap_vec[i].second] << endl;
	}

	cout << swap_cnt;
}
