#include <bits/stdc++.h>

#define nl '\n'
#define F first
#define S second
#define mp make_pair
#define ll long long
#define pii pair<int, int>

const int N = 2e5 + 123;
const ll mod = 1e9 + 7;
const ll inf = 1e18;

using namespace std;

int n;
pair<string, string> p[N];
vector<int> g[N];
int in[N];
multiset<pair<int, int> > st[6];
vector<int> ans;

int getType(pair<string, string> p) {
	if(p.F == "set") {
		if(p.S == "true") {
			return 1;
		} else {
			return 2;
		}
	} else {
		if(p.S == "true") {
			return 3;
		} else {
			return 4;
		}
	}
}

void addAnswer(int x) {
	ans.push_back(x);
	for(auto to : g[x]) {
		int type = getType(p[to]);

		st[type].erase(st[type].find({in[to], to}));
		in[to]--;
		st[type].insert({in[to], to});
	}
}

void deleteTypeUntilYouCan(int type) {
	while(st[type].size() > 0) {
		pii top = *st[type].begin();

		if(top.F > 0) {
			break;
		}
		addAnswer(top.S);
		st[type].erase(st[type].begin());
	}
}

void outputAns() {
	if(ans.size() != n) {
		return ;
	}
	for(int i = 0; i < ans.size(); i++) {
		cout << ans[i] << ' ';
	}
	exit(0);
}

int col[N];

void Dfs (int v) {
	col[v] = 1;
	for (auto to : g[v]) {
		if (col[to] == 1) {
			cout << -1;
			exit(0);
		}
		if (col[to] == 0) {
			Dfs (to);
		}
	}
	col[v] = 2;
}

void checkcycle() {
	for (int i = 1; i <= n; i ++) {
		if (col[i] == 0) Dfs (i);
	}
}

void solve() {
	cin >> n;
	for(int i = 1; i <= n; i++) {
		cin >> p[i].F >> p[i].S;
	}
	int q;
	cin >> q;
	for(int i = 1; i <= q; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		in[v]++;
	}
	checkcycle();
	for(int i = 1; i <= n; i++) {
		int type = getType(p[i]);
		st[type].insert({in[i], i});
	}
	deleteTypeUntilYouCan(4);
	outputAns();
	if (st[1].size() != 1) {
		cout << -1;
		return ;
	}
	pii top = *st[1].begin();
	st[1].erase(st[1].begin());
	if(top.F > 0) {
		cout << -1;
		return ;
	}

	addAnswer(top.S);

	deleteTypeUntilYouCan(2);
	outputAns();

	if (st[3].size() != 1) {
		cout << -1;
		return ;
	}
	top = *st[3].begin();
	if(top.F > 0) {
		cout << -1;
		return ;
	}
	addAnswer(top.S);
	st[3].erase(st[3].begin());

	deleteTypeUntilYouCan(4);
	outputAns();

	cout << -1;
	return ;
}

int main () {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	const string ourPath = "C:\\Users\\nef\\Desktop\\contest";

	if (ourPath == std::filesystem::current_path()) {
		freopen ("input.txt", "r", stdin);
		freopen ("output.txt", "w", stdout);
	}

	int T = 1;
	// cin >> T;
	while(T--) {
		solve();
	}
} 