#include <bits/stdc++.h>

#define nl '\n'
#define F first
#define S second
#define mp make_pair
#define ll long long

const int N = 2e5 + 123;
const ll mod = 1e9 + 7;
const ll inf = 1e18;

using namespace std;

pair<ll, ll> a[N]; // first = deadline, second = time takes
ll pref[N], interval[N];
vector<pair<ll, ll>> v;

int getInterval(ll x) {
	int l = 0, r = v.size() - 1, res = -1;
	while (l <= r) {
		int m = (l + r) >> 1;
		if (v[m].second <= x) {
			res = m;
			l = m + 1;
		} else {
			r = m - 1;
		}
	}
	return res;
}

int getValue(ll x, int n) {
	int l = 1, r = n, res = 0;
	while (l <= r) {
		int m = (l + r) >> 1;
		if (pref[m] <= x) {
			res = m;
			l = m + 1;
		} else {
			r = m - 1;
		}
	}
	return res;
}

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 1; i <= n; i++){
		cin >> a[i].second;
	}
	for (int i = 1; i <= n; i++){
		cin >> a[i].first;
	}
	sort(a + 1, a + 1 + n);
	ll last = a[n].first;
	for (int i = n; i >= 1; i --){
		if (last > a[i].first) {
			last = a[i].first;
		}
		v.push_back({last - a[i].second + 1, last});
		last = last - a[i].second;
	}
	sort(v.begin(), v.end());
	interval[0] = v[0].second - v[0].first + 1;
	for (int i = 1; i < m; i++) {
		interval[i] = interval[i - 1] + (v[i].second - v[i].first + 1);
	}
	pref[0] = 0;
	for (int i = 1; i <= m; i++) {
		ll x;
		cin >> x;
		pref[i] = pref[i - 1] + x;
	}
	while (k --) {
		ll x;
		cin >> x;
		int id = getInterval(x);
		ll intervalValue = (id >= 0 ? interval[id] : 0);
		if (id + 1 < v.size()) {
			x = min(x, v[id + 1].first - 1);
		}
		ll left = x - intervalValue;
		cout << getValue(left, m) << " ";
	} 
	cout << "\n";
	v.clear();
}

int main () {
	const string ourPath = "C:\\Users\\nef\\Desktop\\contest";

	if (ourPath == std::filesystem::current_path()) {
		freopen ("input.txt", "r", stdin);
		freopen ("output.txt", "w", stdout);
	}

	int T = 1;
	cin >> T;
	while(T--) {
		solve();
	}
}