#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x.size())
#define fi first
#define se second

const int N = 3e5+7;

int n;
char a[5][N];
bool ans;

void brick(int t, int i)
{
    if (t < 1 || t > 2 || i < 1 || i > n || a[t][i] != '.' || !ans) return;
    int x = 0;
    if (a[t][i + 1] == '.') x++;
    if (a[t][i - 1] == '.') x++;
    if (a[t + 1][i] == '.') x++;
    if (a[t - 1][i] == '.') x++;
    if (x == 0)
    {
        ans = false;
        return;
    }
    if (x == 1)
    {
        a[t][i] = '#';
        if (a[t][i + 1] == '.')
        {
            a[t][i + 1] = '#';
            brick(t, i - 1);
            brick(t + 1, i);
            brick(t - 1, i);
            brick(t, i + 2);
            brick(t + 1, i + 1);
            brick(t - 1, i + 1);
        }
        if (a[t][i - 1] == '.')
        {
            a[t][i - 1] = '#';
            brick(t, i - 2);
            brick(t + 1, i - 1);
            brick(t - 1, i - 1);
            brick(t, i + 1);
            brick(t + 1, i);
            brick(t - 1, i);
        }
        if (a[t + 1][i] == '.')
        {
            a[t + 1][i] = '#';
            brick(t + 1, i + 1);
            brick(t + 1, i - 1);
            brick(t, i + 1);
            brick(t, i - 1);
        }
        if (a[t - 1][i] == '.')
        {
            a[t - 1][i] = '#';
            brick(t, i + 1);
            brick(t, i - 1);
            brick(t - 1, i + 1);
            brick(t - 1, i - 1);
        }
    }
}

void solve()
{
    cin >> n;
    ans = true;

    for (int t = 1; t <= 2; ++t)
    {
        for (int i = 1; i <= n; ++i)
        {
            cin >> a[t][i];
        }
    }
    for (int t = 1; t <= 2; ++t)
    {
        for (int i = 1; i <= n; ++i)
        {
            brick(t, i);
            if (!ans)
            {
                cout << "None";
                return;
            }
        }
    }

    bool flag = false;
    int sum = 0;
    for (int t = 1; t <= 2; ++t)
    {
        for (int i = n; i > 0; --i)
        {
            if (a[t][i] == '.')
            {
                sum++;
                flag = true;
                if (a[t + 1][i] != '.' && a[t - 1][i] != '.')
                {
                    cout << "None";
                    return;
                }
            }
        }
    }
    if (sum & 1) cout << "None";
    else if (flag) cout << "Multiple";
    else cout << "Unique";
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int q;
    cin >> q;
    while(q--)
    {
        solve();
        cout << '\n';
    }
}
