#include <bits/stdc++.h>

using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define sz(x) (int)(x).size()
#define all(x) begin(x), end(x)
typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int maxn = 2*1e5 +7;
int dp[maxn][4];

void solve() {
    int n;
    cin >> n;
    string s[2];
    rep(i, 0, 2) cin >> s[i];
    dp[0][3] = 1;
    for (int i = 0; i < n; ++i) {
        for (int mask = 0; mask < 4; ++mask) {
            dp[i + 1][mask] = 0;
            int x = mask;
            bool bad = false;
            for (int j = 0; j < 2; ++j) {
                if (s[j][i] == '#') {
                    if (!(mask & (1 << j))) {
                        bad = true;
                        break;
                    }
                } else {
                    x ^= 1 << j;
                }
            }
            if (bad) continue;
            dp[i + 1][mask] += dp[i][x];
            if (mask == 3 && s[0][i] == '.' && s[1][i] == '.') {
                dp[i + 1][mask] += dp[i][3];
            }
            if (dp[i + 1][mask] > 2) dp[i + 1][mask] = 2;
        }
    }
    if (dp[n][3] == 0) {
        cout << "None\n";
    } else if (dp[n][3] == 1) {
        cout << "Unique\n";
    } else cout << "Multiple\n";
}

int main() {
//    freopen("input.txt", "r", stdin);
    cin.tie(0)->sync_with_stdio(false);
    cout << setprecision(15) << fixed;
    int t = 1;
    cin >> t;
    rep(i, 0, t) {
        solve();
    }
    return 0;
}
