#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int try_watch(int time, int watched, vector<int> episodes) {
    int answer = 0;
    for (int i = watched; i < episodes.size(); i++) {
        if (episodes[i] <= time) {
            answer++;
            time-=episodes[i];
        } else {
            break;
        }
    }
    return answer;
}

int main() {
    string output;
    int cases;
    cin >> cases;
    for (int c = 0; c < cases; c++) {
        int n, m, q;
        cin >> n >> m >> q;
        vector<pair<int, int>> tasks(n);
        for (int i = 0; i < n; i++) {
            cin >> tasks[i].first;
        }
        for (int i = 0; i < n; i++) {
            cin >> tasks[i].second;
            tasks[i].first = tasks[i].second - tasks[i].first;
        }
        vector<int> episodes(m);
        for (int i = 0; i < m; i++) {
            cin >> episodes[i];
        }
        vector<int> discusses(q);
        for (int i = 0; i < q; i++) {
            cin >> discusses[i];
        }
        // init ends
        std::sort(tasks.begin(), tasks.end());

//        for (auto &merged_task: tasks) {
//            std::cout << merged_task.first << " " << merged_task.second << endl;
//        }

        cout << endl;

        vector<pair<int, int>> merged_tasks;

        merged_tasks.push_back(tasks[n - 1]);

        for (int i = n - 2; i >= 0; i--) {
            if (tasks[i].second >= merged_tasks[0].first) {
                merged_tasks[0].first -= tasks[i].second - tasks[i].first;
            } else {
                merged_tasks.insert(merged_tasks.begin(), tasks[i]);
            }
        }

//        for (auto &merged_task: merged_tasks) {
//            std::cout << merged_task.first << " " << merged_task.second << endl;
//        }

        cout << endl;

        int watched = 0;
        int last = 0;
        int cur_discus = 0;

        vector<int> sorted_discusses(discusses);
        sort(sorted_discusses.begin(), sorted_discusses.end());


        std::map<int, int> answers;

        //todo long long
        for (int i = 0;;) {
            int meet_time = sorted_discusses[cur_discus];

            if (i < merged_tasks.size() && merged_tasks[i].first <= meet_time ) {
                int free_time = merged_tasks[i].first - last;
                for (int j = watched; j < episodes.size(); j++) {
                    if (episodes[j] <= free_time) {
                        watched++;
                        free_time-=episodes[j];
                    } else {
                        break;
                    }
                }
                last = merged_tasks[i].second-free_time;
                i++;
            } else {
                int free_time = meet_time - last;
                for (int j = watched; j < episodes.size(); j++) {
                    if (episodes[j] <= free_time) {
                        watched++;
                        free_time-=episodes[j];
                        last += episodes[j];
                    } else {
                        break;
                    }
                }
                answers[meet_time] = watched;
                cur_discus++;
                if (cur_discus == q) break;
            }
        }

        for (int i = 0; i < q; i++) {
            std::cout << answers[discusses[i]] << " ";
        }
        std::cout<<endl;
    }
    return 0;
}
