from queue import Queue

# n = 5
# history = [
#     'set true',
#     'unset true',
#     'set false',
#     'unset false',
#     'unset false',
# ]
# m = 2
# rules = [[1, 4], [5, 2]]

# n = 3
# history = [
#     'unset true',
#     'unset false',
#     'set true',
# ]
# m = 0
# rules = []

# n = 2
# history = [
#     'unset false',
#     'set true',
# ]
# m = 1
# rules = [[2, 1]]


# n = 2
# history = [
#     'unset false',
#     'set false',
# ]
# m = 0
# rules = []

n = int(input())
history = [input() for _ in range(n)]
m = int(input())
rules = [list(map(int, input().split())) for _ in range(m)]
history_2 = list(map(lambda x: x.split(), history))


def f_set(register):
    if not register:
        return True
    return False


def f_unset(register):
    if register:
        return True
    return False


def check(func: str, register: bool, result: str):
    if func == 'set':
        return f_set(register) == (result == 'true') 
    return f_unset(register) == (result == 'true')


def use(func: str):
    if func == 'set':
        return True
    return False


queue = Queue()
for i, (command, result) in enumerate(history_2):
    if check(command, False, result):
        queue.put([use(command), i+1])

answ = []
while not queue.empty():
    register, *hist = queue.get()

    if len(hist) == len(history_2):
        answ.append(hist)
        continue

    for i, (command, result) in enumerate(history_2):
        if i+1 in hist or not check(command, register, result):
            continue

        rules_ = list(filter(lambda x: i+1 == x[0], rules))
        flag = False
        for rule in rules_:
            if rule[1] in hist:
                flag = True
        if flag:
            continue

        queue.put([use(command), *hist, i+1])

if len(answ) == 0:
    print(-1)
else:
    print(*answ[0])
