def check_guard(s):
    for i in range(1, len(s) - 1):
        if s[i] == '.' and s[i-1] == '#' and s[i+1] == '#':
            return i
    return -1

def check_corner(s1, s2):
    for i in range(1, len(s1)):
        if s1[i] == '.' and s1[i-1] == '#' and s2[i] == '#':
            return i
    for i in range(0, len(s1) - 1):
        if s1[i] == '.' and s1[i+1] == '#' and s2[i] == '#':
            return i
    return -1

def fill(s1, s2):
    res = True
    res1 = s1
    res2 = s2
    i = check_guard(s1)
    if i != -1:
        if s2[i] != '.':
            return False
        s1[i] = '#'
        s2[i] = '#'
        st = res
        res, res1, res2 = fill(s1, s2)
        res = res and st
    i = check_guard(s2)
    if i != -1:
        if s1[i] != '.':
            return False
        s1[i] = '#'
        s2[i] = '#'
        st = res
        res, res1, res2 = fill(s1, s2)
        res = res and st

    i = check_corner(s1, s2)
    if i != -1:
        if s1[i - 1] != '.' and  s1[i + 1] != '.':
            return False
        s1[i] = '#'
        s1[i - 1] = '#'
        s1[i + 1] = '#'
        st = res
        res, res1, res2 = fill(s1, s2)
        res = res and st
    return res, res1, res2


n = int(input())
for _ in range(n):
    input()
    ss1 = list('#' + input() + '#')
    ss2 = list('#' + input() + '#')
    r, rs1, rs2 = fill(ss1, ss2)

    if not r:
        print("None")
        continue

    if ['.', '.'] in rs1:
        print('Multiple')
    else:
        print('Unique')

