//#pragma warning (disable : 4996)
#include <iostream>
#include <string>
#include <vector>

using namespace std;

int gcd(int a, int b) {
	while (b != 0) {
		a %= b;

		int temp = a;
		a = b;
		b = temp;
	}

	return a;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n;
	cin >> n;
	vector<int> finish;
	vector<int> current;
	vector<int> racerPos;

	for (int i = 0; i < n; i++) {
		int val;
		cin >> val;

		current.push_back(i);
		finish.push_back(val - 1);

		racerPos.push_back(i);
	}

	vector<pair<int, int>> ans;

	for (int i = 0; i < n; i++) {
		int curRacer = finish[i];

		int pos = racerPos[curRacer];
		for (; current[pos] != curRacer; pos++);

		while (pos + 1 < n) {
			ans.push_back(make_pair(current[pos + 1], current[pos]));

			swap(current[pos], current[pos + 1]);
			racerPos[current[pos]] = pos;
			racerPos[current[pos + 1]] = pos + 1;

			pos++;
		}

		pos--;
		while (pos >= i) {
			ans.push_back(make_pair(current[pos + 1], current[pos]));

			swap(current[pos], current[pos + 1]);
			racerPos[current[pos]] = pos;
			racerPos[current[pos + 1]] = pos + 1;

			pos--;
		}
	}

	cout << ans.size() << endl;
	for (auto it = ans.begin(); it != ans.end(); it++) {
		cout << it->first + 1 << ' ' << it->second + 1 << endl;
	}


	return 0;

	/*int T;
	cin >> T;

	for (int testId = 0; testId < T; testId++) {
		int W, H;
		cin >> W >> H;

		int w1, h1, x1, y1, dx1, dy1;
		int w2, h2, x2, y2, dx2, dy2;

		cin >> w1 >> h1 >> x1 >> y1 >> dx1 >> dy1;
		cin >> w2 >> h2 >> x2 >> y2 >> dx2 >> dy2;

		int cycleCount = 0;
		int intersectionCount = 0;

		int W1 = W - w1;
		int W2 = W - w2;
		int H1 = H - h1;
		int H2 = H - h2;

		int startX1 = x1;
		int startX2 = x2;
		int startY1 = y1;
		int startY2 = y2;

		do {
			cycleCount++;
			if (x1 >= x2 && x1 < x2 + w2 && y1 >= y2 && y1 < y2 + h2) {
				intersectionCount++;
			}
			else if (x2 >= x1 && x2 < x1 + w1 && y2 >= y1 && y2 < y1 + h1) {
				intersectionCount++;
			}

			x1 += dx1;
			x2 += dx2;
			y1 += dy1;
			y2 += dy2;

			if (x1 == 0 || x1 == W1) dx1 = -dx1;
			if (x2 == 0 || x2 == W2) dx2 = -dx2;
			if (y1 == 0 || y1 == H1) dy1 = -dy1;
			if (y2 == 0 || y2 == H2) dy2 = -dy2;

		} while (x1 != startX1 || x2 != startX2 || y1 != startY1 || y2 != startY2);

		int g = gcd(cycleCount, intersectionCount);
		cycleCount /= g;
		intersectionCount /= g;

		cout << intersectionCount << '/' << cycleCount << endl;
	}*/

	return 0;
}
