#include <bits/stdc++.h>

using namespace  std;

#define int long long

void add_extra_swap(int i, vector<int> &perm, vector<pair<int, int>> &ans, unordered_set<int> &extra, set<pair<int, int>> &extra_swaps) {
    if (extra_swaps.find({perm[i], perm[i + 1]}) != extra_swaps.end()) {
        return;
    }
    extra.insert((int)ans.size());
    ans.emplace_back(perm[i], perm[i + 1]);
    ans.emplace_back(perm[i + 1], perm[i]);
    extra_swaps.insert({perm[i], perm[i + 1]});
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    vector<int> indexes(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        v[i]--;
        indexes[v[i]] = i;
    }

    vector <pair<int, int>> ans;
    unordered_set <int> extra;
    set <pair<int, int>> swaps;
    set <pair<int, int>> extra_swaps;

    vector <int> perm(n);
    iota(perm.begin(), perm.end(), 0);

    for (int i = 0; i < (int)n - 1; i++) {
        add_extra_swap(i, perm, ans, extra, extra_swaps);
    }


    for (int i = 0; i < n; i++) {
        int cur_ind = find(perm.begin(), perm.end(), i) - perm.begin();

        for (int j = max(0ll, cur_ind - 2); j < min(n, cur_ind + 1); j++) {
            if (j + 1 < n) {
                add_extra_swap(j, perm, ans, extra, extra_swaps);
            }
        }

        while (cur_ind < indexes[i]) {
            ans.emplace_back(perm[cur_ind], perm[cur_ind + 1]);
            swap(perm[cur_ind], perm[cur_ind + 1]);
            swaps.insert(ans.back());
            cur_ind++;
        }

        while (cur_ind > indexes[i]) {
            ans.emplace_back(perm[cur_ind - 1], perm[cur_ind]);
            swap(perm[cur_ind - 1], perm[cur_ind]);
            swaps.insert(ans.back());
            cur_ind--;
        }

        for (int j = max(0ll, cur_ind - 2); j < min(n, cur_ind + 1); j++) {
            if (j + 1 < n) {
                add_extra_swap(j, perm, ans, extra, extra_swaps);
            }
        }

    }

    vector<int> skip(ans.size());

    for (auto i: extra) {
        if (swaps.find(ans[i]) != swaps.end() || swaps.find(ans[i + 1]) != swaps.end()) {
            skip[i] = 1;
            skip[i + 1] = 1;
        }
    }

    int cnt = 0;
    for (int i = 0; i < ans.size(); i++) {
        if (skip[i] == 0) {
            cnt++;
        }
    }

    cout << cnt << '\n';

    for (int i = 0; i < ans.size(); i++) {
        if (skip[i]) {
            continue;
        }

        cout << ans[i].second + 1 << ' ' << ans[i].first + 1 << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
    return 0;
}
