#include <iostream>
#include <vector>
#include <string>
#include <unordered_map>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> start(n);
    for (int i = 0; i < n; i++)
        cin >> start[i];

    vector<int> v(n);
    unordered_map<int, int> pos;
    for (int i = 0; i < n; i++) {
        pos[i + 1] = i;
        v[i] = i + 1;
    }

    vector<pair<int, int>> ans;
    for (int i = n - 1; i >= 0; i--) {
        int elem = start[i], pi = pos[elem];
        while (pi != 0) {
            ans.push_back({v[pi], v[pi - 1]});
            swap(v[pi], v[pi - 1]);
            swap(pos[v[pi]], pos[v[pi - 1]]);
            pi = pos[elem];
        }
//
//        while (pos[v[i]] != i) {
//            ans.push_back({v[i], v[i + 1]});
//            swap(v[i], v[i + 1]);
//            swap(pos[v[i]], pos[v[i + 1]]);
//        }
    }

    cout << ans.size() << '\n';
    for (auto [f1, f2] : ans)
        cout << f1 << ' ' << f2 << '\n';

    return 0;
}
