#include <iostream>
#include <cstdio>

using namespace std;

int main()
{
    int x;
    cin >> x;
    int cnt = 0;
    auto out = [&](int x)
    {
	printf("%04x\n", x);
	cnt++;
    };
    auto instr = [&](int a, int b, int c)
    {
	out(a);
	out(b);
	out(c);
	out(0);
    };
    for(int i = 0; i < 16; i++)
    {
	instr(0xfff0+i, 256*i+64+32+2, 16*i+4);
	instr(0xffe1, 0xfff0, 16*i+8);
	instr(0, 0, (x & (1 << i)) ? 260 : 16*i+16);
	instr(0, 0, (x & (1 << i)) ? 16*i+16 : 260);
    }
    if(cnt != 256)
	__builtin_trap();
    instr(0xffe0, 0xfff0, 260);
    for(int i = 1; i < 16; i++)
	instr(0xffe1, 0xfff0+i, i == 15 ? 4096 : 260+4*i);
    while(cnt < 4094)
	out(0);
    out(1);
    return 0;
}
