#include <iostream>
#include <vector>
#include <array>

using namespace std;

void solve(void)
{
    int n;
    cin >> n;
    string upper, lower;
    cin >> upper >> lower;
    vector<array<int, 4>> data(n+1);
    data[0][3] = 1;
    for(int i = 1; i <= n; i++)
	for(int mask = 0; mask < 4; mask++)
	{
	    bool up = mask & 1;
	    bool dn = mask & 2;
	    int M = mask;
	    if(upper[i-1] == '#')
	    {
		if(!up)
		    continue;
		M -= 1;
	    }
	    if(lower[i-1] == '#')
	    {
		if(!dn)
		    continue;
		M -= 2;
	    }
	    int cnt = 0;
	    if(M == 3)
		cnt += data[i-1][3];
	    cnt += data[i-1][M ^ 3];
	    if(cnt > 2)
		cnt = 2;
	    data[i][mask] = cnt;
	}
    /*for(int i = 0; i <= n; i++)
	for(int j = 0; j < 4; j++)
            cout << data[i][j] << ' ';*/
    cout << ((const char*[3]){"None\n", "Unique\n", "Multiple\n"})[data.back()[3]];
}

int main()
{
    int T;
    cin >> T;
    for(int I = 1; I <= T; I++)
	solve();
}
