#include <bits/stdc++.h>
using namespace std;

void bad()
{
    cout << -1;
    exit(0);
}

void topDfs(int i, int par, int needType, vector<vector<int> > &v, vector<int> &ans, vector<int> &arr,
            vector<int> &type, vector<bool> &mark, vector<bool> &t, bool needed = false)
{
    mark[i] = true;
    for (auto &u : v[i])
    {
        if (needed && !t[u])
            continue;
        if (mark[u] || u == par)
            continue;
        if (type[u] != needType)
            continue;

        topDfs(u, i, needType, v, ans, arr, type, mark, t, needed);
    }
    ans.push_back(i);
}

void solve() {

    int n;
    cin >> n;
    vector<int> type(n + 1);
    vector<vector<int> > nums(4);
    vector<vector<int> > v(n + 1);
    for (int i = 1; i <= n; i++)
    {
        string s;
        cin >> s;
        if (s == "set")
        {
            cin >> s;
            if (s == "true")
            {
                type[i] = 0;
            }
            else
            {
                type[i] = 1;
            }
        }
        else
        {
            cin >> s;
            if (s == "true")
            {
                type[i] = 2;
            }
            else
            {
                type[i] = 3;
            }
        }

        nums[type[i]].push_back(i);
    }

    if (nums[0].size() > 1 || nums[2].size() > 1)
    {
        bad();
    }

    if (nums[0].empty() && nums[2].size() == 1)
    {
        bad();
    }

    if (nums[0].empty() && !nums[1].empty())
        bad();

    int m;
    cin >> m;
    while (m--)
    {
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
    }

    int st, ut;
    st = ut = 0;
    if (!nums[0].empty())
        st = nums[0][0];
    if (!nums[2].empty())
        ut = nums[2][0];

    if (!nums[2].empty())
    {
        for (auto &u : v[ut])
        {
            if (u == st || type[u] == 1)
                bad();
        }
    }

    for (auto &sf : nums[1])
    {
        for (auto &u : v[sf])
        {
            if (u == st)
                bad();
        }
    }

    vector<int> centreAns;
    vector<bool> mark(n + 1);

    if (!nums[2].empty())
        centreAns.push_back(ut);

    for (int i = 1; i <= n; i++)
    {
        if (type[i] == 1 && !mark[i])
            topDfs(i, -100, 1, v, centreAns, nums[1],type, mark, mark);
    }

    if (!nums[0].empty())
        centreAns.push_back(st);

    vector<int> top;
    vector<int> bottom;
    vector<bool> t(n + 1);
    vector<bool> b(n + 1);

    for (auto &u : v[ut])
    {
        if (type[u] != 3)
            continue;
        b[u] = true;
    }
    for (auto &u : v[st])
    {
        if (type[u] != 3)
            continue;
        b[u] = true;
    }
    for (auto &sf : nums[1])
    {
        for (auto &u : v[sf])
        {
            if (type[u] != 3)
                continue;
            b[u] = true;
        }
    }

    for (auto &uf : nums[3])
    {
        for (auto &u : v[uf])
        {
            if (type[u] == 0 || type[u] == 1 || type[u] == 2)
                t[uf] = true;
        }
    }

    for (auto &uf : nums[3])
    {
        if (t[uf] && b[uf])
            bad();

        if (b[uf])
        {
            bottom.push_back(uf);
            continue;
        }
        else
        {
            top.push_back(uf);
        }
    }

    if (!bottom.empty() && nums[2].empty())
        bad();

    for (auto &uf : bottom)
    {
        for (auto &u : v[uf])
        {
            if (type[u] != 3)
                continue;

            if (t[u])
                bad();
        }
    }

    vector<int> upAns;
    vector<int> downAns;

    for (auto &uf : top)
        topDfs(uf, -100, 3, v, upAns, top, type, mark, t, true);
    for (auto &uf : bottom)
        topDfs(uf, -100, 3, v, downAns, bottom, type, mark, b, true);

    reverse(centreAns.begin(), centreAns.end());
    reverse(upAns.begin(), upAns.end());
    reverse(downAns.begin(), downAns.end());

    for (auto &u : upAns)
        cout << u << " ";

    for (auto &u : centreAns)
        cout << u << " ";

    for (auto &u : downAns)
        cout << u << " ";
}


int32_t main()
{

        solve();

}
