#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    n *= 2;
    vector<int> a(n);
    for (auto &i: a)cin >> i, --i;
    vector<vector<array<int, 2>>> g(n);
    int k = n / 2;
    vector<vector<int>> where(k);
    vector<array<int, 2>> E;
    for (int i = 0; i < n; ++i) {
        where[a[i]].push_back(i);
    }
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
        E.push_back({u, v});
    }
    if (n == 2) {
        cout << "0\n";
        return;
    }
    vector<array<int, 3>> match;
    vector<int> other(n, -1);
    auto dfs = [&](auto &&dfs, int v, int p) -> int {
        int re = v;
        for (auto [to, id]: g[v]) {
            if (to == p)continue;
            int it = dfs(dfs, to, v);
            if (~it && ~re) {
                int u = it, v = re;
                if (u > v)swap(u, v);
                other[u] = v;
                other[v] = u;
                match.push_back({u, v, id});
                re = -1;
            }
        }
        return re;
    };
    for (int v = 0; v < n; ++v) {
        if (g[v].size() > 1) {
            dfs(dfs, v, -1);
            break;
        }
    }
    vector<vector<array<int, 2>>> G(n);
    vector<char> hz(n, 1);
    for (auto [u, v, id]: match) {
        u = a[u];
        v = a[v];
        G[u].push_back({v, id});
        G[v].push_back({u, id});
        hz[u] = hz[v] = 0;
    }
    vector<array<int, 2>> res;
    auto sw = [&](int x, int y) {
        res.push_back({x, y});
        swap(a[x], a[y]);
        {
            auto it = find(where[a[x]].begin(), where[a[x]].end(), x);
            where[a[x]].erase(it);
            where[a[x]].push_back(y);
        }
        {
            auto it = find(where[a[y]].begin(), where[a[y]].end(), y);
            where[a[y]].erase(it);
            where[a[y]].push_back(x);
        }
    };
    vector<char> used(k);
    for (int v = 0; v < k; ++v) {
        if (used[v] || G[v].size() != 1)continue;
        vector<array<int, 2>> ord;
        auto dfs = [&](auto &&dfs, int v) ->void{
            used[v] = 1;
            for (auto [to, id]: G[v]) {
                if (used[to])continue;
                ord.push_back({E[id][0], E[id][1]});
                dfs(dfs,to);
            }
        };
        dfs(dfs, v);
        for (int i = 0; i + 1 < ord.size(); ++i) {
            if (a[ord[i][1]] != a[ord[i + 1][0]])swap(ord[i], ord[i + 1]);
        }
        int t = ord.size();
        for (int i = 0; i < ord.size() / 2; ++i) {
            int fi = t - i - 1;
            if (fi > i) {
                sw(ord[i][0], ord[fi][0]);
                swap(ord[i][0], ord[fi][0]);
            }
            int se = fi - 1;
            if (se > i) {
                sw(ord[i][1], ord[se][1]);
                swap(ord[i][1], ord[se][1]);
            }
        }
        int it = ord.back()[0];
        for (auto x: where[a[it]]) {
            if (x == it)continue;
            sw(it, x);
        }
    }
    for (int v = 0; v < k; ++v) {
        if (used[v])continue;
        set<array<int, 2>> match;
        int num = 0;
        auto dfs = [&](auto &&dfs, int v) ->void{
            used[v] = 1;
            ++num;
            for (auto [to, id]: G[v]) {
                if (used[to]) {
                    auto [x,y] = E[id];
                    match.insert({min(x, y),max(x,y)});
                    continue;
                }
                dfs(dfs,to);
            }
        };
        dfs(dfs, v);
        if (match.empty())continue;
        assert(num == match.size());
        auto it = *match.begin();
        int cur = it[0];
        while (1) {
            int o = other[cur];
            match.erase({min(cur, o), max(cur, o)});
            if (a[cur] == a[o])break;
            int nw = -1;
            for (auto x: where[a[cur]]) {
                if (x == cur)continue;
                nw = x;
            }
            sw(o, nw);
            cur = nw;
        }
    }
    cout << res.size() << "\n";
    for (auto [u, v]: res) {
        cout << u + 1 << " " << v + 1 << "\n";
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--)solve();
}
