#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

#define p_b push_back
#define e_b emplace_back
#define m_p make_pair
#define fi first
#define se second
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF = 1e18 + 2;
const ll N = 1e6 + 2;

std::optional<vector<int>> solve() {
    int n;
    cin >> n;
    vector<vector<int>> edges(n);
    vector<bool> is_set(n), res(n);
    for (int i = 0; i < n; i++) {
        string s, t;
        cin >> s >> t;
        is_set[i] = (s == "set");
        res[i] = (t == "true");
    }
    int m;
    cin >> m;
    vector<int> in_cnt(n, 0);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        edges[v].p_b(u);
        in_cnt[u]++;
    }
    vector<int> q;
    vector<bool> used(n, false);
    for (int i = 0; i < n; i++) {
        if (in_cnt[i] == 0) {
            q.p_b(i);
            used[i] = true;
        }
    }
    vector<int> ans;
    auto add_all = [&](bool x, bool y) {
        vector<int> p;
        while (!q.empty()) {
            int v = q.back();
            q.pop_back();
            if (is_set[v] == x && res[v] == y) {
                ans.p_b(v);
                for (int to: edges[v]) {
                    in_cnt[to]--;
                    if (!in_cnt[to]) {
                        q.p_b(to);
                    }
                }
            } else {
                p.p_b(v);
            }
        }
        q = p;
    };
    auto add_one = [&](bool x, bool y) {
        vector<int> p;
        bool was = false;
        while (!q.empty()) {
            int v = q.back();
            q.pop_back();
            if (!was && is_set[v] == x && res[v] == y) {
                was = true;
                ans.p_b(v);
                for (int to: edges[v]) {
                    in_cnt[to]--;
                    if (!in_cnt[to]) {
                        q.p_b(to);
                    }
                }
            } else {
                p.p_b(v);
            }
        }
        q = p;
        return was;
    };

    add_all(false, false);
    if (q.empty()) return ans;

    if (!add_one(true, true)) return nullopt;

    add_all(true, false);
    if (q.empty()) return ans;

    if (!add_one(false, true)) return nullopt;

    add_all(false, false);
    if (q.empty()) return ans;

    return nullopt;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    auto res = solve();
    if (!res.has_value()) {
        cout << -1;
    } else {
        for (int x: *res) cout << x + 1 << " ";
    }
    return 0;
}
