#include <bits/stdc++.h>


using namespace std;

#define int long long
#define all(a) (a).begin(),(a.end())

void solve() {
    int n;
    cin >> n;
    vector<string> vert(n);
    map<string, vector<int>> vert_to_i;
    for (int i = 0; i < n; i++) {
        string tmp1, tmp2;
        cin >> tmp1 >> tmp2;
        if (tmp1 == "set" && tmp2 == "true") {
            vert[i] = "TF";
        }
        if (tmp1 == "unset" && tmp2 == "true") {
            vert[i] = "FT";
        }
        if (tmp1 == "set" && tmp2 == "false") {
            vert[i] = "FF";
        }
        if (tmp1 == "unset" && tmp2 == "false") {
            vert[i] = "TT";
        }
        vert_to_i[vert[i]].push_back(i);
    }
    if (vert_to_i["TF"].size() == 2 || vert_to_i["FT"].size() == 2
        || (vert_to_i["TF"].size() == 0 && vert_to_i["FT"].size() + vert_to_i["FF"].size() >= 1)) {
        cout << "-1";
        return;
    }
    vector<int> cnt_in(n);
    vector<vector<int> > out(n);

    int m;
    cin >> m;
    for (int q = 0; q < m; q++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        out[a].push_back(b);
        cnt_in[b]++;
    }
    vector<bool> can(n, false);
    map<string, set<int>> can_verts;
    for (int q = 0; q < n; q++) {
        if (cnt_in[q] == 0) {
            can[q] = true;
            can_verts[vert[q]].insert(q);
        }
    }
    auto use_edge = [&](int i) {
        for (int x: out[i]) {
            cnt_in[x]--;
            if (cnt_in[x] == 0) {
                can[x] = true;
                can_verts[vert[x]].insert(x);
            }
        }
        return;
    };
    vector<int> res;
    while (!can_verts["TT"].empty()) {
        auto x = can_verts["TT"].begin();
        res.push_back(*x);
        use_edge(*x);
        can_verts["TT"].erase(x);
    }
    if (can_verts["TF"].empty() && res.size() < n) {
        cout << "-1";
        return;
    }
    if (res.size() == n) {
        for (int q: res) {
            cout << q + 1 << " ";
        }
        return;
    }
    {
        auto it = can_verts["TF"].begin();
        use_edge(*it);
        res.push_back(*it);
        can_verts["TF"].erase(it);
    }
    while (!can_verts["FF"].empty()) {
        auto x = can_verts["FF"].begin();
        res.push_back(*x);
        use_edge(*x);
        can_verts["FF"].erase(x);
    }
    if (res.size() == n) {
        for (int q: res) {
            cout << q + 1 << " ";
        }
        return;
    }
    if (can_verts["FT"].empty() && res.size() < n) {
        cout << "-1";
        return;
    }
    {
        auto it = can_verts["FT"].begin();
        use_edge(*it);
        res.push_back(*it);
        can_verts["FT"].erase(it);
    }
    while (!can_verts["TT"].empty()) {
        auto x = can_verts["TT"].begin();
        res.push_back(*x);
        use_edge(*x);
        can_verts["TT"].erase(x);
    }
    if (res.size() == n) {
        for (int q: res) {
            cout << q + 1 << " ";
        }
        return;
    }
    cout << "-1";
}

int32_t main() {

    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
}
/*
5
 set true
 unset true
 set false
 unset false
 unset false
 2
 1 4
 5 2

*/
