#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define all(x) (x).begin(), (x).end()

using namespace std;

const int inf = -1e15;

void solve(){
    string q;
    cin >> q;
    int n = q.size();
    auto parse_number = [&](string_view str) {
        if(str.empty() || str.size() > 10 || (str.size() > 1 && str[0] == '0')) return inf;
        int x = 0;
        for(auto c: str){
            if(c < '0' || c > '9') return inf;
            x = (x * 10) + c - '0';
        }
        // cout << x << '\n';
        return x;
    };
    auto parse_expr = [&](string_view str) {
        int prev = 0;
        int x = 0;
        int sign = 1;
        for(int i = 0; i < str.size(); i++){
            if(str[i] == '+' || str[i] == '-') {
                int y = parse_number(str.substr(prev, i - prev));
                if(y == inf) return inf;
                x += y * sign;
                prev = i + 1;
                sign = str[i] == '-' ? -1 : 1;
                // cout << x << ' ' << y << ' ' << sign << '\n';
            }
        }
        // cout << str.size() << ' ' << prev << '\n';
        if(prev >= str.size()) return inf;
        int y = parse_number(str.substr(prev, str.size() - prev));
        // cout << "y " << y << '\n';
        if(y == inf) return inf;
        x += y * sign;
        return x;
    };
    auto parse_eq = [&](string_view str) {
        int x = inf, y = inf;
        for(int i = 0; i < str.size(); i++){
            if(str[i] == '=') {
                x = parse_expr(str.substr(0, i));
                // cout << x << '\n';
                y = parse_expr(str.substr(i + 1, str.size() - (i + 1)));
                break;
            }
        }
        // cout << x << ' ' << y << '\n';
        return (x != inf && y != inf && x == y ? true : false);
    };
    if(parse_eq(q)){
        cout << "Correct";
        return;
    }
    for(int i = 0; i < n; i++) {
        if(q[i] == '-' || q[i] == '+' || q[i] == '=') continue;
//        cout << q[i] << '\n';
        string qq = (i ? q.substr(0, i) : "") + (i + 1 != n ? q.substr(i + 1, n - (i + 1)) : "");
        for(int j = 0; j < n; j++){
            string cpy = qq;
            cpy.insert(j, 1, q[i]);
            if(parse_eq(cpy)) {
                cout << cpy;
                return;
            }
        }
//        cout << qq << '\n';
    }
    cout << "Impossible";
}

//
// void solve() {
//     int n;
//     cin >> n;
//     vector<string> types(n);
//     for(auto& s: types) {
//         cin >> s;
//         string t;
//         cin >> t;
//         s += t;
//     }
//     int m;
//     cin >> m;
//     vector<vector<int>> g(n);
//     for(int i = 0; i < m; i++) {
//         int v, u;
//         cin >> v >> u;
//         v--;
//         u--;
//         g[v].push_back(u);
//     }
//     vector<int> used(n);
//     vector<int> topo;
//     auto dfs = [&](auto &&dfs, int v) -> void {
//         used[v] = 1;
//         for(auto u: g[v]){
//             if(used[u]) continue;
//             dfs(dfs, u);
//         }
//         topo.push_back(v);
//     };
//     for(const auto& str: {"unsettrue", "setfalse", "settrue", "unsetfalse"}) {
//        for(int i = 0; i < n; i++) {
//            if(used[i] || types[i] != str) continue;
//            dfs(dfs, i);
//        }
//        for(auto v: topo) cout << v + 1 << ' ';
//        cout << '\n';
//     }
//     reverse(all(topo));
//     for(auto v: topo) cout << v + 1 << ' ';
//     const string strs[5] = {"unsetfalse", "settrue", "setfalse", "unsettrue", "unsetfalse"};
//     int cur = 0;
//     for(auto v: topo) {
//        while(cur < 5 && types[v] != strs[cur]) {
//            cur++;
//        }
//        if(cur == 5) {
//            cout << "-1\n";
//            return;
//        }
//     }
//     for(auto v: topo) {
//         cout << v + 1 << ' ';
//     }
//     cout << '\n';
// }

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
