#include  <bits/stdc++.h>

typedef long long ll;

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> op(n);
    for (int i = 0; i < n; ++i) {
        string a, b;
        cin >> a >> b;
        int ind = ((a == "unset") << 0) + ((b == "true") << 1);
        op[i] = ind;
    }
    vector<vector<int>> g(n);
    vector<int> in(n);
    int m;
    cin >> m;
    while (m--) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        ++in[v];
    }
    vector<int> ord = {1, 2, 0, 3, 1};
    vector<int> need = {1, 0, 0, 1};
    vector<int> free[4];
    for (int i = 0; i < n; ++i) {
        if (in[i] == 0) {
            free[op[i]].push_back(i);
        }
    }
    vector<int> ans;
    int val = 0;
    for (int x : ord) {
        int hap = 0;
        if (val == need[x]) {
            for (int i: free[x]) {
                ans.push_back(i);
                ++hap;
                for (int y: g[i]) {
                    --in[y];
                    if (in[y] == 0) {
                        free[op[y]].push_back(y);
                    }
                }
            }
            free[x].clear();
        }
        if (x == 2) {
            if (hap > 1) {
                cout << "-1\n";
                return;
            }
            if (hap == 1) val = 1;
        } else if (x == 3) {
            if (hap > 1) {
                cout << "-1\n";
                return;
            }
            if (hap == 1) val = 0;
        }
    }
    if (ans.size() == n) {
        for (int y : ans) cout << y + 1 << ' ';
        cout << '\n';
    } else {
        cout << "-1\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}