#include <iostream>
#include <vector>
using namespace std;

void solve() {
    size_t n; cin >> n;
    string up, down;
    cin >> up >> down;
    bool multiple = false;
    for(int i = 0; i < n; i++){
        if(up[i] == '#' && down[i] == '#')
            continue;
        else if(up[i] == '.' && down[i] == '.'){
            up[i] = '#';
            down[i] = '#';
            if(i < n-1 && up[i+1] == '.' && down[i+1] == '.'){
                multiple = true;
                up[i+1] = '#';
                down[i+1] = '#';
            }
        }
        else if(i == n-1){
            cout << "None" << '\n';
            return;
        }
        else if(up[i] == '.' && up[i+1] == '.'){
            up[i] = '#';
            up[i+1] = '#';
        }
        else if(down[i] == '.' && down[i+1] == '.'){
            down[i] = '#';
            down[i+1] = '#';
        }
        else{
            cout << "None" << '\n';
            return;
        }
    }
    cout << (multiple? "Multiple" : "Unique") << '\n';
}

int main()
{
    size_t t;
    cin >> t;
    while(t--){
        solve();
    }
}
