#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> needPos(n);

    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        x--;
        needPos[x] = i;    
    }

    vector<int> now(n);
    iota(now.begin(), now.end(), 0);

    vector<pair<int, int>> ans;

    for (int i = 0; i < n; i++) {
        int j = 0;

        while (j < n - i - 1) {
            ans.push_back({now[j + 1], now[j]});
            swap(now[j], now[j + 1]);
            j++;
        }
    }

    for (int i = n - 1; i >= 0; i--) {
        int j = i;

        while (j > needPos[now[j]]) {
            ans.push_back({now[j], now[j - 1]});
            swap(now[j], now[j - 1]);
            j--;
        }
    }

    cout << ans.size() << '\n';

    for (auto [x, y] : ans) {
        cout << x + 1 << ' ' << y + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    // freopen("input.txt", "r", stdin);

    int t = 1; 
    // cin >> t;

    while (t--) {
        solve();
    }
}
