#include <bits/stdc++.h>
using namespace std;

void upd(int n, vector<int>& a, vector<int>& pos, vector<vector<bool>>& used, vector<pair<int, int>>& ans) {
    for(int i = 0; i + 1 < n; i++) {
        if(!used[a[i]][a[i + 1]] && pos[a[i]] < pos[a[i + 1]]) {
            used[a[i]][a[i + 1]] = used[a[i + 1]][a[i]] = 1;
            ans.push_back({a[i + 1], a[i]});
            ans.push_back({a[i], a[i + 1]});
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<bool>> used(n + 1, vector<bool>(n + 1, 0));
    vector<int> a(n);
    for(int i = 0; i < n; i++) a[i] = i + 1;
    vector<int> b(n);
    for(int i = 0; i < n; i++) cin >> b[i];
    vector<int> pos(n + 1);
    for(int i = 0; i < n; i++) pos[b[i]] = i;
    vector<pair<int, int>> ans;
    upd(n, a, pos, used, ans);
    for(int ti = 0; ti < n + 5; ti++) {
        for(int i = n - 1; i > 0; i--) {
            if(pos[a[i]] < pos[a[i - 1]]) {
                if(!used[a[i]][a[i - 1]]) {
                    ans.push_back({a[i], a[i - 1]});
                    used[a[i]][a[i - 1]] = used[a[i - 1]][a[i]] = 1;
                }
                swap(a[i], a[i - 1]);
            }
        }
        upd(n, a, pos, used, ans);
    }
    cout << ans.size() << '\n';
    for(auto i : ans) {
        cout << i.first << ' ' << i.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;
    // cin >> t;
    while(t--) solve();
    return 0;
}