#include <bits/stdc++.h>

using namespace std;

const int maxn = 3e5 + 5;

int in[maxn];
int out[maxn];
vector<vector<int>> g(maxn);
int st[maxn];

queue<int> q[2][2];

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        string s1, s2;
        cin >> s1 >> s2;

        bool c1 = s1 == "set";
        bool c2 = s2 == "true";

        if (c1 && c2) {
            in[i] = false;
            out[i] = true;
        } else if (c1 && !c2) {
            in[i] = true;
            out[i] = true;
        } else if (!c1 && c2) {
            in[i] = true;
            out[i] = false;
        } else if (!c1 && !c2) {
            in[i] = false;
            out[i] = false;
        }
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;

        --u;
        --v;
        st[v]++;
        g[u].push_back(v);
    }

    int cur = 0;


    for (int i = 0; i < n; ++i) {
        if (st[i] == 0) {
            q[in[i]][out[i]].push(i);
        }
    }
    vector<int> answer;

    while (q[0][0].size() || q[0][1].size() || q[1][0].size() || q[1][1].size()) {
        if (cur == 0) {
            if (q[0][0].size()) {
                answer.push_back(q[0][0].front());
                q[0][0].pop();
            } else if (q[0][1].size()) {
                answer.push_back(q[0][1].front());
                q[0][1].pop();
                cur = 1;
            } else {
                cout << -1;
                return;
            }
        } else {
            if (q[1][1].size()) {
                answer.push_back(q[1][1].front());
                q[1][1].pop();
            } else if (q[1][0].size()) {
                answer.push_back(q[1][0].front());
                q[1][0].pop();
                cur = 0;
            } else {
                cout << -1;
                return;
            }
        }

        int v = answer.back();

        for (auto now: g[v]) {
            st[now]--;
            if (st[now] == 0) {
                q[in[now]][out[now]].push(now);
            }
        }
    }

    for(auto now : answer) cout << now + 1 << ' ';
}
/*
 5
 set true
 unset true
 set false
 unset false
 unset false
 2
 1 4
 5 2

 3
 unset true
 unset false
 set true
 0

 2
 unset false
 set true
 1
 2 1


 2
 unset false
 set false
 0
 */

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    // cin >> t;

    while (t-- > 0) {
        solve();
    }
    return 0;
}
