#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <sstream>
#include <cstring>
#include <numeric>
#include <ctime>

using namespace std;

int n;
long long was[200005][4];
string s[2];

long long dp(int p, int k) {
	if (p == n) {
		if (k == 0)
			return 1;
		else
			return 0;
	}
	if (was[p][k] != -1) {
		return was[p][k];
	}
	long long ans = 0;
	if (s[0][p] == '.' && s[1][p] == '.') {
		if (k == 0) {
			ans += dp(p + 1, 0);
			if (p + 1 < n && s[0][p + 1] == '.' && s[1][p + 1] == '.')
				ans += dp(p + 1, 3);
		}
		if (k == 1) {
			if (p + 1 < n && s[1][p + 1] == '.')
				ans += dp(p + 1, 2);
		}
		if (k == 2) {
			if (p + 1 < n && s[0][p + 1] == '.')
				ans += dp(p + 1, 1);
		}
		if (k == 3) {
			ans += dp(p + 1, 0);
		}
	}
	else if (s[0][p] == '#' && s[1][p] != '#') {
		if (k == 0) {
			if (p + 1 < n && s[1][p + 1] == '.')
				ans += dp(p + 1, 2);
		}
		if (k == 2) {
			ans += dp(p + 1, 0);
		}
	}
	else if (s[1][p] == '#' && s[0][p] != '#') {
		if (k == 0) {
			if (p + 1 < n && s[0][p + 1] == '.')
				ans += dp(p + 1, 1);
		}
		if (k == 1) {
			ans += dp(p + 1, 0);
		}
	}
	else {
		ans += dp(p + 1, 0);
	}
	if (ans > 2) {
		ans = 2;
	}
	was[p][k] = ans;
	return ans;
}

void solve() {
	cin >> n;
	cin >> s[0] >> s[1];
	for (int i = 0; i < n; i++) {
		was[i][0] = -1;
		was[i][1] = -1;
		was[i][2] = -1;
		was[i][3] = -1;
	}
	auto c = dp(0, 0);
	if (c == 0) {
		cout << "None\n";
	}
	if (c > 1) {
		cout << "Multiple\n";
	}
	if (c == 1) {
		cout << "Unique\n";
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}