#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <sstream>
#include <cstring>
#include <numeric>
#include <ctime>

using namespace std;



void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	vector<long long> a(n), d(n), l(m), ans(q);
	vector<pair<long long, long long>> p(n), t(q);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> l[i];
		if (i) {
			l[i] += l[i - 1];
		}
	}
	for (int i = 0; i < q; i++) {
		long long z;
		cin >> z;
		t[i] = { z, i };
	}
	for (int i = 0; i < n; i++) {
		p[i] = { d[i], a[i] };
	}
	sort(p.begin(), p.end());
	sort(t.begin(), t.end());
	int i = 0, j = 0, z = 0;
	long long sd = 0;
	for (auto x : t) {
		auto ti = x.first;
		while (i < n && p[i].first <= ti) {
			sd += p[i].second;
			i++;
		}
		long long res = ti - sd;
		if (i < n) {
			if (p[i].first >= ti) {
				res -= max(0ll, ti - (p[i].first - p[i].second));
			}
		}
		auto temp = upper_bound(l.begin(), l.end(), res) - l.begin();
		ans[x.second] = temp;
	}
	for (auto x : ans) {
		cout << x << " ";
	}
	cout << "\n\n";
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}

