#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using vs = vector<string>;
using vi = vector<int>;
using vvi = vector<vi>;
#define hashmap unordered_map
#define all(c) c.begin(), c.end()

int main() {
    int n;
    cin >> n;

    vi seq(n);
    for (int i = 0; i < n; ++i) cin >> seq[i];

    vector<pii> overtakes;
    for (int len = n; len > 1; --len) {
        for (int i = 1; i < len; ++i) {
            if (seq[i - 1] < seq[i]) {
                overtakes.push_back({seq[i - 1], seq[i]});
                swap(seq[i - 1], seq[i]);
            }
        }
    }
    for (int len = n; len > 1; --len) {
        for (int i = 1; i < len; ++i) {
            if (seq[i - 1] > seq[i]) {
                overtakes.push_back({seq[i - 1], seq[i]});
                swap(seq[i - 1], seq[i]);
            }
        }
    }

    reverse(all(overtakes));
    cout << overtakes.size() << '\n';
    for (pii ot: overtakes) {
        cout << ot.first << ' ' << ot.second << '\n';
    }
}
