#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using vs = vector<string>;
using vi = vector<int>;
using vvi = vector<vi>;
#define hashmap unordered_map

#define TOP 0
#define BOTTOM 1
#define BOTH 2


int dp(vvi &damag, hashmap<ull, int> &mem, int top, int bot) {
    int hash = ((ull) top << 32) + bot;
    if (mem.count(hash) != 0) {
        return mem[hash];
    }

    while (top >= 0 and damag[0][top] == 0) top--;
    while (bot >= 0 and damag[1][bot] == 0) bot--;

    int res = 0;
    if (top < 0 and bot < 0) res = 1;

    else if (top > bot) {
        if (top > 0 and damag[0][top - 1] == 1)
            res += dp(damag, mem, top - 2, bot);
    } else if (top < bot) {
        if (bot > 0 and damag[1][bot - 1] == 1)
            res += dp(damag, mem, top, bot - 2);
    } else {
        res += dp(damag, mem, top - 1, bot - 1);
        if (top > 0 and damag[0][top - 1] == 1 and damag[1][bot - 1] == 1)
            res += 2 * dp(damag, mem, top - 2, bot - 2);
    }

    return mem[hash] = res;
}


int main() {
    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        int len;
        cin >> len;

        vvi damag(2, vi(len, 0));
        for (int r = 0; r < 2; ++r) {
            for (int c = 0; c < len; ++c) {
                char chr;
                cin >> chr;
                if (chr == '.') damag[r][c] = 1;
            }
        }

        hashmap<ull, int> mem;
        int res = dp(damag, mem, len - 1, len - 1);

//        for (int r = 0; r < 3; ++r) {
//            for (int c = 0; c < len; ++c) {
//                cout << mem[r][c] << ' ';
//            }
//            cout << endl;
//        }

        if (res == 1) cout << "Unique\n";
        else if (res == 0) cout << "None\n";
        else cout << "Multiple\n";
    }
}
