#include <bits/stdc++.h>

using namespace std;

#define SP ' '
#define LF '\n'
#define rep(i, a, b) for(ll i = (a); i < (b); i++)
#define all(x) (x).begin(), (x).end()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;
	vector<int> c(n);
	rep(i, 0, n) {
		cin >> c[i];
	}
	reverse(all(c));

	using pii = pair<int, int>;
	vector<pii> ans;
	vector<int> curr(n);
	iota(all(curr), 1);
	reverse(all(curr));
	rep(i, 0, n - 1) {
		rep(j, 1, n - i) {
			ans.emplace_back(curr[j - 1], curr[j]);
			swap(curr[j - 1], curr[j]);
		}
	}
	// cout << ans.size() << endl;
	assert(is_sorted(all(curr)));

	rep(i, 0, n - 1) {
		int pos = -1;
		rep(j, 0, n) {
			if (curr[j] == c[i]) {
				pos = j;
				break;
			}
		}
		assert(pos >= 0);
		for (int j = pos - 1; j >= i; j--) {
			ans.emplace_back(curr[j], curr[j + 1]);
			swap(curr[j], curr[j + 1]);
		}
		// cout << "dbg: " << ans.size() << endl;
	}
	cout << ans.size() << LF;
	for (auto [u, v] : ans) {
		cout << u << SP << v << LF;
	}
}
