#include <bits/stdc++.h>

#define ll long long
#define pl pair<ll,ll>
#define vl vector<ll>
#define all(a) a.begin(), a.end()

using namespace std;


const ll N = 1<<12;
uint16_t bitmem[N];
uint16_t work_mem[N];


char hexcodes[16];

void check(ll x) {
    copy(bitmem, bitmem + N, work_mem);
    work_mem[4095] = x;

    ll ip = 0;
    for (ll i = 0; i < 100 && ip + 2 < N; i++) {
        ll a = work_mem[ip+0];
        ll b = work_mem[ip+1];
        ll bit = work_mem[a>>4]>>(a&15) & 1;
        ll temp = ~(~work_mem[b>>4] | 1<<b&15);
        work_mem[b>>4] = temp | bit << (b&15);
        cerr << "Test: " << ip << ' ' << a << ' ' << b << ' ' << temp << ' ' << bit << ' ' << work_mem[ip+2] << endl;
        ip = work_mem[ip+2];
    }

    cerr << work_mem[4095];
}

string to_hex(uint16_t n) {
    string res = "";
    while (n) {
        res += hexcodes[n & 15];
        n >>= 4;
    }
    while (res.size() < 4) res += "0";
    reverse(all(res));
    return res;
}

void solve() {
    for (ll i = 0; i < 10; i++) hexcodes[i] = '0' + i;
    for (ll i = 0; i < 6; i++) hexcodes[10+i] = 'a' + i;

    ll x; cin >> x;
    vl const_words(2);
    for (ll i = 0; i < 16; i++) {
        ll off = i * 3;
        bitmem[off + 0] = 0xfff0 + i;
        bitmem[off + 1] = (48 + off) << 4;
        bitmem[off + 2] = off + 3;
    }

    for (ll i = 0; i < 16; i++) {
        ll off = i * 3 + 48;
        bitmem[off + 0] = (96 + i << 4);
        bitmem[off + 1] = 112 << 4;
        // bitmem[off + 1] = 0xfff0;
        bitmem[off + 2] = off + 3;
    }

    for (ll i = 0; i < 16; i++) {
        ll off = 96 + i;
        ll bit = (x >> i) & 1;
        bitmem[off] = (bit ? 1 : 2);
    }

    bitmem[95] = 112;
    bitmem[112] = 115 << 4;
    bitmem[113] = 0xfff0;
    bitmem[114] = 125;

    bitmem[115] = 0x0001;

    // Terminator
    bitmem[125] = 0;
    bitmem[126] = 0;
    bitmem[127] = 125;

    // ll x; cin >> x;
    // vl const_words(2);
    // const_words[0] = (49 << 4) | 0;
    // const_words[1] = (49 << 4) | 1;
    // bitmem[49] = 0b0010;
    // for (ll i = 0; i < 16; i++) {
    //     ll off = i * 3;
    //     bitmem[off + 0] = const_words[x >> i & 1];
    //     bitmem[off + 1] = 0xfff0 + i;
    //     bitmem[off + 2] = off + 3;
    // }
    // bitmem[48] = 50;
    // bitmem[52] = 52;


    // for (ll i = 0; i < N; i++) cerr << i << " -> " << "(" << bitmem[i] << ": " << (bitmem[i] >> 4) << ", " << (bitmem[i] & 15) << ")" << '\n';
    for (ll i = 0; i < N; i++) cout << to_hex(bitmem[i]) << ' ';
    cerr << endl;
    // check(1);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) solve();
}