#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define int ll

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}
const int INF = 1e15;

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <pair <int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int x, y, c;
        cin >> x >> y >> c; --x; --y;
        g[y].emplace_back(x, c);
    }

    vector <int> d(n, INF);
    d[n - 1] = 0;
    set <pair <int, int>> s;
    s.insert({0, n - 1});
    while (!s.empty()) {
        auto [cost, v] = *s.begin();
        s.erase(s.begin());
        for (auto i : g[v]) {
            if (d[i.first] > cost + i.second) {
                s.erase({d[i.first], i.first});
                d[i.first] = cost + i.second;
                s.insert({d[i.first], i.first});
            }
        }
    }

    vector <int> dd(n, INF);
    vector <int> ok_out(n);

    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (d[j.first] == d[i] + j.second) ++ok_out[j.first];
        }
    }

    vector <int> used(n);
    s.clear();
    used[n - 1] = 1;
    for (int i = 0; i < n; ++i) {
        if (d[i] == INF) {
            dd[i] = -1;
            s.insert({-1, i});
        }
    }

    while (!s.empty()) {
        auto [cost, v] = *s.begin();
        s.erase(s.begin());
        used[v] = 1;

        for (auto i : g[v]) {
            if (dd[i.first] == -1) continue;
            if (i.first == n - 1) continue;
            int nd;
            if (d[i.first] == d[v] + i.second) {
                --ok_out[i.first];
                if (ok_out[i.first]) {
                    nd = cost + 1;
                } else {
                    nd = cost;
                }
            } else {
                nd = cost + 1;
            }

            if (nd < dd[i.first]) {
                s.erase({dd[i.first], i.first});
                dd[i.first] = nd;
                s.insert({nd, i.first});
            }
        }
    }

    cout << min(n, dd[0]);
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}