#pragma GCC optimize("O3,unroll-loops")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define pbc push_back
#define mp make_pair
#define all(v) begin(v),end(v)
#define vin(v) for (auto &el : v) cin >> el

mt19937 rnd(179);

template<typename T1, typename T2>
inline void chkmin(T1 &x, const T2 &y) {
    if (y < x) {
        x = y;
    }
}

template<typename T1, typename T2>
inline void chkmax(T1 &x, const T2 &y) {
    if (y > x) {
        x = y;
    }
}
// #define int ll
int W,H;
const int MAXN = 4e3+20;
char cnt[MAXN][MAXN][2][2];
vector<pair<int,int>> period(int x,int y,int w, int h, int mx, int my) {
    // memset(cnt, 0, sizeof cnt);
    vector<pair<int,int>> res;
    res.reserve(W*H * 2);
    while(!cnt[x][y][(mx+1)/2][(my+1)/2]) {
        res.pbc({x,y});
        cnt[x][y][(mx+1)/2][(my+1)/2] ++;
        if(mx == -1 &&x ==0) {
            mx = 1;
        }
        if(x + w == W && mx == 1) {
            mx  = -1;
        }
        if(y + h == H && my == 1) {
            my = -1;
        }
        if(y ==0  && my == -1) {
            my = 1;
        }
        x = x+mx;
        y = y+ my;
    }
    for(int xa=0;xa<2;++xa)for(int ya=0;ya<2;++ya)
    for(auto i :res) cnt[i.first][i.second][xa][ya] = 0;
    return res;
}
ll gcd(ll a,ll b) {
    while(b) {
        a%=b;
        swap(a,b);
    }
    return a;
}
ll lcm(ll a,ll b) {
    return a/gcd(a,b) * b;
}

struct Fenwick {
    int n;
    vector <int> f;

    Fenwick(int n) : n(n) {
        f.resize(n + 1);
    }

    inline void add(int i, int x) {
        for (++i; i <= n; i += (i & (-i))) f[i] += x;
    }

    inline int get_pref(int i) {
        int ans = 0;
        for (++i; i > 0; i -= (i & (-i))) ans += f[i];
        return ans;
    }

    inline int get_seg(int l, int r) {
        return get_pref(r) - get_pref(l - 1);
    }
};

struct Event {
    short x, type, l, r;
};

bool cmp(const Event& a, const Event& b) {
    if (a.x != b.x) return a.x < b.x;
    return a.type < b.type;
}

void solve() {
    cin>>W>>H;
    // W = 4000;
    // H = 4000;
    vector<vector<int>> r(2);
    vector<pair<int,int>> f1,f2;
    for(int i=0;i< 2;++i) {
        r[i].resize(6);
        for(int j=0;j< 6;++j) cin>>r[i][j];
        // r[i][0] = rnd() % (W-1);
        // r[i][1] = rnd()%(H-1);
        // r[i][2] = rnd() %(W-r[i][0] - 1);
        // r[i][3] = rnd() %(H-r[i][1] - 1);
        // r[i][4] = rnd() % 2;
        // r[i][4] = r[i][4] * 2 -1;
        // r[i][5] = rnd() % 2;
        // r[i][5] =  r[i][5] *  2 - 1;

    }

    f1 = period(r[0][2],r[0][3], r[0][0], r[0][1], r[0][4], r[0][5]);
    f2 = period(r[1][2],r[1][3], r[1][0], r[1][1], r[1][4], r[1][5]);
    // cout<<f1.size()<<' '<<f2.size()<<endl;
    // cout<<"f1 = "<<endl;
    // for(auto i :f1) {
    //     cout<<i.first<<' '<<i.second<<endl;
    // }
    // cout<<"f2 = "<<endl;
    // for(auto i:f2) {
    //     cout<<i.first<<' '<<i.second<<endl;
    // }
    ll g=gcd(f1.size(), f2.size());
    ll tot = lcm(f1.size(), f2.size());
    ll gth = 0;
    Fenwick ff(H);
    vector <Event> events;
    events.reserve(f1.size() + 2* f2.size());
    for(int f = 0;f< g;++f) {
        events.clear();
        for(int j =f;j< f1.size();j += g) {
            // upd(f1[j].first, f1[j].second, 1);
            // cout<<"add "<<f1[j].first<<' '<<f1[j].second<<endl;
            events.push_back({f1[j].first, 0, f1[j].second, 0});
        }

        for(int j = f;j< f2.size();j+=g) {
            int x = f2[j].first;
            int y = f2[j].second;
            int mx = max(0, x - r[0][0] + 1);
            int my = max(0, y - r[0][1] + 1);
            int maxx = min(W, x + r[1][0] - 1);
            int maxy = min(H, y + r[1][1] - 1);
            // gth += getrect(mx,my, maxx,maxy);
            events.push_back({mx - 1, 1, my, maxy});
            events.push_back({maxx, 2, my, maxy});
            // cout<<"get on "<<mx<<' '<<my<<' '<<maxx<<' '<<maxy<<endl;
        }
        sort(all(events), cmp);
        for (const auto& i : events) {
            if (i.type == 0) {
                ff.add(i.l, 1);
            } else {
                if (i.type == 1) gth -= ff.get_seg(i.l, i.r);
                else gth += ff.get_seg(i.l, i.r);
                // gth += ff.get_seg(i.l, i.r) * i.sgn;
            }
        }
        for (const auto& i : events) {
            if (i.type == 0) {
                ff.add(i.l, -1);
            } else {
                // gth += f.get_seg(i.l, i.r) * i.sgn;
            }
        }
    }
    ll gg = gcd(gth, tot);
    cout<<gth / gg<< '/' << tot/gg<<'\n';
    // cout<<(ld)clock ()/CLOCKS_PER_SEC<<endl;
    // cout<<gth<<' '<<tot<<endl;
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}