#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const N = 3e5 + 4;
int const inf = 1e9 + 7;
int const mod = 998244353;
ll const INF = 1e18; 

int n;
vector<int> a;
vector<vector<int>> rebra;
int dp[N][2], opt[N];
void dfs(int i, int prev) {
	dp[i][0] = dp[i][1] = 0;
	opt[i] = -1;
	int sm = 0;
	for (auto j : rebra[i]) {
		if (j == prev) continue;
		dfs(j, i);
		dp[i][0] += max(dp[j][1], dp[j][0]);
	}
	sm = dp[i][0];
	for (auto j : rebra[i]) {
		if (j == prev) continue;
		int tr = sm - max(dp[j][1], dp[j][0]) + dp[j][0] + 1;
		if (tr > dp[i][1]) {
			dp[i][1] = tr;
			opt[i] = j;
		}
	}
}
pair<int, int> b[N];
int bsz;
void dfs1(int i, int prev) {
	if (dp[i][0] >= dp[i][1]) {
		for (auto j : rebra[i]) {
			if (j != prev) dfs1(j, i);
		}
	} else {
		b[bsz++] = {i, opt[i]};
		for (auto j : rebra[i]) {
			if (j == prev) continue;
			if (j == opt[i]) {
				for (auto j2 : rebra[j]) {
					if (j2 != i) dfs1(j2, j);
				}
			} else {
				dfs1(j, i);
			}
		}
	}
}
void solve() {
	cin >> n;
	a.resize(2*n);
	rebra.clear(); rebra.resize(2*n);
	vector<int> SM(n, 0);
	for (int i = 0; i < 2*n; i++) {
		cin >> a[i]; 
		a[i]--;
		SM[a[i]] += i;
	}
	for (int i = 0; i < 2*n-1; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		rebra[u].push_back(v);
		rebra[v].push_back(u);
	}
	dfs(0, -1);
	bsz = 0;
	dfs1(0, -1);
	vector<int> used(n, 0);
	vector<int> smn(n, 0), cntn(n, 0);
	vector<int> ANy(n, 0);
	for (int i = 0; i < bsz; i++) {
		auto [u, v] = b[i];
		ANy[a[u]] = ANy[a[v]] = i;
		smn[a[u]] += i;
		cntn[a[u]] ++;
		smn[a[v]] += i;
		cntn[a[v]] ++;
	}
	vector<pair<int, int>> ans;
	//cout << "\n!\n";
	//for (int i = 0; i < bsz; i++) cout << b[i].ft << " " << b[i].sc << endl;
	// exit(0);
	// return;
	for (int i = 0; i < n; i++) {
		if (used[i]) continue;
		if (cntn[i] == 2 || cntn[i] == 0) continue;
		vector<int> col = {i};
		vector<int> bl = {smn[i]};
		used[i] = 1;
		while (1) {
			int j = a[b[bl.back()].ft] + a[b[bl.back()].sc] - col.back();
			col.push_back(j);
			used[j] = 1;
			if (cntn[j] == 1) break;
			bl.push_back(smn[j] - bl.back());
		}
		int n2 = bl.size();
		int to, from;
		if (n2%2 == 0) {
			to = n2/2-1;
			from = n2/2;
		} else {
			to = n2/2;
			from = n2/2-1;
		}
		for (int _ = 0; _ < n2-1; _++) {
			auto &[u, v] = b[bl[from]];
			auto &[u1, v1] = b[bl[to]];
			bool flag = 0;
			for (auto i : {v, u}) {
				if (flag) break;
				for (auto j : {v1, u1}) {
					if (a[i] == a[j]) {
						if (i == v) swap(u, v);
						if (j == v1) swap(u1, v1);
						flag = 1;
						break;
					}
				}
			}
			ans.push_back({u, v1});
			swap(u, v1);
			int nfrom;
			if (from > to) nfrom = to-1;
			else nfrom = to+1;
			to = from;
			from = nfrom;
		}
		auto &[u, v] = b[bl[n2-1]];
		// u
		ans.push_back({v, SM[a[u]] - u});
	}
	for (int i = 0; i < n; i++) {
		if (used[i]) continue;
		if (cntn[i] == 0) continue;
		vector<int> col = {i};
		vector<int> bl = {ANy[i]};
		used[i] = 1;
		while (1) {
			int j = a[b[bl.back()].ft] + a[b[bl.back()].sc] - col.back();
			if (j == col[0]) break;
			col.push_back(j);
			used[j] = 1;
			bl.push_back(smn[j] - bl.back());
		}
		int n2 = bl.size();
		int to, from;
		if (n2%2 == 0) {
			to = n2/2-1;
			from = n2/2;
		} else {
			to = n2/2;
			from = n2/2-1;
		}
		for (int _ = 0; _ < n2-1; _++) {
			auto &[u, v] = b[bl[from]];
			auto &[u1, v1] = b[bl[to]];
			bool flag = 0;
			for (auto i : {v, u}) {
				if (flag) break;
				for (auto j : {v1, u1}) {
					if (a[i] == a[j]) {
						if (i == v) swap(u, v);
						if (j == v1) swap(u1, v1);
						flag = 1;
						break;
					}
				}
			}
			// cout << u << " " << v << " " << u1 << " "<< v1 << "\n";
			ans.push_back({u, v1});
			swap(u, v1);
			int nfrom;
			if (from > to) nfrom = to-1;
			else nfrom = to+1;
			to = from;
			from = nfrom;
		}
	}
	cout << ans.size() << "\n";
	for (auto [u, v] : ans) cout << u+1 << " " << v+1 << "\n";
	// exit(0);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

/*

3
2
1 2 2 1
1 2
2 3
3 4
4
4 3 1 3 2 4 1 2
1 2
3 1
3 4
5 1
5 6
2 7
2 8
3
1 1 2 2 3 3
1 2
1 3
1 4
1 5
1 6


6 7 5 4
0 1 7 4
2
7 5
1 5

*/