from itertools import filterfalse


def calc(v):
    ans = 0
    x = 1
    cur = 0
    for c in v:
        if c == '-':
            ans += cur * x
            x = -1
            cur = 0
            continue
        if c == '+':
            ans += cur * x
            x = 1
            cur = 0
            continue
        cur = cur * 10 + int(c)
    ans += cur * x
    return ans


def check(s):
    cur = 0
    lencur = 0
    for i in range(len(s)):
        if s[i].isalnum():
            lencur += 1
            if cur == 0 and lencur > 1:
                return False
            if lencur > 10:
                return False
            cur = cur * 10 + int(s[i])
        else:
            if lencur == 0 and i != 0:
                return False
            lencur = 0
            cur = 0
    return True


def solve():
    s = input().strip()
    a, b = s.split('=')
    x, y = calc(a), calc(b)
    if calc(a) == calc(b):
        return 'Correct'

    for i in range(len(s)):
        if s[i].isalnum():
            newstoadd = s[:i] + s[i + 1:]
            for j in range(len(s)):
                news = newstoadd[:j] + s[i] + newstoadd[j:]
                newa, newb = news.split('=')
                if check(newa) and check(newb):
                    if calc(newa) == calc(newb):
                        return news

    return 'Impossible'


print(solve())
