#include <bits/stdc++.h>

using namespace std;

int const maxn = 2e5 + 5;
int a[maxn];
vector < int > g[maxn];
int dp[maxn][2], cnt[maxn];
vector < pair < int, int > > pr;
vector < pair < int, int > > G[maxn];
vector < int > pos[maxn];
set < int > pos2[maxn];
int used[maxn];
vector < int > node, edges;

void calc(int v, int p, int t) {
    //cout << v << " " << t << " " << dp[v][t] << endl;
    if (t == 0) {
        for (auto u : g[v]) {
            if (u == p) continue;
            if (dp[u][0] >= dp[u][1]) calc(u, v, 0);
            else calc(u, v, 1);
        }
    } else {
        for (auto u : g[v]) {
            if (u == p) continue;
            if (dp[v][1] != dp[u][0] + 1 + dp[v][0] - max(dp[u][0], dp[u][1])) continue;
            pr.push_back({u, v});
            for (auto to : g[v]) {
                if (to == p) continue;
                if (to == u) calc(u, v, 0);
                else {
                    if (dp[to][0] >= dp[to][1]) calc(to, v, 0);
                    else calc(to, v, 1);
                }
            }
            break;
        }
    }
}

void dfs(int v, int p) {
    dp[v][0] = dp[v][1] = 0;
    for (auto u : g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v][0] += max(dp[u][0], dp[u][1]);
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        dp[v][1] = max(dp[v][1], dp[v][0] - max(dp[u][0], dp[u][1]) + dp[u][0] + 1);
    }
}

int h[maxn], tmr;

void tgk(int v, int par = -1) {
    used[v] = 1;
    node.push_back(v);
    h[v] = tmr++;
    for (auto [u, to] : G[v]) {
        if (!used[u]) {
            edges.push_back(to);
            tgk(u, to);
        } else if (h[u] < h[v] && par != to) edges.push_back(to);
    }
}

main(){
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        for (int i = 1; i <= 2 * n; i++) cin >> a[i];
        for (int i = 1; i <= 2 * n; i++) g[i] = {}, G[i] = {}, pos[i] = {}, pos2[i] = {};
        for (int i = 1; i <= 2 * n; i++) pos[a[i]].push_back(i);
        for (int i = 1; i < 2 * n; i++) {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        dfs(1, 0);
        pr = {};
        if (dp[1][0] >= dp[1][1]) calc(1, 0, 0);
        else calc(1, 1, 1);
        assert(pr.size() == max(dp[1][0], dp[1][1]));
        vector < pair < int, int > > out;
        fill(cnt, cnt + n + 1, 0);
        int ind = -1;
        for (auto [u, v] : pr) {
            ind++;
            if (a[u] == a[v]) continue;
            cnt[a[u]]++, cnt[a[v]]++;
            G[a[u]].push_back({a[v], ind});
            G[a[v]].push_back({a[u], ind});
            //cout << u << " " << v << endl;
        }
        fill(used, used + n + 1, 0);
        for (int i = 1; i <= n; i++) {
            if (used[i] || cnt[i] != 1) continue;
            node = {}, edges = {};
            tgk(i);
            vector < int > pth;
            auto [u, v] = pr[edges[0]];
            if (a[u] != i) swap(u, v);
            pth = {u, v};
            for (int j = 1; j < edges.size(); j++) {
                auto [u, v] = pr[edges[j]];
                if (a[u] != a[pth.back()]) swap(u, v);
                pth.push_back(u);
                pth.push_back(v);
            }
            int A = -1, B = -1;
            for (auto tt : pos[i]) if (tt != pth[0]) A = tt;
            for (auto tt : pos[a[pth.back()]]) if (tt != a[pth.back()]) B = tt;
            out.push_back({A, pth[1]});
            if (pth.size() > 2) {
                out.push_back({B, pth[2]});
                vector < int > cycle = {B};
                for (int j = 3; j < pth.size(); j++) cycle.push_back(pth[j]);
                            int len = cycle.size() / 2, pos = 0;
                            for (int j = 0; j < cycle.size(); j++) pos2[a[cycle[j]]].insert(j);
                            //for (auto u : cycle) cout << u << " ";
                            //cout << endl;
                for (int it = 1; it < len; it++) {
                    int need = -1;
                    for (auto gg : pos2[a[cycle[pos]]]) {
                        if (gg != pos) need = gg;
                    }
                    assert(need != -1);
                    if (pos % 2 == 0) {
                        out.push_back({cycle[pos + 1], cycle[need]});
                        pos2[a[cycle[pos + 1]]].erase(pos + 1);
                        swap(cycle[pos + 1], cycle[need]);
                        pos = need;
                    } else {
                        out.push_back({cycle[pos - 1], cycle[need]});
                        pos2[a[cycle[pos - 1]]].erase(pos - 1);
                        swap(cycle[pos - 1], cycle[need]);
                        pos = need;
                    }
                }
            }
        }
        for (int i = 1; i <= n; i++) {
            if (used[i] || cnt[i] != 2) continue;
            node = {}, edges = {};
            tgk(i);
            vector < int > pth;
            auto [u, v] = pr[edges[0]];
            if (a[u] != i) swap(u, v);
            pth = {u, v};
            for (int j = 1; j < edges.size(); j++) {
                auto [u, v] = pr[edges[j]];
                if (a[u] != a[pth.back()]) swap(u, v);
                pth.push_back(u);
                pth.push_back(v);
            }
            vector < int > cycle = pth;
            int len = cycle.size() / 2, pos = 0;
                            for (int j = 0; j < cycle.size(); j++) pos2[a[cycle[j]]].insert(j);
                            //for (auto u : cycle) cout << u << " ";
                            //cout << endl;
                for (int it = 1; it < len; it++) {
                    int need = -1;
                    for (auto gg : pos2[a[cycle[pos]]]) {
                        if (gg != pos) need = gg;
                    }
                    assert(need != -1);
                    if (pos % 2 == 0) {
                        out.push_back({cycle[pos + 1], cycle[need]});
                        pos2[a[cycle[pos + 1]]].erase(pos + 1);
                        swap(cycle[pos + 1], cycle[need]);
                        pos = need;
                    } else {
                        out.push_back({cycle[pos - 1], cycle[need]});
                        pos2[a[cycle[pos - 1]]].erase(pos - 1);
                        swap(cycle[pos - 1], cycle[need]);
                        pos = need;
                    }
                }
        }
        set < int > Q;
        for (auto [u, v] : out) Q.insert(u), Q.insert(v);
        assert(Q.size() == 2 * out.size());
        for (auto [u, v] : out) swap(a[u], a[v]);
        int res = 0;
        for (int i = 1; i <= 2 * n; i++) {
            for (auto j : g[i]) {
                if (i < j && a[i] == a[j]) res++;
            }
        }
        //assert(res == max(dp[1][0], dp[1][1]));
        cout << out.size() << '\n';
        for (auto [u, v] : out) cout << u << " " << v << '\n';
    }
    return 0;
}

