#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define show(x) cout << "[debug " << __LINE__ << "] " << x << endl
#else
#define show(x) ((void)0)
#endif

void solve() {
    int n;
    cin >> n;

    vector<string> s(2);
    cin >> s[0] >> s[1];

    bool not_unique = false;
    bool ok = true;

    int i = 0;

    for (; i < n - 1; i++) {
        if (s[0][i] == '.' && s[1][i] == '.' && s[0][i + 1] == '.' && s[1][i + 1] == '.') {
            not_unique = true;
            i++;
        } else if (s[0][i] == '.' && s[1][i] == '.') {
            // pass
        } else if (s[0][i] == '.' && s[0][i + 1] == '.') {
            s[0][i] = s[0][i + 1] = '#';
        } else if (s[1][i] == '.' && s[1][i + 1] == '.') {
            s[1][i] = s[1][i + 1] = '#';
        } else if (s[0][i] == '#' && s[1][i] == '#') {
            // pass
        } else {
            show(i);
            ok = false;
            break;
        }
    }

    if (!ok) {
        cout << "None\n";
        return;
    }

    if (i == n - 1) {
        ok = (s[0][i] == '.' && s[1][i] == '.') || (s[0][i] == '#' && s[1][i] == '#');
    }

    if (ok && not_unique) {
        cout << "Multiple\n";
    } else if (ok) {
        cout << "Unique\n";
    } else {
        cout << "None\n";
    }

}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}
