#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <set>
#include <string>
#include <map>
#include <numeric>

using namespace std;

#define int long long
#define all(a) begin(a), end(a)
#define vi vector<int>
#define ve vector
#define pii pair<int,int>

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout << fixed; cout.precision(10);
}

void solve() {
    int n; cin >> n;
    vi v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    ve<pii> ans;
    vi t(n);
    for (int i = 0; i < n; i++) {
        t[i] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        int id = find(all(t), v[i]) - t.begin();
        while (id != n - 1) {
            ans.push_back({t[id + 1], t[id]});
            swap(t[id], t[id + 1]);
            id++;
        }
        while (id != i) {
            ans.push_back({t[id], t[id - 1]});
            swap(t[id], t[id - 1]);
            id--;
        }
        
    }
    cout << ans.size() << "\n";
    for (auto [a, b] : ans) {
        cout << a << " " << b << "\n";
    }
}

signed main() {
    fast();
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}