#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()

bool validate(string s) {
    int n = s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            if (i + 1 < n && '0' <= s[i + 1] && s[i + 1] <= '9') {
                return false;
            }
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    vector<int> ans;
    vector<bool> used;
    int T = 1;
    // cin >> T;
    while (T--) {
        int n;
        cin >> n;
        used.resize(n + 1);
        vector<int> needed(n + 1);
        vector<vector<int> > g(n + 1);
        vector<pair<string, string> > data(n + 1);
        for (int i = 1; i <= n; i++) {
            string s, t;
            cin >> s >> t;    
            data[i] = {s, t};
        }
        int m;
        cin >> m;
        for (int i = 1; i <= m; i++) {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
            needed[v]++;
        }
        set<int> uf;
        for (int i = 1; i <= n; i++) {
            if (!needed[i]) {
                if (data[i].first == "unset" && data[i].second == "false" && used[i] == 0) {
                    uf.insert(i);
                    used[i] = 1;
                }
            }
        }
        while (!uf.empty()) {
            int cur = *uf.begin();
            uf.erase(uf.begin());
            ans.push_back(cur);
            for (auto i : g[cur]) {
                needed[i]--;
                if (needed[i] == 0) {
                    if (data[i].first == "unset" && data[i].second == "false") {
                        uf.insert(i);
                        used[i] = 1;
                    }
                }
            }
        }
        set<int> st;
        for (int i = 1; i <= n; i++) {
            if (needed[i] == 0) {
                if (data[i].first == "set" && data[i].second == "true" && used[i] == 0) {
                    st.insert(i);
                    used[i] = 1;
                }
            }
        }
        if (st.size() == 2) {
            cout << "-1" << endl;
            return 0;
        }
        if (st.empty()) {
            if (ans.size() != n) {
            cout << "-1" << endl;
            return 0;
            }
            for (auto i : ans) {
                cout << i << " ";
            }
            return 0;
        }
        int cur = *st.begin();
        st.erase(st.begin());
        ans.push_back(cur);
        for (auto i : g[cur]) {
            needed[i]--;
        }
        set<int> sf;
        for (int i = 1; i <= n; i++) {
            if (needed[i] == 0) {
                if (data[i].first == "set" && data[i].second == "false" && used[i] == 0) {
                    sf.insert(i);
                    used[i] = 1;
                }
            }
        }
        while(!sf.empty()) {
            cur = *sf.begin();
            sf.erase(sf.begin());
            ans.push_back(cur);
            for (auto i : g[cur]) {
                needed[i]--;
                if (needed[i] == 0 && data[i].first == "set" && data[i].second == "false") {
                    used[i] = 1;
                    sf.insert(i);
                }
            }
        }
        set<int> ut;
        for (int i = 1; i <= n; i++) {
            if (needed[i] == 0) {
                if (data[i].first == "unset" && data[i].second == "true" && used[i] == 0) {
                    ut.insert(i);
                    used[i] = 1;
                }
            }
        }
        if (ut.size() == 2) {
            cout << "-1" << endl;
            return 0;
        }
        if (ut.empty()) {
            if (ans.size() != n) {
            cout << "-1" << endl;
            return 0;
            }
            for (auto i : ans) {
                cout << i << " ";
            }
            return 0;
        }
        cur = *ut.begin();
        ut.erase(ut.begin());
        ans.push_back(cur);
        for (auto i : g[cur]) {
            needed[i]--;
        }
        for (int i = 1; i <= n; i++) {
            if (needed[i] == 0) {
                if (data[i].first == "unset" && data[i].second == "false" && used[i] == 0) {
                    uf.insert(i);
                    used[i] = 1;
                }
            }
        }
        while (!uf.empty()) {
            cur = *uf.begin();
            uf.erase(uf.begin());
            ans.push_back(cur);
        }
        if (ans.size() != n) {
            cout << "-1" << endl;
            return 0;
        }
        for (auto i : ans) {
            cout << i << " ";
        }
    } 
}
