#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()

bool validate(string s) {
    int n = s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            if (i + 1 < n && '0' <= s[i + 1] && s[i + 1] <= '9') {
                return false;
            }
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    int T = 1;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        vector<vector<bool> > a(n + 1, vector<bool>(2, 1));
        for (int i = 1; i <= n; i++) {
            char c;
            cin >> c;
            if (c == '#') {
                a[i][0] = 1;
            } else {
                a[i][0] = 0;
            }
        }
        for (int i = 1; i <= n; i++) {
            char c;
            cin >> c;
            if (c == '#') {
                a[i][1] = 1;
            } else {
                a[i][1] = 0;
            }
        }
        vector<vector<int> > dp(n + 1, vector<int>(4, 0));
        dp[0][3] = 1;
        for (int i = 1; i <= n; i++) {
            int cur = 0;
            cur += a[i][1];
            cur *= 2;
            cur += a[i][0];
            dp[i][cur] += dp[i - 1][3];
            for (int msk = 0; msk <= 3; msk++) {
                if ((msk & 1) && a[i][0] == 0 && a[i - 1][0] == 0 && (bool((msk & 2)) == a[i][1])) {
                    if (a[i - 1][0] == 0) {
                        dp[i][msk] += dp[i - 1][2];
                    }
                }
                if ((msk & 2) && a[i][1] == 0 && ((msk & 1) == a[i][0])) {
                    if (a[i - 1][1] == 0) {
                        dp[i][msk] += dp[i - 1][1];
                    }
                }
                if (a[i][0] == 0 && a[i][1] == 0 && msk == 3) {
                    dp[i][msk] += dp[i - 1][0];
                }
            }
            if (a[i][0] == 0 && a[i][1] == 0) {
                dp[i][3] += dp[i - 1][3];
            }
            for (int j = 0; j <= 3; j++) {
                dp[i][j] = min(dp[i][j], 2);
            }
        }
        if (dp[n][3] == 0) {
            cout << "None" << endl;
        }
        if (dp[n][3] == 1) {
            cout << "Unique" << endl;
        }
        if (dp[n][3] > 1) {
            cout << "Multiple" << endl;
        }
    } 
}
