#include<bits/stdc++.h>
using namespace std;
 
#define ll long long
#define all(x) (x).begin(), (x).end()
#define int long long
bool validate(string s) {
    int n = s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            if (i + 1 < n && '0' <= s[i + 1] && s[i + 1] <= '9') {
                return false;
            }
        }
    }
    return true;
}
struct my
{
    int a, d, i;
};


struct comp {
    bool operator() (my i1, my i2) const {
        if (i2.d != i1.d) {
                return i1.d < i2.d;
            }
        if (i1.d - i1.a != i2.d - i2.a) {
                return i1.d - i1.a < i2.d - i2.a;
            }
            
            if (i1.a != i2.a) {
                return i1.a < i2.a;
            }
            return i1.i < i2.i;
    }
};
 
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    vector<int> ans;
    vector<bool> used;
    int T = 1;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        int m;
        cin >> m;
        int q;
        cin >> q;
        vector<int> a(n);
        vector<int> d(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        for (int i = 0; i < n; i++)  {
            cin >> d[i];
        }
        vector<int> l(m);
        for (int i = 0; i < m; i++) {
            cin >> l[i];
        }
        vector<int> ans(m);
        multiset<my, comp> st;
        multiset<pair<int, int>> tasks;
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int i, int j) {
            my s1{a[i], d[i], i};
            my s2{a[j], d[j], j};
            return comp()(s1, s2);
        });
        // int pref_sum = 0;
        // vector<int> prefs(n);
        // for (auto& i : ord) {
        //     tasks.insert({d[i] - a[i] - pref_sum, i});
        //     prefs[i] = pref_sum;
        //     pref_sum += a[i];
        //     st.insert(my{a[i], d[i], i});
        // }
        // int j = 0;
        // int sub = 0;
        // int cur_time = 0;
        // while (j < m && st.size() > 0) {
        //     while (j < m && tasks.begin()->first - sub - l[j] >= 0) {
        //         cur_time += l[j];
        //         sub += l[j];
        //         ans[j] = cur_time;
        //         j++;
        //     }
        //     cur_time += st.begin()->a;
        //     auto [a, d, i] = *st.begin();
        //     st.erase(st.begin());
        //     tasks.erase({d - a - prefs[i], i});
        // }
        // // if (j == m && st.size() > 0) {
        // //     cur_time += a[st.begin()->first];
        // //     st.erase(st.begin());
        // // }
        // while (j < m && st.size() == 0) {
        //     cur_time += l[j];
        //     ans[j] = cur_time;
        //     j++;
        // }
        vector<int> pref_a(n + 1);
        vector<int> mn(n);
        int pref_sum = 0;
        for (int i = 0; i < n; i++) {
            pref_sum += a[ord[i]];
            pref_a[i] = pref_sum;
        }
        mn[n - 1] = d[ord[n - 1]] - pref_a[n - 1];
        for (int i = n - 2; i >= 0; i--) {
            mn[i] = min(mn[i + 1], d[ord[i]] - pref_a[i]);
        }
        int cur_l = 0;
        int i = 0;
        int j = 0;
        while (j < m && i < n) {
            while (j < m && cur_l + l[j] <= mn[i]) {
                ans[j] = cur_l + l[j] + pref_a[i] - a[ord[i]];
                cur_l += l[j];
                j++;
            }
            i++;
        
        }
        while (j < m) {
            ans[j] = pref_a[n - 1] + cur_l + l[j];
            cur_l += l[j];
            j++;
        }
        for (int i = 0; i < q; i++) {
            int t;
            cin >> t;
            auto it = upper_bound(ans.begin(), ans.end(), t);
            if (it == ans.end()) {
                cout << m << ' ';
            } else {
                cout << it - ans.begin() << ' ';
            }
        }
        cout << endl;
    } 
}