#include <iostream>
#include <bits/stdc++.h>

using namespace std;

template <typename T>
ostream &operator<<(ostream &ostr, vector <T> &v){
    for (T& elem : v){
        ostr << v << ' ';
    }
    return ostr;
}

template <typename T>
istream &operator>>(istream &istr, vector <T> &v){
    for (T &elem : v){
        istr >> elem;
    }
    return istr;
}

bool Dset(bool &x){
    return !x ? true : false;
}

bool Dunset(bool &x){
    return x;
}

int main() {
    int n;
    cin >> n;
    vector <int> v(n);
    cin >> v;

    map <int, bool> mp;
    map <int, int> dist;
    vector <int> positions(n+1);
    for (int i = 0; i < n; i++){
        dist[i+1] = i - (std::find(v.begin(), v.end(), i+1) - v.begin());
    }
    for (int i = 0; i < n; i++) {
        v[i] = i + 1;
        positions[i+1] = i;
    }
    vector <pair<int, int> > result;
    for (int i = 0; i < n; i++){
        int maxindex = 1;
        bool directionLeft = dist[1] < 0;
        int value = 1;
        for (int j = 1; j <= n; j++)
            if (abs(dist[j]) > abs(dist[maxindex])) {
                maxindex = j;
                directionLeft = dist[j] < 0;
                value = j;
            }
        for (int z = positions[value]; dist[value] != 0;){
            int fP = z;
            int change = -(directionLeft * 2 - 1);
            int sP = fP - change;
            if (!directionLeft){
                result.emplace_back(v[fP], v[sP]);
            } else {
                result.emplace_back(v[sP], v[fP]);
            }
//            result.push_back(directionLeft ? {v[fP], v[sP]} : )
//            cout << v[fP] << ' ' << v[sP] << '\n';
            mp[v[fP]*1000+v[sP]] = true;
            dist[v[sP]] += change;
            positions[v[sP]] += change;
            dist[v[fP]] -= change;
            positions[v[fP]] -= change;

            swap(v[fP], v[sP]);
            z -= change;
        }
    }

    for (int i = 0; i < n-1; i++){
        int hash1 = v[i]*1000+v[i+1];
        int hash2 = v[i+1]*1000+v[i];
        if (!mp[hash1] && !mp[hash2]){
            result.emplace_back(v[i+1], v[i]);
            result.emplace_back(v[i], v[i+1]);
        }
    }

    cout << result.size() << '\n';
    for (auto [f, s] : result){
        cout << f << ' ' << s << '\n';
    }
    return 0;
}
