#include <iostream>
#include <vector>
#include <array>

using namespace std;

void solveA() {
	int a[1000], b[1000], c[1000];
	int n;

	bool swapped[1000][1000];

	cin >> n;

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	for (int i = 0; i < n; i++) {
		c[a[i] - 1] = i;
	}

	vector<pair<int, int>> v;

	int s = 0;
	for (int i = 0; i < n; ++i) {
		b[i] = i;
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n - 1; ++j) {
			if (c[b[j]] > c[b[j + 1]]) {
				v.push_back({ b[j + 1] + 1, b[j] + 1 });
				swap(b[j], b[j + 1]);
				swapped[b[j]][b[j + 1]] = 1;
				swapped[b[j + 1]][b[j]] = 1;
			}
		}
	}

	for (int i = 1; i < n; ++i) {
		int p = i;
		while (p > 0 && !swapped[b[p]][b[p - 1]]) {
			v.push_back({ b[p] + 1, b[p - 1] + 1 });
			swapped[b[p]][b[p - 1]] = 1;
			swapped[b[p - 1]][b[p]] = 1;
			swap(b[p], b[p - 1]);
			//cout << p << endl;
			--p;
		}

		//cout << endl;

		while (p < i) {
			++p;
			v.push_back({ b[p] + 1, b[p - 1] + 1 });
			swap(b[p], b[p - 1]);
			//cout << p << " " << p - 1 << endl;
		}
	}

	cout << v.size() << endl;
	for (auto& x : v) {
		cout << x.first << " " << x.second << endl;
	}
}

int c = 0;

void rec(int i, int j, int n, array<array<int, 2>, 200000>& v) {
	if (i >= n) {
		++c;
		//cout << n << endl;
		//for (int i = 0; i < n; i++) {
		//	cout << (v[i][0] == 0 ? '.' : v[i][0] == 1 ? '*' : '#');
		//}
		//cout << endl;
		//for (int i = 0; i < n; i++) {
		//	cout << (v[i][1] == 0 ? '.' : v[i][1] == 1 ? '*' : '#');
		//}
		//cout << endl << endl;
	}
	else {
		if (c > 1) {
			return;
		}

		if (v[i][j] > 0) {
			rec(i + (j + 1) / 2, (j + 1) % 2, n, v);
		}
		else {
			if (j == 1 && (i < n - 1 && v[i + 1][j] == 0)) {
				v[i][j] = 1;
				v[i + 1][j] = 1;
				rec(i + 1, 0, n, v);
				v[i][j] = 0;
				v[i + 1][j] = 0;
			}
			if (j == 0 && v[i][1] == 0) {
				v[i][0] = 1;
				v[i][1] = 1;
				rec(i + 1, 0, n, v);
				v[i][0] = 0;
				v[i][1] = 0;
			}
			if (j == 0 && (i < n - 1 && v[i + 1][j] == 0)) {
				v[i][j] = 1;
				v[i + 1][j] = 1;
				rec(i, 1, n, v);
				v[i][j] = 0;
				v[i + 1][j] = 0;
			}
		}
	}
}

array<array<int, 2>, 200000> v;

void solveB() {
	int t;
	cin >> t;

	for (int i = 0; i < t; ++i) {
		int n;
		cin >> n;
		for (int j = 0; j < n; j++) {
			v[j][0] = v[j][1] = 0;
		}
		string s;
		cin >> s;
		for (int j = 0; j < n; j++) {
			v[j][0] = 2 * (s[j] == '#');
		}
		cin >> s;
		for (int j = 0; j < n; j++) {
			v[j][1] = 2 * (s[j] == '#');
		}
		c = 0;
		rec(0, 0, n, v);
		if (c == 0) {
			cout << "None" << endl;
		}
		if (c == 1) {
			cout << "Unique" << endl;
		}
		if (c > 1) {
			cout << "Multiple" << endl;
		}
	}
}

int main() {
	solveB();
}