#include<iostream>
#include<vector>
#include<cassert>

using namespace std;

void solve() {
	int n; cin >> n;
	vector<int> vc(n + 1), a(n + 1), ind(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> vc[i];
		a[i] = i;
		ind[i] = i;
	}
	vector<vector<bool>> ch(n + 1, vector<bool>(n + 1));
	vector<pair<int, int>> ans;
	for (int i = 1; i <= n; i++) {
		assert(ind[vc[i]] >= i);
		while (ind[vc[i]] != i) {
			int z = ind[vc[i]];
			ch[a[z]][a[z - 1]] = true;
			ans.push_back({ a[z], a[z - 1] });
			ind[a[z]]--;
			ind[a[z - 1]]++;
			swap(a[z], a[z - 1]);
		}
	}
	vector<pair<int, int>> vec;
	for (int i = 1; i <= n; i++) {
		int z1 = ind[vc[i]];
		int z2 = z1 - 1;
		while (z2 > 0) {
			if (ch[a[z1]][a[z2]] || ch[a[z2]][a[z1]])
				break;
			vec.push_back({ a[z1], a[z2] });
			ans.push_back({ a[z1], a[z2] });
			ind[a[z1]]--;
			ind[a[z2]]++;
			swap(a[z1], a[z2]);
			ch[a[z1]][a[z2]] = true;
			z1--;
			z2--;
		}
	}
	for (int j = vec.size() - 1; j >= 0; j--) {
		ans.push_back({ vec[j].second, vec[j].first });
		assert(vec[j].first > 0 && vec[j].second > 0);
	}

	cout << ans.size() << '\n';
	for (auto [x, y] : ans)
		cout << x << ' ' << y << '\n';

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}