#include<iostream>
#include<vector>
#include<functional>
#include<cassert>
#include<algorithm>

using namespace std;

void solve() {
	int n; cin >> n;
	vector<pair<int, int>> vc(n + 1);
	for (int i = 1; i <= n; i++) {
		string s1, s2;
		cin >> s1 >> s2;
		if (s1 == "set" && s2 == "true") {
			vc[i] = { 0, 1 };
		}
		else if (s1 == "set" && s2 == "false") {
			vc[i] = { 1, 1 };
		}
		else if (s1 == "unset" && s2 == "true") {
			vc[i] = { 1, 0 };
		}
		else {
			vc[i] = { 0, 0 };
		}
	}
	vector<int> zzz(n + 1);
	int m; cin >> m;
	vector<pair<int, int>> a;
	vector<vector<int>> g(n + 1);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		zzz[u] = true;
		zzz[v] = true;
		g[u].push_back(v);
		a.push_back({ u, v });
	}
	vector<bool> ch(n + 1);
	vector<int> sor1, sor0, sor10, sor01;
	function<void(int)> dfs = [&](int v) {
		if (vc[v].first != vc[v].second || ch[v])
			return;
		ch[v] = true;
		for (auto x : g[v]) {
			dfs(x);
		}
		if (vc[v].first == 0)
			sor0.push_back(v);
		else
			sor1.push_back(v);
	};
	for (int i = 1; i <= n; i++) {
		if (vc[i].first == 1 && vc[i].second == 0)
			sor10.push_back(i);
		if (vc[i].first == 0 && vc[i].second == 1)
			sor01.push_back(i);
		if (zzz[i]) continue;
		if (vc[i].first == 0 && vc[i].second == 0)
			sor0.push_back(i);
		if (vc[i].first == 1 && vc[i].second == 1)
			sor1.push_back(i);
	}
	for (int i = 0; i < m; i++) {
		auto [u, v] = a[i];
		dfs(v);
		dfs(u);
	}
	if (sor01.empty() && sor10.empty()) {
		if (!sor1.empty()) cout << "-1\n";
		else
			for (auto x : sor0)
				cout << x << ' ';
		return;
	}
	if (sor01.empty()) {
		cout << "-1\n";
		return;
	}
	if (sor01.size() > 1 || sor10.size() > 1) {
		cout << "-1\n";
		return;
	}

	if (sor10.empty()) {
		for (auto x : sor1) {
			for (auto y : g[x]) {
				if (vc[y] == make_pair(0, 0)) {
					cout << "-1\n";
					return;
				}
			}
		}
		for (auto y : g[sor01[0]]) {
			if (vc[y] == make_pair(0, 0)) {
				cout << "-1\n";
				return;
			}
		}
		for (auto x : sor0)
			cout << x << ' ';
		cout << sor01[0] << ' ';
		for (auto x : sor1)
			cout << x << ' ';
		cout << '\n';
		return;
	}
	vector<bool> gr(n + 1);
	vector<int> indz(n + 1);
	for (int i = 0; i < sor0.size(); i++)
		indz[sor0[i]] = i;
	vector<int> g2;
	for (auto x : sor1) {
		for (auto y : g[x]) {
			if (vc[y] == make_pair(0, 0)) {
				gr[y] = true;
				g2.push_back(y);
			}
		}
	}
	for (auto y : g[sor01[0]]) {
		if (vc[y] == make_pair(0, 0)) {
			gr[y] = true;
			g2.push_back(y);
		}
	}
	sort(g2.begin(), g2.end());
	g2.erase(unique(g2.begin(), g2.end()), g2.end());
	sort(g2.begin(), g2.end(), [&](int f1, int f2) {return indz[f1] < indz[f2]; });
	for (auto x : g2) {
		for (auto y : g[x]) {
			if (vc[y] == make_pair(1, 1)) {
				cout << "-1\n";
				return;
			}
			if (vc[y] == make_pair(0, 0) && !gr[y]) {
				cout << "-1\n";
				return;
			}
		}
		if (vc[sor10[0]] == make_pair(1, 1) || vc[sor10[0]] == make_pair(0, 0) && !gr[sor10[0]]) {
			cout << "-1\n";
			return;
		}
		if (vc[sor01[0]] == make_pair(1, 1) || vc[sor01[0]] == make_pair(0, 0) && !gr[sor10[0]]) {
			cout << "-1\n";
			return;
		}
	}
	for (auto x : sor0) {
		if (gr[x]) continue;
		cout << x << ' ';
	}
	cout << sor01[0] << ' ';
	for (auto x : sor1)
		cout << x << ' ';
	cout << sor10[0] << ' ';
	for (auto x : g2)
		cout << x << ' ';
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}