#include <bits/stdc++.h>
#define ll long long

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
   int n;
   cin >> n;
   vector<pair<bool, bool>> ops(n);
   int sti = -1, uti = -1;
   bool good = true;
   for (int i = 0; i <n; ++i) {
       string s1, res;
       cin>> s1 >> res;
       ops[i] = {s1 == "set", res == "true"};
       if (ops[i] == pair{true, true}) {
           if (sti == -1)
               sti = i;
           else {
               good = false;
           }
       } else if (ops[i] == pair{false, true}) {
           if (uti == -1)
               uti = i;
           else {
               good = false;
           }
       }
   }
   vector<vector<int>> g(n);
   int m;
   cin >> m;
   for (int i = 0; i < m;++i) {
       int u, v;
       cin >> u >> v;
       --u, --v;
       g[u].push_back(v);
   }
   if (!good) {
       cout << "-1";
       return 0;
   }
   if (sti == -1) {
       bool res = true;
       for (int v = 0; v < n; ++v) {
           if (ops[v] == pair{true, false} || ops[v] == pair{false, true}) {
               res = false;
               break;
           }
       }
       if (!res) {
           cout << "-1";
           return 0;
       }
   } else {
       for (int v = 0; v < n; ++v) {
           if (ops[v] == pair{true, false}) {
               g[sti].push_back(v);
           }
       }
       if (uti != -1) {
           for (int v = 0; v < n; ++v) {
               if (ops[v] == pair{true, false}) {
                   g[v].push_back(uti);
               }
           }
           for (int u = 0; u < n; ++u) {
               if (ops[u] != pair{false, false}) continue;
               for (int v: g[u]) {
                   if (ops[v] == pair{true, false} || ops[v] == pair{false, true}) {
                       g[u].push_back(sti);
                       break;
                   }
               }
           }
           for (int u = 0; u < n; ++u) {
               for (int v: g[u]) {
                   if (ops[v] != pair{false, false}) continue;
                   if (ops[u] == pair{true, false} || ops[v] == pair{true, true}) {
                       g[uti].push_back(v);
                   }
               }
           }
       } else {
           for (int v = 0; v < n; ++v) {
               if (ops[v] == pair{false, false}) {
                   g[v].push_back(sti);
               }
           }
       }
   }
   vector<int> visited(n);
   vector<int> order;
   function<bool(int)> dfs = [&](int u) {
       visited[u] = 1;
       bool res = true;
       for (int v: g[u]) {
           if (visited[v] == 1) {
               return false;
           }
           if (visited[v] == 2) {
               continue;
           }
           res = res && dfs(v);
       }
       visited[u] = 2;
       order.push_back(u);
       return res;
   };
   bool res = true;
   for (int u = 0; u < n; ++u) {
       if (ops[u] == pair{false, false})
       if (visited[u] == 0)
            res = res && dfs(u);
   }
    for (int u = 0; u < n; ++u) {
        if (visited[u] == 0)
            res = res && dfs(u);
    }
   if (not res) {
       cout << "-1";
   } else {
       for (int i = order.size() - 1; i >= 0; --i) {
           cout << order[i] + 1 << ' ';
       }
   }

}
