#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <deque>
#include <queue>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <ctime>
#include <chrono>
#include <random>
#include <functional>
#include <stack>
#include <cassert>
#include <climits>
using namespace std;
using ll = long long;
using db = double;
using ldb = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vint = vector<int>;
using vvint = vector<vint>;
using vll = vector<ll>;
using vvll= vector<vll>;
using vst = vector<string>;
using vpll = vector<pll>;
using vpii = vector<pii>;
using vldb = vector<ldb>;
using t3ll = tuple<ll, ll, ll>;
#define all(x) x.begin(), x.end()
#define forp(i,s,f) for(int i = s; i < f; ++i) 
#define form(i,s,f) for(int i = s; i > f; --i) 
#define size(x) int(x.size())
#define dprint(x) for(auto now: x) cout << now << '\n'

void solve() {
	ll n;
	cin >> n;
	vll sp(n);
	map<ll, ll> pos;
	map < pll, bool> sl;
	forp(i, 0, n) {
		cin >> sp[i];
		pos[sp[i]] = i;
	}
	forp(i, 1, n + 1) {
		forp(j, i + 1, n + 1) {
			if (pos[i] < pos[j]) {
				sl[{i, j}] = true;
				sl[{j, i}] = true;
			}
			else {
				sl[{j, i}] = true;
			}
		}
	}
	vll now(n);
	forp(i, 0, n) now[i] = i + 1;
	vst ans;
	form(k, n - 1, -1) {
		int i = n - 1;
		int ind = i - 1;
		while (i >= 0 and ind >= 0 and sl[{now[i], now[ind]}]) {
			ans.push_back(to_string(now[i]) + " " + to_string(now[ind]));
			
			sl[{now[i], now[ind]}] = false;
			swap(now[i], now[ind]);
			i--;
			--ind;

		}
	}
	cout << size(ans) << '\n';
	dprint(ans);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}