#include <bits/stdc++.h>

using namespace std;

void solve() {

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<vector<int>> g(n);
    vector<pair<int, int>> value(n);
    for (int i = 0; i < n; ++i) {
        string a, b;
        cin >> a >> b;
        if (a == "set") {
            value[i].first = 0;
        } else {
            value[i].first = 1;
        }
        if (b == "true") {
            value[i].second = 1;
        } else {
            value[i].second = 0;
        }
    }
    int m;
    cin >> m;
    vector<int> deg(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        deg[b]++;
    }
    auto f = [&](int ind) -> pair<int, int> {
        if (value[ind].second == 1) {
            if (value[ind].first == 0) {
                return {0, 1};
            } else {
                return {1, 0};
            }
        } else {
            if (value[ind].first == 0) {
                return {1, 1};
            } else {
                return {0, 0};
            }
        }
    };
    vector<int> st00, st01, st10, st11;
    auto add = [&](int i) -> void {
        auto tmp = f(i);
        if (tmp.first == 0 && tmp.second == 1) {
            st01.push_back(i);
        }
        if (tmp.first == 0 && tmp.second == 0) {
            st00.push_back(i);
        }
        if (tmp.first == 1 && tmp.second == 0) {
            st10.push_back(i);
        }
        if (tmp.first == 1 && tmp.second == 1) {
            st11.push_back(i);
        }
    };
    auto del = [&](int i) {
        for (int v : g[i]) {
            --deg[v];
            if (!deg[v]) {
                add(v);
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!deg[i]) {
            add(i);
        }
    }
    vector<int> ans;
    int state = 0;
    while (true) {
        if (state == 0) {
            while (st00.size()) {
                ans.push_back(st00.back());
                st00.pop_back();
                del(ans.back());
            }
            if (st01.size()) {
                ans.push_back(st01.back());
                st01.pop_back();
                del(ans.back());
                state ^= 1;
            } else {
                break;
            }
        } else if (state == 1) {
            while (st11.size()) {
                ans.push_back(st11.back());
                st11.pop_back();
                del(ans.back());
            }
            if (st10.size()) {
                ans.push_back(st10.back());
                st10.pop_back();
                del(ans.back());
                state ^= 1;
            } else {
                break;
            }
        }
    }
    if (ans.size() != n) {
        cout << "-1\n";
    } else {
        for (int i : ans) {
            cout << i + 1 << ' ';
        }
        cout << '\n';
    }
}
