#include <iostream>
#include <vector>

#define ll long long

using namespace std;

int main() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);

    vector<pair<ll, ll>> ans;
    for(int i = 0; i < n; i++){
        cin >> a[i];
        b[i] = i + 1;
    }

    vector<vector<bool>> swapped(n + 1, vector<bool>(n + 1));

    for(int number = n; number >= 1; number--) {
        ll pos = 0;
        for(; pos < number - 1; pos++){
            if(a[pos] == number){
                break;
            }
        }

        for(;pos + 1 < number; pos++){
            swapped[a[pos]][a[pos + 1]] = true;
            swapped[a[pos + 1]][a[pos]] = true;

            ans.push_back(make_pair(number, a[pos + 1]));
            ll t = a[pos + 1];
            a[pos + 1] = a[pos];
            a[pos] = t;
        }
    }

    ans = vector<pair<ll, ll>>(ans.rbegin(), ans.rend());

//    for(int i = 0; i < n; i++){
//        cout << a[i] << " ";
//    }

    for(int i = 0; i < n; i++){
        int cnt = 0;
        for(int j = i + 1; j < n; j++){
            if(swapped[i + 1][j + 1]){
                break;
            }

            ans.push_back(make_pair(j + 1, i + 1));
            cnt++;
        }
        for(int j = i + cnt; j > i; j--){
            ans.push_back(make_pair(i + 1, j + 1));
        }

    }

    cout << ans.size() << endl;
    for(int i = 0; i < ans.size(); i++){
        cout << ans[i].first << " " << ans[i].second << endl;
    }

    return 0;
}
