#include <bits/stdc++.h>

using namespace std;
#define ll long long

vector<set<int>> g;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        string s1;
        string s2;
        cin >> s1 >> s2;
        g.resize(2 * n);
        g.assign(2 * n, set<int> ());
        set<pair<int, int>> free;
        vector<int> neighs(2 * n);
        int frees = 0;
        for (int i = 0; i < n; ++i) {
            ++frees;
            int neighbors = 0;
            if (s1[i] == '.') {
                if (i > 0 && s1[i - 1] == '.') {
                    g[i].insert(i - 1);
                    ++neighbors;
                }
                if (i + 1 < n && s1[i + 1] == '.') {
                    g[i].insert(i + 1);
                    ++neighbors;
                }
                if (s2[i] == '.') {
                    g[i].insert(i + n);
                    ++neighbors;
                }
                free.insert({neighbors, i});
                neighs[i] = neighbors;
            }
            neighbors = 0;
            if (s2[i] == '.') {
                if (i > 0 && s2[i - 1] == '.') {
                    g[i + n].insert(i + n - 1);
                    ++neighbors;
                }
                if (i + 1 < n && s2[i + 1] == '.') {
                    g[i + n].insert(i + n + 1);
                    ++neighbors;
                }
                if (s1[i] == '.') {
                    g[i + n].insert(i);
                    ++neighbors;
                }
                free.insert({neighbors, i + n});
                neighs[i + n] = neighbors;
            }
        }
        int ok = 0;
        if (frees % 2 == 1) {
            cout << "None\n";
            continue;
        }
        while (!free.empty()) {
            pair<int, int> pr = (*free.begin());
            if (pr.first == 0) {
                ok = -1;
                break;
            }
            if (pr.first > 1) {
                ok = 1;
                break;
            }
            int v = pr.second;
            int u = (*g[v].begin());
            g[v].clear();
            for (int q : g[u]) {
                if (q == v) continue;
                g[q].erase(u);
                free.erase({neighs[q], q});
                --neighs[q];
                free.insert({neighs[q], q});
            }
            g[u].clear();
            free.erase({neighs[v], v});
            free.erase({neighs[u], u});
            neighs[v] = neighs[u] = 0;
        }
        if (ok == -1) {
            cout << "None\n";
        } else if (ok == 0) {
            cout << "Unique\n";
        } else {
            cout << "Multiple\n";
        }
    }
}
