#include <bits/stdc++.h>

using namespace std;
#define ll long long

vector<set<int>> g;
vector<bool> used;

int comp(int v) {
    used[v] = true;
    int sm = 0;
    for (int q : g[v]) {
        if (used[q]) continue;
        sm += comp(q);
    }
    return sm + 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        string s1, s2;
        cin >> s1 >> s2;
        g.resize(2 * n);
        g.assign(2 * n, set<int> ());
        used.resize(2 * n);
        used.assign(2 * n, false);
        set<pair<int, int>> free;
        int smEven = 0;
        int smOdd = 0;
        for (int i = 0; i < n; ++i) {
            if (s1[i] != '.') {
                used[i] = true;
                continue;
            }
            if (i % 2 == 0) ++smEven;
            else ++smOdd;
            if (i > 0 && s1[i - 1] == '.') {
                g[i].insert(i - 1);
            }
            if (i + 1 < n && s1[i + 1] == '.') {
                g[i].insert(i + 1);
            }
            if (s2[i] == '.') {
                g[i].insert(i + n);
            }
            free.insert({g[i].size(), i});
        }

        for (int i = 0; i < n; ++i) {
            if (s2[i] != '.') {
                used[i + n] = true;
                continue;
            }

            if (i % 2 == 0) ++smOdd;
            else ++smEven;
            if (i > 0 && s2[i - 1] == '.') {
                g[i + n].insert(i + n - 1);
            }
            if (i + 1 < n && s2[i + 1] == '.') {
                g[i + n].insert(i + n + 1);
            }
            if (s1[i] == '.') {
                g[i + n].insert(i);
            }
            free.insert({g[i + n].size(), i + n});
        }
        bool ok1 = true;
        for (int i = 0; i < 2 * n; ++i) {
            if (used[i]) continue;
            if (comp(i) % 2 == 1) {
                ok1 = false;
                break;
            }
        }
        if (!ok1 || (smOdd != smEven)) {
            cout << "None\n";
            continue;
        }
        bool ok = true;
        while (!free.empty()) {
            auto pr = *free.begin();
            if (pr.first == 0) {
                ok = false;
                cout << "None\n";
                break;
            }
            if (pr.first > 1) {
                ok = false;
                cout << "Multiple\n";
                break;
            }

            int v = pr.second;
            int u = *g[v].begin();
            free.erase(free.find(pr));
            free.erase(free.find({g[u].size(), u}));
            for (int q : g[u]) {
                if (q == v) continue;
                free.erase(free.find({g[q].size(), q}));
                g[q].erase(u);
                free.insert({g[q].size(), q});
            }
            g[u].clear();
            g[v].clear();
        }
        if (ok) {
            cout << "Unique\n";
        }
    }
}