#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long

int val(string &v, string &v1, int i) {
    if(i >= v.size()){
        return -1;
    }
    int res = 0;
    if (v[i] == '#') {
        res += 1;
    }
    if (v1[i] == '#') {
        res += 2;
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    string st1, st2;
    cin >> st1 >> st2;
    vector<int> st_col_pos(n, 0);
    for (int i = 0; i < n; i++) {
        st_col_pos[i] = val(st1, st2, i);
    }
    vector<vector<int>> dp(4, vector<int>(n + 1, 0));
    dp[val(st1, st2, 0)][0] = 1;
    for (int i = 0; i < n; i++) {
        for (int pos = 0; pos < 4; pos++) {
            if(dp[pos][i]<1){
                continue;
            }
            if(pos == 0){
                dp[3][i] += dp[pos][i];
                if(val(st1, st2, i+1) == 0){
                    dp[3][i+1] += dp[pos][i];
                }
            }
            else if(pos == 1){
                if(val(st1, st2, i+1) == 0){
                    dp[2][i+1] += dp[pos][i];
                }
                if(val(st1, st2, i+1) == 1){
                    dp[3][i+1] += dp[pos][i];
                }
            }
            else if(pos == 2){
                if(val(st1, st2, i+1) == 0){
                    dp[1][i+1] += dp[pos][i];
                }
                if(val(st1, st2, i+1) == 2){
                    dp[3][i+1] += dp[pos][i];
                }
            }
            else{
                if (val(st1,st2, i+1) >= 0){
                    dp[val(st1,st2,i+1)][i+1] += dp[pos][i];
                }
            }
        }
    }
//    for(auto st : dp){
//        for( auto i : st){
//            cout << i << " ";
//        }
//        cout << endl;
//    }
    if (dp[3][n - 1] == 0) {
        cout << "None" << endl;
    } else if (dp[3][n - 1] == 1) {
        cout << "Unique" << endl;
    } else {
        cout << "Multiple" << endl;
    }

}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
