#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;

const int N = 1e5 + 10;
vector<int> g[N];

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<bool> set_type(n), bool_type(n);
    for (int i = 0; i < n; i++) {
        string s1, s2;
        cin >> s1 >> s2;
        if (s1 == "set") {
            set_type[i] = 1;
        }

        if (s2 == "true") {
            bool_type[i] = 1;
        }
    }

    int m;
    cin >> m;
    vector<pair<int, int>> edges(m);
    for (int i = 0; i < m; i++) {
        cin >> edges[i].first >> edges[i].second;
        edges[i].first--, edges[i].second--;

        g[edges[i].first].pb(edges[i].second);
    }

    int set_true = -1, unset_true = -1;

    auto is_unset_true = [&](int i) -> bool {
        if (bool_type[i] == 1 && set_type[i] == 0) {
            return 1;
        }
        return 0;
    };

    auto is_set_true = [&](int i) -> bool {
        if (bool_type[i] == 1 && set_type[i] == 1) {
            return 1;
        }
        return 0;
    };

    auto is_set_false = [&](int i) -> bool {
        if (bool_type[i] == 0 && set_type[i] == 1) {
            return 1;
        }
        return 0;
    };

    auto is_unset_false = [&](int i) -> bool {
        if (set_type[i] == 0 && bool_type[i] == 0) {
            return 1;
        }
        return 0;
    };

    for (int i = 0; i < n; i++) {
        if (is_set_true(i)) {
            if (set_true != -1) {
                cout << -1 << endl;
                return 0;
            }
            set_true = i;
        }

        if (is_unset_true(i)) {
            if (unset_true != -1) {
                cout << -1 << endl;
                return 0;
            }
            unset_true = i;
        }
    }

    vector<int> ord;

    if (set_true != -1 && unset_true != -1) {
        deque<int> q;
        vector<int> cnt(n);

        for (int i = 0; i < m; i++) {
            cnt[edges[i].second]++;
        }

        for (int i = 0; i < n; i++) {
            if (cnt[i] == 0 && is_unset_false(i)) {
                q.pb(i);
            }
        }
        map<int, int> used;
        while (q.size() > 0) {
            int v = q.front();
            q.pop_front();
            ord.pb(v);
            used[v] = 1;
            for (auto u : g[v]) {
                cnt[u]--;
                if (cnt[u] == 0 && is_unset_false(u)) {
                    q.pb(u);
                }
            }
        }

        ord.pb(set_true);

        for (auto u : g[set_true]) {
            cnt[u]--;
        }

        for (int i = 0; i < n; i++) {
            if (cnt[i] == 0 && is_set_false(i)) {
                q.pb(i);
            }
        }

        while (q.size() > 0) {
            int v = q.front();
            q.pop_front();
            ord.pb(v);

            for (auto u : g[v]) {
                cnt[u]--;
                if (cnt[u] == 0 && is_set_false(u)) {
                    q.pb(u);
                }
            }
        }

        ord.pb(unset_true);

        for (auto u : g[unset_true]) {
            cnt[u]--;
        }

        for (int i = 0; i < n; i++) {
            if (cnt[i] == 0 && is_unset_false(i)) {
                q.pb(i);
            }
        }

        while (q.size() > 0) {
            int v = q.front();
            q.pop_front();
            if (used[v]) continue;
            ord.pb(v);
            for (auto u : g[v]) {
                cnt[u]--;
                if (cnt[u] == 0 && is_unset_false(u)) {
                    q.pb(u);
                }
            }
        }
    } else if (set_true != -1) {
        deque<int> q;
        vector<int> cnt(n);

        for (int i = 0; i < m; i++) {
            cnt[edges[i].second]++;
        }

        for (int i = 0; i < n; i++) {
            if (cnt[i] == 0 && is_unset_false(i)) {
                q.pb(i);
            }
        }

        while (q.size() > 0) {
            int v = q.front();
            q.pop_front();
            ord.pb(v);
            for (auto u : g[v]) {
                cnt[u]--;
                if (cnt[u] == 0 && is_unset_false(u)) {
                    q.pb(u);
                }
            }
        }

        ord.pb(set_true);

        for (auto u : g[set_true]) {
            cnt[u]--;
        }

        for (int i = 0; i < n; i++) {
            if (cnt[i] == 0 && is_set_false(i)) {
                q.pb(i);
            }
        }

        while (q.size() > 0) {
            int v = q.front();
            q.pop_front();
            ord.pb(v);

            for (auto u : g[v]) {
                cnt[u]--;
                if (cnt[u] == 0 && is_set_false(u)) {
                    q.pb(u);
                }
            }
        }
    } else if (unset_true == -1) {
        deque<int> q;
        vector<int> cnt(n);

        for (int i = 0; i < m; i++) {
            cnt[edges[i].second]++;
        }

        for (int i = 0; i < n; i++) {
            if (cnt[i] == 0 && is_unset_false(i)) {
                q.pb(i);
            }
        }

        while (q.size() > 0) {
            int v = q.front();
            q.pop_front();
            ord.pb(v);
            for (auto u : g[v]) {
                cnt[u]--;
                if (cnt[u] == 0 && is_unset_false(u)) {
                    q.pb(u);
                }
            }
        }
    }
    if (ord.size() != n) {
        cout << -1 << endl;
        return 0;
    }

    bool flag = 0, good = 1;

    for (int v : ord) {
        if (is_set_true(v)) {
            good &= flag == 0;
            flag = 1;
        } else if (is_set_false(v)) {
            good &= flag == 1;
            flag = 1;
        } else if (is_unset_true(v)) {
            good &= flag == 1;
            flag = 0;
        } else if (is_unset_true(v)) {
            good &= flag == 0;
            flag = 0;
        }
    }

    if (good) {
        for (int v : ord) {
            cout << v + 1 << ' ';
        }
        cout << endl;
    } else {
        cout << -1 << endl;
    }
    return 0;
}
