#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;

int a[2][N];
int dp[N][2][2];

void solve() {
    int n;
    cin >> n;
    vector<string> s(2);
    cin >> s[0] >> s[1];
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            a[i][j] = s[i][j] == '#';
        }
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < 2; ++j) {
            for (int k = 0; k < 2; ++k) {
                dp[i][j][k] = 0;
            }
        }
    }
    dp[0][1][1] = 1;
    for (int i = 0; i < n; ++i) {
        for (int x = 0; x < 2; ++x) {
            for (int y = 0; y < 2; ++y) {
                if (dp[i][x][y] == 0) continue;
                for (int x1 = 0; x1 < 2; ++x1) {
                    for (int y1 = 0; y1 < 2; ++y1) {
                        for (int z = 0; z < 2; ++z) {
                            if (x1 && z) continue;
                            if (y1 && z) continue;
                            if ((x || a[0][i]) && x1) continue;
                            if ((y || a[1][i]) && y1) continue;
                            if ((a[0][i] || a[1][i]) && z) continue;
                            if (!x && !x1) continue;
                            if (!y && !y1) continue;
                            int x2 = x1 | z | a[0][i];
                            int y2 = y1 | z | a[1][i];
                            dp[i + 1][x2][y2] = min(2, dp[i + 1][x2][y2] + dp[i][x][y]);
                        }
                    }
                }
            }
        }
    }
    int ans = dp[n][1][1];
    if (ans == 0) {
        cout << "None\n";
    } else if (ans == 1) {
        cout << "Unique\n";
    } else {
        cout << "Multiple\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
