#include <iomanip>
#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long

using namespace std;

void solve();

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}
}

void solve() {
	int n;
	cin >> n;
	vector<vector<char>> floor(2, vector<char>(n));
	vector<vector<ll>> dp(n + 1, vector<ll>(4));

	for (int i = 0; i < 2; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> floor[i][j];
		}
	}

	ll prev;
	bool st = true;
	ll ans = 0;
	dp[0][3] = 1;
	int move[4][4]{};
	move[0][0] = move[0][3] = 1;
	move[1][2] = move[2][1] = 1;
	move[3][0] = 1;

	for (int i = 1; i <= n; ++i) {
		for (int from = 0; from < 4; ++from) {
			if (dp[i - 1][from] == 0) continue;

			for (int to = 0; to < 4; ++to) {
				if ((to & 1) && floor[0][i - 1] == '#' || (to & 2) && floor[1][i - 1] == '#') continue;
				if (move[from][to] == 0) continue;
				int k = 0;
				if (floor[0][i - 1] == '#') k |= 1;
				if (floor[1][i - 1] == '#') k |= 2;

				dp[i][to | k] += dp[i - 1][from];
			}
		}
	}

	ans += dp[n][3] + dp[n][0];

	if (ans == 0) {
		cout << "None\n";
	}
	else if (ans == 1) {
		cout << "Unique\n";
	}
	else {
		cout << "Multiple\n";
	}
}