#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <bits/stdc++.h>


#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()

using namespace std;

int32_t main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
#define pb push_back
#define F first
#define S second
    int n;
    cin>>n;
    vector<int> cnt[2][2];

    vector<pair<int,int>> vec(n);
    for(int i=0;i<n;i++){
        string t,s;
        cin>>t>>s;
        if(t=="unset"){
            if(s=="true"){
                cnt[0][1].pb(i);
                vec[i]={0,1};
            }
            else {
                cnt[0][0].pb(i);
                vec[i]={0,0};
            }
        }
        else {
            if(s=="true"){
                cnt[1][1].pb(i);
                vec[i]={1,1,};
            }
            else {
                cnt[1][0].pb(i);
                vec[i]={1,0};
            }
        }
    }


    int m;
    cin>>m;
    vector<vector<int>> edges(n);
    vector<int> out_degree(n);
    for(int i=0;i<m;i++){
        int x,y;
        cin>>x>>y;
        x--,y--;
        edges[x].pb(y);
        out_degree[y]++;
    }
    if((int)cnt[0][1].size()>1 || (int)cnt[1][1].size()>1){
        cout<<-1<<"\n";
        return 0;
    }

    vector<int> leaves[2][2];
    for(int i=0;i<n;i++){
        if(out_degree[i]==0){
            leaves[vec[i].F][vec[i].S].pb(i);
        }
    }

    auto _del=[&](int node){
        for(auto v:edges[node]){
            out_degree[v]--;
            if(out_degree[v]==0){
                leaves[vec[v].F][vec[v].S].pb(v);
            }
        }
    };

    vector<int> ans;
    auto go=[&](vector<int>& cur){
        bool flag=false;
        while(!cur.empty()){
            int x=cur.back();
            cur.pop_back();
            _del(x);
            ans.pb(x);

            flag=true;
        }
        return flag;
    };

    go(leaves[0][0]);
    if(go(leaves[1][1])){
        go(leaves[1][0]);
        if(go(leaves[0][1])){
            go(leaves[0][0]);
        }
    }
    if((int)ans.size()!=n){
        cout<<-1<<"\n";
    }
    else {
        for(auto v:ans){
            cout<<v+1<<" ";
        }cout<<"\n";
    }
}