#include <bits/stdc++.h>
using namespace std;
vector<vector<bool> > calc_f(string a, string b) {
    int n = a.size();
    bool dp[n+1][4];
    for (int i = 0; i <= n; i++)
        for (int j = 0; j < 4; j++)
            dp[i][j] = false;
    a = ' '+a;
    b = ' '+b;
    dp[0][3] = true;
    for (int i = 1; i <= n; i++) {
        if (a[i] == '#') {
            if (b[i] == '#') {
                for (int j = 0; j < 4; j++)
                    dp[i][j] = dp[i-1][j];
            }
            else {
                if (dp[i-1][1]) {
                    dp[i][3] = true;
                }
                if (dp[i-1][3]) {
                    dp[i][1] = true;
                }
            }
        }
        else {
            if (b[i] == '#') {
                if (dp[i-1][2]) {
                    dp[i][3] = true;
                }
                if (dp[i-1][3]) {
                    dp[i][2] = true;
                }
            }
            else {
                if (dp[i-1][0]) {
                    dp[i][3] = true;
                }
                if (dp[i-1][1]) {
                    dp[i][1] = true;
                }
                if (dp[i-1][2]) {
                    dp[i][2] = true;
                }
                if (dp[i-1][3]) {
                    dp[i][0] = true;
                    dp[i][3] = true;
                }
            }
        }
    }
    vector<vector<bool> > res;
    for (int i = 1; i <= n; i++) {
        vector<bool> t1;
        for (int j = 0; j < 4; j++)
            t1.push_back(dp[i][j]);
        res.push_back(t1);
    }
    return res;
}
void solve() {
    int n;
    cin >> n;
    string s1, s2;
    cin >> s1 >> s2;
    vector<vector<bool> > p1 = calc_f(s1, s2);
    reverse(s1.begin(), s1.end());
    reverse(s2.begin(), s2.end());
    vector<vector<bool> > p2 = calc_f(s1, s2);
    reverse(p2.begin(), p2.end());
    if (!p2[0][3]) {
        cout << "None" << "\n";
        return;
    }
    if (n == 1) {
        if (p1[0][3])
            cout << "Unique" << "\n";
        return;
    }
    if (s1[0] == '.' && s2[0] == '.') {
        if (p2[1][0] && p2[1][3]) {
            cout << "Multiple" << "\n";
            return;
        }
    }
    if (s1[n-1] == '.' && s2[n-1] == '.') {
        if (p1[n-2][0] && p2[n-2][3]) {
            cout << "Multiple" << "\n";
            return;
        }
    }
    for (int i = 1; i < n-1; i++) {
        int k = 0;
        if (s1[i] == '.' && s2[i] == '.') {
            if (p1[i-1][3] && p2[i][0])
                k++;
            if (p1[i][0] && p2[i][3])
                k++;
            if (p1[i][2] && p2[i][1])
                k++;
            if (p1[i][1] && p2[i][2])
                k++;
            if (p1[i-1][3] && p2[i+1][3])
                k++;
        }
        if (k > 1) {
            cout << "Multiple" << "\n";
            return;
        }
    }
    cout << "Unique" << "\n";
    return;
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int q;
    cin >> q;
    while (q--)
        solve();
}
