#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define int ll

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<ll> a(n), d(n), l(m);
    for (auto &el: a) cin >> el;
    for (auto &el: d) cin >> el;
    for (auto &el: l) cin >> el;

    ll curtime = 0;
    vector<int> order(n);
    iota(begin(order), end(order), 0);
    ranges::sort(order, [&d](const int l, const int r) { return d[l] < d[r]; });
    // start time
    vector<ll> dz(n);
    // end time
    vector<ll> film(m);

    for (auto i : order) {
        dz[i] = curtime;
        curtime += a[i];
    }

//    cout << "DZ0: ";
//    //check
//    for (auto i : order) {
//        cout << dz[i] << ' ';
//    }
//    cout << endl;

    curtime = 1e18;
    for (int j = n - 1; j >= 0; --j) {
        int i = order[j];
        // may be -1
        curtime = min(curtime, d[i]);
        dz[i] = curtime - a[i];
        curtime -= a[i];
    }

//    cout << "DZ1 ";
//    //check
//    for (auto i : order) {
//        cout << dz[i] << ' ';
//    }
//    cout << endl;

    curtime = 0;
    int ifilm = 0;
    for (auto idz: order) {
        while (ifilm < m && l[ifilm] + curtime <= dz[idz]) {
            film[ifilm] = curtime + l[ifilm];
            curtime = film[ifilm]; // maybe + 1;
            ++ifilm;
        }
        dz[idz] = curtime;
        curtime += a[idz];
    }
    while (ifilm < m) {
        film[ifilm] = curtime + l[ifilm];
        curtime = film[ifilm]; // maybe + 1;
        ++ifilm;
    }
//
//    cout << "FILM ";
//    //check
//    for (auto el : film) {
//        cout << el << ' ';
//    }
//    cout << endl;

    while (q--) {
        ll t;
        cin >> t;
        // bin search
        auto it = upper_bound(begin(film), end(film), t);
        cout << it - begin(film) << ' ';
    }
    cout << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    cout.flush();
}
