#include<iostream>
#include<cmath>
#include<vector>
#include<map>
using namespace std;
using pint = pair<int, int>;
#define pb push_back
#define fr first
#define sc second
#define ll long long 
#define vll vector<ll>
void solve() {
	ll n; cin >> n;

	ll indSet = -1, indUnset = -1;
	bool thereIsSet = false;
	bool can = true;
	vector<pair<string, string>> res(n);
	for (ll i = 0; i < n; ++i) {
		cin >> res[i].first >> res[i].second;
		thereIsSet = thereIsSet | res[i].first == "set";
		if (res[i].second == "true") {
			if (res[i].first == "set") {
				if (indSet != -1)
					can = false;
				indSet = i;
			}
			else {
				if (indUnset != -1)
					can = false;
				indUnset = i;
			}
		}
	}

	ll m; cin >> m;

	vll cnt(n, 0);
	vector<vll> edges(n, vll(0));

	while (m--) {
		ll f, s; cin >> f >> s;
		f--;
		s--;

		edges[f].pb(s);
		cnt[s]++;
	}

	if (!can || indUnset != -1 && indSet == -1 || thereIsSet && indSet == -1) {
		cout << -1 << '\n';
		return;
	}

	if (indSet != -1) {
		for (ll i = 0; i < n; ++i) {
			if (res[i].first == "set" && i != indSet) {
				edges[indSet].pb(i);
				cnt[i]++;
			}
		}
	}

	vll bfs(0);
	for (ll i = 0; i < n; ++i) {
		if (!cnt[i])
			bfs.pb(i);
	}

	vector<bool> wasSet(n, false);
	vector<bool> wasUnset(n, false);
	vector<bool> wasSetT(n, false);
	vector<bool> wasUnsetT(n, false);

	ll ind = 0;

	vector<vll> ans(3, vll(0));
	if (indUnset != -1)
		ans[2].pb(indUnset);

	while (ind < bfs.size()) {
		ll cur = bfs[ind];
		++ind;

		//cout << cur << '\n';

		if (res[cur].first == "set") {
			ans[1].pb(cur);
		}

		if (res[cur].first == "unset" && res[cur].second != "true") {
			if (wasSetT[cur] || wasUnsetT[cur] || res[cur].second == "true") {
				ans[2].pb(cur);
			}
			else {
				ans[0].pb(cur);
			}
		}

		if (res[cur].first == "unset" && wasSet[cur] && indUnset == -1) {
			cout << -1 << '\n';
			return;
		}

		if (res[cur].first == "unset" && res[cur].second == "true" && wasUnset[cur] && wasSetT[cur]) {
			cout << -1 << '\n';
			return;
		}

		if (res[cur].first == "set" && wasSet[cur] && wasUnset[cur]) {
			cout << -1 << '\n';
			return;
		}

		if (res[cur].first == "set") {
			wasSet[cur] = true;
			if (res[cur].second == "true") {
				wasSetT[cur] = true;
			}
		}

		if (res[cur].first == "unset") {
			wasUnset[cur] = true;
			if (res[cur].second == "true") {
				wasUnsetT[cur] = true;
			}
		}

		for (auto& i : edges[cur]) {
			cnt[i]--;
			wasSet[i] = wasSet[i] | wasSet[cur];
			wasUnset[i] = wasUnset[i] | wasUnset[cur];
			wasSetT[i] = wasSetT[i] | wasSetT[cur];
			wasUnsetT[i] = wasUnsetT[i] | wasUnsetT[cur];

			if (!cnt[i]) {
				bfs.pb(i);
			}
		}

	}

	for (auto& i : cnt) {
		if (i) {
			cout << -1 << '\n';
			return;
		}
	}

	for (auto& j : ans) {
		for (auto& i : j)
			cout << i + 1 << ' ';
	}
}

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);

	ll t = 1; 
	//cin >> t;
	while (t--)
		solve();
}