#include <iostream>
#include <vector>

using namespace std;

void Apply(string& s, int pos1=-1, int pos2=-1) {
    if (pos1 == pos2) {
        return;
    }
    string res;
    for (int i = 0; i < pos2; i++) {
        if (i != pos1) {
            res += s[i];
        }
    }
    res += s[pos1];
    for (int i = pos2; i < s.size(); i++) {
        if (i != pos1) {
            res += s[i];
        }
    }
    s = res;
}

bool Valid(string s, int pos1 = -1, int pos2 = -1) {
    if (pos1 != -1) {
        Apply(s, pos1, pos2);
    }
    bool isF = 1;
    long long s1 = 0, s2 = 0;
    bool isPos = 1;
    string cur;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] >= '0' && s[i] <= '9') {
            cur += s[i];
        } else if (s[i] == '+' || s[i] == '-' || s[i] == '=') {
            if (cur[0] == '0' && cur.size() != 1) {
                return false;
            }
            if (cur.size() == 0) {
                return false;
            }
            long long x = 0;
            for (auto c : cur) {
                x *= 10;
                x += (c - '0');
            }
            if (x >= 1e10) {
                return false;
            }
            if (isF) {
                s1 += (isPos ? x : -x);
            } else {
                s2 += (isPos ? x : -x);
            }
            if (s[i] == '-') {
                isPos = 0;
            }
            if (s[i] == '+') {
                isPos = 1;
            }
            if (s[i] == '=') {
                isPos = 1;
                isF = 0;
            }
            cur = "";
        }
    }
    if (cur[0] == '0' && cur.size() != 1) {
        return false;
    }
    long long x = 0;
    for (auto c : cur) {
        x *= 10;
        x += (c - '0');
    }

    if (x >= 1e10) {
        return false;
    }
    if (isF) {
        s1 += (isPos ? x : -x);
    } else {
        s2 += (isPos ? x : -x);
    }
    if (s1 == s2) {
        if (pos1 != -1)
            cout << s << endl;
        return true;
    }
    return  false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    string s;
    cin >> s;
    if (Valid(s)) {
        cout << "Correct\n";
        return 0;
    }
    for (int i = 0; i < s.size(); i++) {
        if (s[i] >= '0' && s[i] <= '9') {
            for (int i1 = 0; i1 <= s.size(); i1++) {
                if (Valid(s, i, i1)) {
                    return 0;
                }
            }
        }
    }
    cout << "Impossible\n";
    return 0;
}
