#define _GLIBCXX_DEBUG 1
#pragma gcc optimize ("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define rsort(a) sort(a, [&] (auto b, auto c) {return b > c;})
using ll = long long;
using ld = long double;
using ull = unsigned long long; 
const ll inf = 1e18;
const ll MOD = 998244353;
struct var{
    ll m[2][2];
};
signed main(){
    int t;
    cin >> t;
    while(t --){
        int n;
        cin >> n;
        vector<pair<bool,bool>> a(n);
        for(int i = 0; i < n; i ++){
            char x;
            cin >> x;
            if(x == '#'){
                a[i].first = true;
            }else{
                a[i].first = false;
            }
        }
        for(int i = 0; i < n; i ++){
            char x;
            cin >> x;
            if(x == '#'){
                a[i].second = true;
            }else{
                a[i].second = false;
            }
        }
        vector<var> dp(n);
        dp[0].m[0][0] = 0;
        dp[0].m[0][1] = 0;
        dp[0].m[1][0] = 0;
        dp[0].m[1][1] = 0;
        if(a[0].first == false && a[0].second == false){
            dp[0].m[1][1] = 1;
        }
        dp[0].m[a[0].first][a[0].second] = 1;
        for(int i = 1; i < n; i ++){
            if(a[i].first == true && a[i].second == true){
                dp[i].m[0][0] = 0;
                dp[i].m[0][1] = 0;
                dp[i].m[1][0] = 0;
                dp[i].m[1][1] = dp[i - 1].m[1][1];
            }
            if(a[i].first == true && a[i].second == false){
                dp[i].m[0][0] = 0;
                dp[i].m[0][1] = 0;
                dp[i].m[1][0] = dp[i - 1].m[1][1];
                dp[i].m[1][1] = dp[i - 1].m[1][0];
            }
            if(a[i].first == false && a[i].second == true){
                dp[i].m[0][0] = 0;
                dp[i].m[0][1] = dp[i - 1].m[1][1];
                dp[i].m[1][0] = 0;
                dp[i].m[1][1] = dp[i - 1].m[0][1];
            }
            if(a[i].first == false && a[i].second == false){
                dp[i].m[0][0] = dp[i - 1].m[1][1];
                dp[i].m[0][1] = dp[i - 1].m[1][0];
                dp[i].m[1][0] = dp[i - 1].m[0][1];
                dp[i].m[1][1] = min(2ll, dp[i - 1].m[1][1] + dp[i - 1].m[0][0]);
            }
        }
        if(dp[n - 1].m[1][1] == 1){
            cout << "Unique" << endl;
            continue;
        }
        if(dp[n - 1].m[1][1] > 1){
            cout << "Multiple" << endl;
            continue;
        }
        if(dp[n - 1].m[1][1] == 0){
            cout << "None" << endl;
            continue;
        }
    }
}