#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

#define int long long

void solve() {

	int n; cin >> n;
	vector <string> tab(2);

	cin >> tab[0] >> tab[1];

	vector <vector <int> > dp(n + 1, vector <int>(3));

	dp[0][0] = 1;

	for (int i = 1; i <= n; i++) {

		for (int j = 2; j >= 0; j--) {

			if (j == 2) {
				if (tab[0][i - 1] == '#') {
					dp[i][j] = dp[i - 1][0];
					continue;
				}
				if (i == 1 || tab[0][i - 2] == '#')
					continue;
				dp[i][j] = dp[i - 1][1];
			}
			else if (j == 1) {
				if (tab[1][i - 1] == '#') {
					dp[i][j] = dp[i - 1][0];
					continue;
				}
				if (i == 1 || tab[1][i - 2] == '#')
					continue;
				dp[i][j] = dp[i - 1][2];
			}
			else {

				if (tab[1][i - 1] == '#') {
					dp[i][j] = dp[i][2];
					continue;
				}

				if (tab[0][i - 1] == '#') {
					dp[i][j] = dp[i][1];
					continue;
				}

				dp[i][j] = dp[i - 1][0];

				if (i >= 2 && tab[0][i - 2] == '.' && tab[1][i - 2] == '.') 
					dp[i][j] = min((int)2, dp[i][j] + dp[i - 2][0]);

			}

		}


	}

	if (dp[n][0] == 0)
		cout << "None\n";
	else if (dp[n][0] == 1)
		cout << "Unique\n";
	else
		cout << "Multiple\n";

}

signed main() {
#ifdef _DEBUG
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif

	int tt; cin >> tt;
	while (tt--)
		solve();

}