#include <iostream>
#include <vector>
#include <string>				
#include <algorithm>
using namespace std;

int main() {																																															
	int t;
	cin >> t;
	while (t--) {
		int n, m, q;
		cin >> n >> m >> q;
		vector<pair<long long, int>> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i].second;
		}
		for (int i = 0; i < n; i++) {
			cin >> a[i].first;
		}
		vector<int> b(m);
		for (int i = 0; i < m; i++) {
			cin >> b[i];
		}
		vector<int> request(q);
		for (int i = 0; i < q; i++) {
			cin >> request[i];
		}
		sort(a.begin(), a.end());
		vector<long long> a_pref(n + 1);
		for (int i = 1; i <= n; i++) {
			a_pref[i] = a_pref[i - 1] + a[i - 1].second;
		}
		vector<long long> a_min(n);
		a_min[n - 1] = a[n - 1].first - a_pref[n];
		for (int i = n - 2; i >= 0; i--) {
			a_min[i] = min(a_min[i+1], a[i].first - a_pref[i+1]);
		}
		vector<long long> res(m);
		int ind_a = 0;
		long long k = 0;
		for (int i = 0; i < m; i++) {
			while (ind_a != n && b[i] > (a_min[ind_a] - k)) {
				ind_a++;
			}
			k += b[i];
			res[i] = a_pref[ind_a] + k;
		}
		for (int i = 0; i < q; i++) {
			cout << upper_bound(res.begin(), res.end(), request[i]) - res.begin() << " ";
		}
		cout << "\n";
	}
}