#include <bits/stdc++.h>

#define pb push_back
#define vi vector<int>
#define pii pair<int,int>
#define vpii vector<pii>

using namespace std;



using ll = long long;

string s;
char c;
int pos;
string lex;
bool flag;

void nextChar(){
    if(pos < s.size()){
        c = s[pos];
        pos++;
    } else {
        c = '\n';
    }
}

ll number(){
    ll ans = 0;
    int cnt = 0;

    if('1' <= c && c <= '9'){
        ans = c - '0';
        cnt++;
        nextChar();
    } else {
        flag = false;
        return 0;
    }

    while('0' <= c && c <= '9'){
        ans *= 10;
        ans += (c - '0');
        cnt++;
        nextChar();
    }

    if(cnt > 10){
        flag = false;
    }
    return ans;
}

ll expression(){
    ll ans = number();

    int sign;
    while(c == '+' || c == '-'){
        if(c == '+'){
            sign = 1;
        } else {
            sign = -1;
        }

        nextChar();
        ans += sign * number();
    }

    return ans;
}

bool correctEquality(){
    if(s == "123456789+987654321=1111111010+11-1"){

    }

    ll left = expression();
    if(c != '='){
        flag = false;
    }
    nextChar();

    ll right = expression();

    //if(left == right) cout << s << ' ' << left << ' ' << right << ' ' << flag << ' ' << c << '\n';

    if(pos < s.size()){
        flag = false;
    }

    return (left == right) && flag;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    string s1;
    cin >> s1;

    int n = s1.size();

    s = s1;
    pos = 0;
    nextChar();
    flag = true;

    if(correctEquality()){
        cout << "Correct";
        return 0;
    }

    for(int i = 0; i < n; i++){
        for(int j = 0; j <= n; j++){
            if(i == j){
                continue;
            }

            string s2;

            char cc = s1[i];
            for(int k = 0; k <= n; k++){
               if(k == i){
                   continue;
               }

               if(k == j){
                  s2.pb(cc);
                  if(k < n){
                      s2.pb(s1[k]);
                  }
               } else {
                   s2.pb(s1[k]);
               }
            }

            //if(i == 1) cout << s2 << ' ' << j <<  '\n';

            s = s2;
            pos = 0;
            nextChar();
            flag = true;
            if(correctEquality()){
                cout << s;
                return 0;
            }

            swap(s[i], s[j]);
        }
    }

    cout << "Impossible";

    return 0;
}

/*
123456789+987654321=1111111100+11-1
123456789+987654321=1111111100+11-1
 */