#include <bits/stdc++.h>

using namespace std;

int add(int a, int b) {
    return min(2, a + b);
}

void solve() {
    int n; cin >> n;
    string s[2];
    cin >> s[0] >> s[1];
    s[0] = "#" + s[0];
    s[1] = "#" + s[1];

    vector <array <int, 4>> dp(n + 1, {0, 0, 0, 0});
    dp[0][3] = 1;

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < 4; j++) {
            int mask = (s[0][i] == '#') + (s[1][i] == '#') * 2;
            if (j == 2 && !(mask & 1)) {
                dp[i][mask | 1] = add(dp[i][mask | 1], dp[i - 1][j]);
            }
            if (j == 1 && !(mask & 2)) {
                dp[i][mask | 2] = add(dp[i][mask | 2], dp[i - 1][j]);
            }
            if (j == 0 && mask == 0) {
                dp[i][3] = add(dp[i][3], dp[i - 1][0]);
            }
            if (j == 3 && mask == 0) {
                dp[i][3] = add(dp[i][3], dp[i - 1][3]);
            }
            if (j == 3) {
                dp[i][mask] = add(dp[i][mask], dp[i - 1][3]);
            }
        }
    }

    if (dp[n][3] == 0) {
        cout << "None\n";
    } else if (dp[n][3] == 1) {
        cout << "Unique\n";
    } else {
        cout << "Multiple\n";
    }
}

int main() {
#ifdef LOCAL
    freopen( "input.txt" , "r", stdin );
    freopen( "output.txt" , "w", stdout );
#endif // LOcCAL

    int test; cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}
