#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()

using namespace std;

const ll mod = 1e9+7;
const ll MAXN = 1e5+10;

void start(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll gcd(ll a, ll b){
    while(a){
        b %= a;
        swap(a, b);
    }
    return b;
}


void solve(){
    int n;
    cin >> n;
    vector<int> c(n);
    for(int i = 0; i < n; ++i){
        cin >> c[i];
    }
    vector<pair<int, int>> ans;
    vector<int> tec(n);
    for(int i = 0; i < n; i++){
        tec[i] = i + 1;
    }
    for(int i = 0; i < n; i++){
        for(int j = 1; j < n - i; j++){
            ans.push_back({tec[j], tec[j - 1]});
            swap(tec[j], tec[j - 1]);
        }
    }
    int j;
    for(int i = 0; i < n; i++){
        j= 0;
        while(tec[j] != c[i]){
            j++;
        }
        for(; j > i; --j) {
            ans.push_back({tec[j], tec[j - 1]});
            swap(tec[j], tec[j - 1]);
        }
    }
    cout << ans.size() << "\n";
    for(auto [f, s] : ans){
        cout << f << " " << s << "\n";
    }

}

int main() {
    start();
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }

    return 0;
}
