#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

const ll mod = 1e9+7;
const ll MAXN = 1e5+10;

void start(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll gcd(ll a, ll b){
    while(a){
        b %= a;
        swap(a, b);
    }
    return b;
}

void solve(){
    int n;
    cin >> n;
    vector<int> a(n*2);
    map<int, pair<int, int>> gde;
    for(int i = 0; i < n*2; ++i){
        cin >> a[i];
        if(gde.count(a[i])){
            gde[a[i]].second = i;
        }else{
            gde[a[i]] = {i, -1};
        }

    }
    vector<vector<int>> g(n*2);
    int u, v;
    vector<int> st(n*2, 0);
    for(int i = 0; i < n*2 - 1; ++i){
        cin >> v >> u;
        v--, u--;
        g[v].push_back((u));
        g[u].push_back((v));
        st[u]++;
        st[v]++;
    }
    vector<bool> use(n * 2, false);
    vector<pair<int, int>> ans;
    set<pair<int, int>> l;
    for(int i = 0; i < n*2; ++i){
        l.insert({st[i], i});
    }
    while(l.size()){
        auto [_, v] = *l.begin();
        l.erase(l.begin());
        use[v] = true;
        for(auto u : g[v]){
            if (!use[u]){
                if(a[u] != a[v]){
                    auto [f, s] = gde[a[u]];
                    if(f == u){
                        f = s;
                    }
                    ans.push_back({v + 1, f + 1});
                    if (gde[a[v]].first == v)
                        gde[a[v]].first = f;
                    else
                        gde[a[v]].second = f;
                    swap(a[v], a[f]);
                }
                use[u] = true;
                l.erase({st[u], u});
                for(auto q : g[u]){
                    if(!use[q]){
                        l.erase({st[q], q});
                        st[q]--;
                        if(st[q] != 0){
                            l.insert({st[q], q});
                        }
                    }
                }
            }

        }
    }
    cout << ans.size() << endl;
    for(auto [f,s] : ans){
        cout << f << " " << s << endl;
    }
}

int main() {
    start();
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }

    return 0;
}
