#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>

using ll = long long;

using namespace std;

int main() {
	int n; cin >> n;
	vector<int> a(n), pos(n);
	for (auto& i : a) {
		static int j = 0;
		cin >> i; 
		pos[i - 1] = j++;
	}
	vector<int> p(n);
	for (int i = 0; i < n; i++) {
		p[i] = n - i - 1;
	}
	vector<pair<int, int>> ps;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			ps.push_back(make_pair(j, i));
		}
	}
	for (int i = 0; i < n; i++) {
		int np = pos[i];
		if (p[i] == np) continue;
		for (int j = i + 1; j < n; j++) {
			swap(p[i], p[j]), ps.push_back(make_pair(i, j));
			if (p[j] == np) break;
		}
	}
	cout << ps.size() << endl;
	for (auto i : ps) {
		cout << i.first + 1 << ' ' << i.second + 1 << endl;
	}
	return 0;
}

/*
1
10
#.......##
##..#.##..
*/