#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
 
using ll = long long;
 
using namespace std;
 
int main() {
    int n; cin >> n;
    vector<int> a(n), pos(n);
    for (auto& i : a) {
        static int j = 0;
        cin >> i; 
        pos[i - 1] = j++;
    }
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
		p[i] = i;
    }
    vector<pair<int, int>> ps;
    for (int i = 0; i < n; i++) {
		int id = -1;
		for (int j = i + 1; j < n; j++) {
			if (p[j] == pos[i]) {
				id = j;
			}
			else {
				ps.push_back(make_pair(i, j));
				ps.push_back(make_pair(j, i));
			}
		}
		if (id != i && id != -1) {	
			ps.push_back(make_pair(i, id));
			swap(p[i], p[id]);
		}
    }
    cout << ps.size() << endl;
    for (auto i : ps) {
        cout << i.first + 1 << ' ' << i.second + 1 << endl;
    }
    return 0;
}
 
/*
1
10
#.......##
##..#.##..
*/