#include <iostream>
#include <vector>
#include <unordered_set>
#include <set>
#include <algorithm>

using namespace std;

bool used[1002][1002];



int main() {
    ios::sync_with_stdio(0);
    cin.tie();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        int d = -1;
        for (int j = i; j < n; j++) {
            if (a[j] == i+1) {
                d = j;
                break;
            }
        }
        for (int j = d+1; j < n; j++) {
            ans.push_back({a[j], a[j-1]});
            swap(a[j], a[j-1]);
        }
        for (int j = n-2; j >= i; j--) {
            ans.push_back({a[j+1], a[j]});
            swap(a[j], a[j+1]);
        }
    }
    cout << ans.size() << "\n";
    std::reverse(ans.begin(), ans.end());
    for (auto p: ans) {
        cout << p.second << " " << p.first << "\n";
    }
    return 0;
}
