#include <bits/stdc++.h>
#define size(a) (ll)(a).size()
#define int long long

using namespace std;
typedef long double ld;
typedef long long ll;

const int INF = INT_MAX;
const int INF_LL = LLONG_MAX;
const ld EPS = 1e-9;
const ll MOD = 1e9 + 7;

map<int, char> hex_map;

void print_hex(int n) {
    int a = n;
    int b = a / 16;
    int c = b / 16;
    int d = c / 16;

    a %= 16;
    b %= 16;
    c %= 16;
    d %= 16;
    cout << hex_map[d] << hex_map[c] << hex_map[b] << hex_map[a] << " ";
}
//
//void emulate(vector<int> cmd, int idx, int last) {
//    while (size(cmd) < (1 << 12) - 1) {
//        cmd.push_back(0);
//    }
//    cmd.push_back(last);
//
//    int ip = 0;
//    int steps = 0;
//    while (ip < (1 << 12) - 1 and steps < (1 << 12)) {
//        steps++;
//        int a = cmd[ip];
//        int b = cmd[ip + 1];
//        int c = cmd[ip + 2];
//
//        cmd[b / 16] = cmd[b / 16] & ((1 << 12) - 1 - (1 << ))
//
//        ip = cmd[c];
//    }
//}

void add_jmp(vector<int>& cmd, int idx) {
    cmd.push_back(3 * 16);
    cmd.push_back(3 * 16);
    cmd.push_back(idx);
    cmd.push_back(0);
}

void add_placeholder(vector<int>& cmd) {
    cmd.push_back(0);
    cmd.push_back(0);
    cmd.push_back(0);
    cmd.push_back(0);
}

void add_copy(vector<int>& cmd, int from, int to, int k_from, int k_to, int nxt) {
    cmd.push_back(from * 16 + k_from);
    cmd.push_back(to * 16 + k_to);
    cmd.push_back(nxt);
    cmd.push_back(0);
}

void add_if(vector<int>& cmd, int k) { // 32
    int curr = size(cmd);
    add_copy(cmd, 4, curr + 10, k, 2, curr + 4); // curr - curr + 3
    add_copy(cmd, (1 << 12) - 1, curr + 10, k, 3, curr + 8); // curr + 4 - curr + 7
    add_jmp(cmd, curr + 16);
    add_placeholder(cmd);

    if (k == 0) {
        add_jmp(cmd, 12); // 4
        add_jmp(cmd, 8); // 4
        add_jmp(cmd, 8); // 4
        add_jmp(cmd, 12); // 4
    } else {
        add_jmp(cmd, curr - 32); // 4
        add_jmp(cmd, 8); // 4
        add_jmp(cmd, 8); // 4
        add_jmp(cmd, curr - 32); // 4
    }
}

void add_print(vector<int>& cmd, int n) {
    if (n == 0) {
        add_copy(cmd, 5, (1 << 12) - 1, 0, 0, (1 << 12) - 1);
    } else {
        add_copy(cmd, 6, (1 << 12) - 1, 0, 0, (1 << 12) - 1);
    }
}

void solve() {
    int x;
    cin >> x;
    vector<int> cmd;

    // jmp(if_15)
    add_jmp(cmd, 496); // 0 - 3

    // x 0 1 0
    cmd.push_back(x); // 4
    cmd.push_back(0); // 5
    cmd.push_back(1); // 6
    cmd.push_back(0); // 7

    // add print
    add_print(cmd, 0); // 8 - 11
    add_print(cmd, 1); // 12 - 15

    for (int i = 0; i < 16; ++i) {
        add_if(cmd, i); // 16 + 32 * i - 16 + 32 * (i + 1)
    }

    for (int i = 0; i < size(cmd); ++i) {
        print_hex(cmd[i]);
        if (i % 4 == 3) cout << '\n';
    }

//    cerr << size(cmd) << endl;
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    cout.precision(20);

    for (int i = 0; i< 16; ++i) {
        if (i < 10) {
            hex_map[i] = '0'+ i;
        } else {
            hex_map[i] = 'a' + (i - 10);
        }
    }

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
