

#include <iostream>
#include <vector>
#include <set>
#include<algorithm>
typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll n;
	cin >> n;
	vector<ll> v(n), f(n);

	for (ll i = 0; i < n; i++) {
		cin >> v[i];
	}

	vector<pair<ll, ll>> ans;

	for (ll i = 0; i < n; i++) {
		f[i] = i + 1;
	}

	for (ll i = n - 1; i > -1; i--) {
		ll pos = 0;

		for (ll j = 0; j < n; j++) {
			if (f[j] == v[i]) {
				pos = j;
				break;
			}
		}

		for (ll j = pos; j > 0; j--) {
			ans.push_back({ f[j], f[j - 1] });
			swap(f[j], f[j - 1]);
		}
	}

	cout << ans.size() << endl;

	for (ll i = 0; i < ans.size(); i++) {
		cout << ans[i].first << ' ' << ans[i].second << endl;
	}
}
